\ Routines for accessing the CPU space resources for the Sun-2 architecture
hex
03. lconstant FC_MAP
05   constant SMAP_OFFSET
06. lconstant CX_ADDR
0b. lconstant LED_ADDR
0f. lconstant ENABLE_ADDR

0f0f constant CX_MASK

code spacec@ ( l.address function_code -- b.value )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        d0         clr          ( zero high bits )
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e10 ,  0000 , ( movsb  a0@,d0  ( Read the byte )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
        d0 sp -) move
c;
code spacew@ ( l.address function_code -- w.value )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        d0         clr          ( zero high bits )
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e50 ,  0000 , ( movsw  a0@,d0  ( Read the word )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
        d0 sp -) move
c;
code spacel@ ( l.address function_code -- l.value )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e90 ,  0000 , ( movsl  a0@,d0  ( Read the long value)
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
        d0 sp -) move
c;
code spacec! ( b.value l.address function_code -- )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        sp )+   d0 move         ( Get the value to write )
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e10 ,  0800 , ( movsb  d0,a0@  ( Write the byte )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
c;
code spacew! ( w.value l.address function_code -- )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        sp )+   d0 move         ( Get the value to write)
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e50 ,  0800 , ( movsw  d0,a0@  ( Write the word )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
c;
code spacel! ( l.value l.address function_code -- )
        sp )+   a1 move
        sp )+   a0 lmove        ( Get access address )
        sp )+   d0 lmove        ( Get the value)
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e90 ,  0800 , ( movsl  d0,a0@  ( Write the long value)
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
c;

code pgmap@ ( d --- d.pmentry )
        sp )+   d0 lmove        ( Get access address )
  byte  d0      clr
  long  d0 a0   lmove
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
  FC_MAP l#) a1 lea                     ( Get function code in a reg )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e90 ,  0000 , ( movsl  a0@,d0  ( Read page map entry )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
       d0 sp -) lmove
c;

code pgmap! ( d.pmentry d --- )
 long   sp )+ d0 lmove          ( Get access address )
 byte   d0      clr
 long   d0 a0    lmove
        sp )+ d0 lmove          ( Get page map entry to write )
        4e7a ,  1001 , ( movc   dfc,d1  ( Save dest function code )
 FC_MAP l#) a1  lea                     ( Get function code in a reg )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )
        0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
        4e7b ,  1001 , ( movc   d1,dfc  ( Restore dest function code )
c;

( access the segment map - 1 byte )
code smap@ ( d --- smentry )
        sp )+   d0 lmove        ( Get access address )
  byte  SMAP_OFFSET d0 move     ( set low byte to the smap offset )
 normal d0 a0   lmove
        d0      clr
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
  FC_MAP l#) a1 lea                     ( Get function code in a reg )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e10 ,  0000 , ( movsb  a0@,d0  ( Read segment map entry )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
       d0 sp -) move
c;

code smap! ( smapentry l --- )
 long   sp )+ d0 lmove          ( Get access address )
 byte   SMAP_OFFSET # d0 move   ( set low byte to the smap offset )
 normal d0 a0    lmove
        sp )+ d0  move          ( Get segment map entry to write )
        4e7a ,  1001 , ( movc   dfc,d1  ( Save dest function code )
 FC_MAP l#) a1  lea                     ( Get function code in a reg )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )
        0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )
        4e7b ,  1001 , ( movc   d1,dfc  ( Restore dest function code )
  word
c;

code context@ ( --- context-entry )
  long  CX_ADDR l# a0 lmove         ( context register address )
  normal
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
  FC_MAP l#) a1 lea                     ( Get function code in a reg )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e50 ,  0000 , ( movsw  a0@,d0  ( Read context register )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
        CX_MASK l# d0  andw             ( clear unused bits )
        d0 sp -) move
c;

code context! ( context-entry --- )
  long  CX_ADDR l# a0 lmove         ( context register address )
  normal
        sp )+ d0  move                  ( Get context value to write )
        4e7a ,  1001 , ( movc   dfc,d1  ( Save dest function code )
 FC_MAP l#) a1  lea                     ( Get function code in a reg )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )
        0e50 ,  0800 , ( movsw  d0,a0@  ( Write context register )
        4e7b ,  1001 , ( movc   d1,dfc  ( Restore dest function code )
c;

( access the status register - 1 byte )
code enable@ ( --- enable-mask )
  long  ENABLE_ADDR l# a0 move   ( enable register address )
 normal d0 clr                       ( clear out high bits )
        4e7a ,  1000 , ( movc   sfc,d1  ( Save source function code )
  FC_MAP l#) a1 lea                     ( Get function code in a reg )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        0e10 ,  0000 , ( movsb  a0@,d0  ( Read enable register )
        4e7b ,  1000 , ( movc   d1,sfc  ( Restore source function code )
       d0 sp -) move
c;

code enable! ( enable-mask --- )
  long  ENABLE_ADDR l# a0 move   ( enable register address )
 normal sp )+ d0  move                  ( Get enable-mask to write )
        4e7a ,  1001 , ( movc   dfc,d1  ( Save dest function code )
 FC_MAP l#) a1  lea                     ( Get function code in a reg )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )
        0e10 ,  0800 , ( movsb  d0,a0@  ( Write enable register )
        4e7b ,  1001 , ( movc   d1,dfc  ( Restore dest function code )
c;

code led! ( led-mask --- )   ( a 0 bit is led on )
  long  LED_ADDR l# a0 move         ( diagnostic register address )
 normal sp )+ d0  move                  ( Get mask )
        4e7a ,  1001 , ( movc   dfc,d1  ( Save dest function code )
 FC_MAP l#) a1  lea                     ( Get function code in a reg )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )
        0e10 ,  0800 , ( movsb  d0,a0@  ( Write diagnostic register entry )
        4e7b ,  1001 , ( movc   d1,dfc  ( Restore dest function code )
c;

800 constant pagesize
0b  constant pageshift

fc00.0000 lconstant OBMEM
fe40.0000 lconstant OBIO
fe80.0000 lconstant MBMEM
fec0.0000 lconstant MBIO
fe80.0000 lconstant VME24LOW
fec0.0000 lconstant VME24HIGH
fec0.ffe0 lconstant VME16

: page# ( daddr --- page_number )
  7f.ffff land  ( mask off bits beyond 8 Meg - MMU phys addr limit )
  pageshift l>>
;
: addr->pmentry ( address-space l.paddr --- l.page_map_entry )
  page# n->l l+
;
: maprange ( address-space physical_start virtual_top virtual_start --- )
  ldo   l2dup addr->pmentry li pgmap!  pagesize n->l l+
  pagesize n->l l+loop
  ldrop
;
: pgmap? ( virtual-address -- ) ( Prints the physical address )
  pgmap@
  lwsplit   swap   ( high-word low-word )
     th fff and  td 11 <<  ." Physical: " u.   ( high-pagemap-word )
  1c0 and  6 >>  ( page-type )
  dup  0 =  if  ." Onboard Memory"   else
  dup  1 =  if  ." Onboard I/O"      else
  dup  2 =  if  ." Bus 0"            else
  dup  3 =  if  ." Bus 1"            else
  dup  ." Unknown page type " .  then then then then
  cr drop
;

f0.0000 lconstant mbmem

: sun2usembmem
( map the first 3/4 of the mbmem meg )
( to 0.0000 to 4.0000 in external multibus memory )
  MBMEM  0.0000   mbmem c.0000 lbounds   maprange 
;
: map-vme ( -- )
   VME24HIGH e0.0000 ( VME phy addr ) e0.0000 ( virt addr )  ef.0000  maprange
   VME16       .0000 ( VME 16 space ) ef.0000 ( virt addr )  f0.0000  maprange
   OBMEM     00.0000 ( OB phys addr ) f0.0000 ( DMA port )  100.0000  maprange
;

\ Machine-type returns the Machine Type field from the ID PROM
\ (see the Sun architecture manual), or 0 if the ID prom does not
\ appear to be valid, as indicated by the absence of a "1" in the
\ first byte of the ID PROM.
: machine-type ( -- n )
  th 8 3 spacec@ 1 =
  if   th 808 3 spacec@
  else ." The CPU ID Prom is invalid or not installed." cr
       0
  then
;
: sun2multibus? ( -- f )
  machine-type 1 =
;
: sun2vme? ( -- f )
  machine-type 2 =
;

decimal
