.nr PS 9
.nr VS 10
.LP
.nf
.bp
( FCB Offsets and constants )
NEWSTRUCT
 1 FIELD C.DR      8 FIELD C.F1       3 FIELD C.T1
 1 FIELD C.EX      2 FIELD C.S1       1 FIELD C.RC
16 FIELD C.D0      1 FIELD C.CR
 1 FIELD C.R0      1 FIELD C.R1       1 FIELD C.R2
CONSTANT FCBSIZE
128 CONSTANT C.RECSIZE  TH FF80 CONSTANT C.RECMSK
128 CONSTANT C.DEFBUF   92 CONSTANT C.DEFFCB
C.RECSIZE 2 * CONSTANT C.BUFSIZE
 15 CONSTANT C.OPEN     16 CONSTANT C.CLOSE
 20 CONSTANT C.READSEQ  21 CONSTANT C.WRITESEQ
 22 CONSTANT C.MAKE     19 CONSTANT C.DELETE
 23 CONSTANT C.RENAME   26 CONSTANT C.SETDMA
 33 CONSTANT C.READRAN  34 CONSTANT C.WRITERAN
 35 CONSTANT C.SIZE     36 CONSTANT C.SETRAN

( FINDBYTE                                      wmb,83Jun11 )

CODE FINDBYTE ( addr count byte --- [ addr ] f ) ( Z80 only )
( returns addr of 1st occurrence of byte in addr:addr+count-1 )
  B D MOV C E MOV   H POP  L A MOV  B POP  H POP
  C INR C DCR 0=
  IF   B INR B DCR  0=  IF  0 H LXI THEN
  ELSE
       TH B1ED , ( Z80 CPIR ) 0=
       IF   H DCX   H PUSH    1 H LXI
       ELSE 0 H LXI                   THEN
  THEN
  E C MOV  D B MOV  HPUSH JMP
END-CODE



( DRLETTONUM SLIDE SETDR                         wmb,83Jun11 )
: DRLETTONUM ( drive-letter --- drive-number )
  ASCII @ -
;
: SLIDE ( addr cnt addr' --- addr' cnt' )
  1+ DUP 4 ROLL - 3 ROLL SWAP - ;
: SETDR ( fcb addr cnt --- fcb addr' cnt' ) ( scans for )
( x: in argument string and sets the appropriate drive number )
    2DUP ASCII : FINDBYTE ( fcb addr cnt [ addr' ] f )
      IF   DUP 1- C@ DRLETTONUM ( fcb addr cnt addr' dr_num )
           5 PICK C.DR C! ( Dr code )    ( fcb addr cnt addr' )
           SLIDE                         ( fcb addr' cnt' )
      ELSE 0 4 PICK C.DR C!  ( store default drive code in fcb )
      THEN
;


( SETFNAME SETEXT                               wmb-06Sep82)
: SETFNAME ( fcb addr cnt --- fcb addr' cnt' )
  ( set name field in fcb from string at addr )
  DDUP ASCII . FINDBYTE    ( fcb addr cnt [ addr' ] f )
      IF   3 PICK 2DUP - 8 MIN    ( fcb addr cnt addr' addr n )
           6 PICK C.F1 SWAP CMOVE ( fcb addr cnt addr' )
           SLIDE                  ( fcb addr' cnt' )
      ELSE 2DUP 8 MIN             ( fcb addr cnt addr n )
           5 PICK C.F1 SWAP CMOVE ( fcb addr cnt )
           + 0                    ( fcb addr' 0  )
      THEN
;
: SETEXT ( fcb addr cnt --- )
  3 MIN ROT C.T1 SWAP CMOVE
;


.bp
( PARSEFN                                       wmb,83Jun11 )
: PARSEFN ( "addr fcb --- )
  0 OVER C.DR C!            ( "addr fcb )
  DUP    C.F1 8 BLANK       ( "addr fcb )
  DUP    C.T1 3 BLANK       ( "addr fcb )
  SWAP COUNT                ( fcb addr cnt )
  SETDR    SETFNAME   SETEXT
;









( ?PARTIAL-RECORD                               wmb,83Aug29 )
: ?PARTIAL-RECORD ( end start --- endaddr f )
  ( If CP/M record is not full - ^Z's at the end,
    leave address of first ^Z and 1,
    else leave address of end-of-buffer and 0 )
  OVER ( end start test )
  BEGIN  1- DUP C@  26 ( ^Z ) =
     IF   2DUP =  ( keep looking for non-^Z character )
     ELSE 1 THEN  ( found a good character )
  UNTIL  ( end start lastvalid ) 1+
  SWAP DROP  SWAP OVER  ( lastvalid+1  end  lastvalid+1 )
  = NOT
;




( CPM-READ-REC SETREC CPMALIGN )
: SETREC ( d.byteno fcb --- )
    >R    C.RECSIZE M/ SWAP DROP ( recno ) R@ C.R0 !
    0 R>  C.R2 C!
;
: CPM-READ-REC ( addr fcb --- eoff )
    >R                         ( addr )
    C.SETDMA SWAP SYSCALL DROP
    C.READRAN R@ SYSCALL       ( 0 if okay, non-0 if err )
    1 R> C.R0 +!
;
: CPMALIGN ( d.byteno --- d.baseadd )
 ( rounds down to a record boundary )
  SWAP C.RECMSK AND SWAP
;


( UN* CPMFSIZE)
: UN* ( ud un --- ud ) ( leave the double product of ud and un )
 ( overflow is ignored )
  SWAP OVER ( d.l n d.u n ) U* DROP ( d.l n partial.u )
  >R  U*  ( ud.l partial2.u ) R> +
;

: CPMFSIZE ( fcb --- size_in_bytes )
  C.SIZE  OVER  SYSCALL  DROP  ( fcb )
  DUP C.R0 @ SWAP C.R2 C@ ( fcb d.nrecs )
  C.RECSIZE UN*
;





.bp
( CPMFREAD                                      wmb,83Aug29 )
: CPMFREAD ( bflimit bfbase d.byteno fcb --- ... )
  ( --- bflimit bfbase fstart bftop bfend )
  >R   CPMALIGN  ( bflimit bfbase d.aligned ) 2DUP R@ SETREC
  3 PICK  ( bflimit bfbase d.aligned bfbase )
  BEGIN   5 PICK  OVER ( ... current-top limit ) =
    IF   1
    ELSE ( bflimit bfbase d.aligned current-top )
         DUP R@ ( addr fcb) CPM-READ-REC
         IF   1
         ELSE DUP  C.RECSIZE +  SWAP ( ... new-top last-top )
              ?PARTIAL-RECORD ( new-top' f ) THEN  THEN
  UNTIL
  R> DROP
  5 PICK ( bfend is the same as bflimit for this case )
;

( CPM-WRITE-REC ?LAST-RECORD                    wmb,83Aug29 )
: CPM-WRITE-REC ( addr fcb --- eoff )
    >R                         ( addr )
    C.SETDMA SWAP SYSCALL DROP
    C.WRITERAN R@ SYSCALL      ( 0 if okay, non-0 if err )
    1 R> C.R0 +!
;
: ?LAST-RECORD ( bftop bfend --- )
  OVER - 26 ( ^Z ) FILL
;







( CPMFWRITE )
: CPMFWRITE  ( bfend bftop bfbase d.byteno fcb --- bfwritten )
  >R  R@  SETREC  ( bfend bftop bfbase )
  SWAP 3 PICK     ( bfend bfbase  bftop bfend ) ?LAST-RECORD
  BEGIN  2DUP >   ( bfend current-written f )
    IF   DUP R@   ( bfend curr curr fcb )
         CPM-WRITE-REC  ( bfend curr f )
         SWAP C.RECSIZE + SWAP
    ELSE 1        ( end of buffer - stop writing )
    THEN          ( bfend new-current-written f )
  UNTIL           ( bfend new-current-wr )
  SWAP DROP   R> DROP
;




( CPMFCLOSE SETUPFD SETFCB )
: CPMFCLOSE ( fd --- )
  C.CLOSE SWAP FID @ SYSCALL DROP ;
: SETUPFD ( mode fcb buf fd )
  >R DUP C.BUFSIZE + SWAP   R@   USEBUF
  ( mode fcb )  R@ USEFID  ( mode )
  R@ FID @ CPMFSIZE   R@ USESIZE  ( mode )  R@ FMODE !
  ' CPMFREAD  ' CPMFWRITE  ' CPMFCLOSE ' NODEV
  R@  USEROUTINES  (  ) R> DROP
;
: SETFCB ( name fcb --- )
  >R R@ PARSEFN
  0 R@ C.EX C!  0 R@ C.S1 !  0 R@ C.RC C!  0 R@ C.CR C!
  R> DROP   0 SET-DRIVE ( should be elsewhere ? )
;


.bp
( FCB allocation )
#FDS CONSTANT #FCBS
CREATE FCBS  #FCBS FCBSIZE * ALLOT
( Allocation strategy - make as many fcbs as there are fds. )
( Then if the n-th fd is used, alse use the n-th fcb )

: (FIND-FCB ( fd --- fcb )
  FDS - FDSIZE / FCBSIZE * FCBS +
;








( Buffer allocation )
#FDS CONSTANT #FBUFS

CREATE FBUFS  #FBUFS C.BUFSIZE * ALLOT
( Allocation strategy - make as many fbufs as there are fds. )
( Then if the n-th fd is used, alse use the n-th fbuf )

: (FIND-FBUF ( fd --- fbuf )
  FDS - FDSIZE / C.BUFSIZE * FBUFS +
;







( CPMFCREATE CPMFDELETE )
: CPMFDELETE ( name --- f ) ( 1 success, 0 failure )
  FIND-FD DUP >R (FIND-FCB ( name fcb )
  DUP >R SETFCB    C.DELETE R> SYSCALL   255 = NOT ( f )
  R> ( f fd ) INIT-FD ( f )
;
: CPMFCREATE ( name --- f ) ( 1 success, 0 failure )
  >R FIND-FD DUP (FIND-FCB ( fd fcb )
  R> OVER ( fd fcb  name fcb ) SETFCB
  C.MAKE OVER SYSCALL ( f ) TH FF =
  IF    DROP 0 ( fd )
  ELSE  C.CLOSE SWAP SYSCALL DROP 1
  THEN ( fd f )
  SWAP INIT-FD
;


( CPMDISKOPEN )
: CPMDISKOPEN ( mode fd buf fcb name --- fd | 0 )
  OVER ( mode fd buf fcb   name fcb ) SETFCB
  C.OPEN OVER ( mode fd buf fcb   c.open fcb )
  SYSCALL ( mode fd buf fcb  f )
  TH FF =  ( mode fd buf fcb  f )
  IF     DROP DROP DROP ( fd ) INIT-FD 0
  ELSE   ROT >R SWAP R@ ( mode fcb buf fd )
         SETUPFD   R>
  THEN ;







.bp
( PROMPT TTYFREAD  using CP/M BDOS )
: PROMPT ." OK " ;  ( should be vectored )
26 CONSTANT TTYENDCHAR ( ^Z for end-of-file from terminal )
: TTYFREAD  ( bflimit bfbase d.byteno fcb --- ... )
  ( --- bflimit bfbase fstart bftop bfend )
  DROP PROMPT  ( bflimit bfbase d.byteno ) ( <-- is ... )
  3 PICK 5 PICK OVER - 1- 255 MIN ( ... addr size )
  OVER 2- C! ( ... addr )
  10 OVER 2- SYSCALL DROP ( ... addr )
  DUP SWAP 1- C@          ( ... addr nread )
  2DUP + NEWLINE SWAP C!  ( ... addr nread )
  1+                      ( ... addr n-in-buf )
  OVER C@ TTYENDCHAR = IF DROP 0 THEN ( ... addr n-in-buf )
  + ( ... bftop ) 5 PICK ( bflimit bfbase fstart bftop bfend )
;


( UTILS FOR DEVICE NAME SCANNING )
: ", ( string --- ) ( emplace string at here and allot space )
  DUP HERE = NOT
  IF  DUP HERE "COPY THEN
  COUNT 1+ ALLOT DROP
;
: LSHIFT ( value cnt --- value-left-shifted-by-count )
  ?DUP IF   15 AND  0 DO DUP + LOOP   THEN
;
: 0>= 0< 0= ;







( "= )
( compares two strings for equality )
: "= ( str1 str2 --- f ) ( str1 must not be 0 )
  2DUP C@ SWAP C@ =
  IF  COUNT ?DUP ( str1 addr2 [ count2 count2 | 0 ] )
      IF  OVER  + SWAP ( str1 end2 start2 )
          DO    1+ DUP C@ I C@ -
                IF DROP 0 LEAVE THEN
          LOOP
      ELSE 2DROP 1 ( both were null strings ) THEN
  ELSE 2DROP 0 THEN
;





( CP/M device table                             wmb,83Oct02 )
NEWSTRUCT
5 FIELD DEVNAME    2 FIELD DEVCLASS    2 FIELD DEVCODE
CONSTANT DEVENT-SIZE
0 CONSTANT CON  2 CONSTANT RDR  4 CONSTANT PUN  6 CONSTANT LST
( Note: " collects a string of non-blanks and leaves its addr )
CREATE DEVTAB
" CON:	",  CON	,  -1	,	" RDR:	",  RDR	,  -1	,
" PUN:	",  PUN	,  -1	,	" LST:	",  LST	,  -1	,
" TTY:	",  RDR	,   0	,	" CRT:	",  CON	,   1	,
" BAT:	",  CON	,   2	,	" UC1:	",  CON	,   3	,
" PTR:	",  RDR	,   1	,	" UR1:	",  RDR	,   2	,
" UR2:	",  RDR	,   3	,	" PTP:	",  PUN	,   1	,
" UP1:	",  PUN	,   2	,	" UP2:	",  PUN	,   3	,
" LPT:	",  LST	,   2	,	" UL1:	",  LST	,   3	,
HERE CONSTANT DEVTAB-END

.bp
( CONIN CONOUT DEVIN DEVOUT )
: DEVIN  ( bflimit bfbase d.byteno syscall# --- ... )
  ( --- bflimit bfbase fstart bftop bfend )
  0 SWAP SYSCALL ( bflimit bfbase d.byteno char )
  4 PICK C! 3 PICK ( bflimit bfbase d.byteno bfbase )
  1+ ( newbftop is bfbase+1 ) 5 PICK ( newbfend is bflimit )
;
: DEVOUT ( bfend bftop bfbase d.byteno syscall# --- bfwritten )
  >R 2DROP ROT DROP ( bftop bfbase )
  BEGIN 2DUP U> WHILE
     R@ OVER C@ ( bftop bfbase syscall# char )
     SYSCALL DROP ( bftop bfnext )
  1+ REPEAT   ( bftop bftop )  DROP R> DROP
;
: DEVCLOSE ( fd --- ) DROP ;


( READROUTINES WRITEROUTINES SYSCALLNUMS )
: CONIN TTYFREAD ;
: CONOUT DROP 2 DEVOUT ;
: NULLREAD ( bftop<-bfbase, bfend<-bflimit )
  DROP 3 PICK 5 PICK ;
CREATE READRTNS
  ' CONIN  , ' DEVIN , ' NULLREAD , ' NULLREAD ,
CREATE WRITERTNS
  ' CONOUT , ' NODEV , ' DEVOUT   , ' DEVOUT   ,
CREATE SYSCALLNUMS    1 , 3 , 4 , 5 ,

: SYSCALLNUM ( devent --- syscall# )
  DEVCLASS @ SYSCALLNUMS + @ ;




( DEVSETUPFD )
: DEVROUTINES ( mode devent --- mode readroutine writeroutine )
  DEVCLASS @ ( mode devclass )  OVER READ-ONLY =
  IF ['] NULLDEV ELSE DUP WRITERTNS + @ THEN  >R
  OVER WRITE-ONLY = IF DROP ['] NULLREAD ELSE READRTNS + @ THEN
  R> ( mode readroutine writeroutine ) ;
: DEVSETUPFD ( mode fd buf devent --- fd )
  >R  ( mode fd buf )
 ( 2+ is for TTYFREAD which needs to use 0th word for count )
  DUP C.BUFSIZE + SWAP 2+  3 PICK ( mode fd bfend bfbase fd )
  USEBUF ( mode fd )
  R@ SYSCALLNUM OVER USEFID
  -1. 3 PICK USESIZE    R> ( mode fd devent )
  SWAP >R DEVROUTINES   ' DEVCLOSE  ' NODEV
  R@ USEROUTINES  R@ FMODE !  R>
;

( SETIOBYTE                                     wmb,83Oct02 )
HEX
CREATE IOBYTEMASKS  FC , F3 , CF , 3F ,
: SETIOBYTE ( devcode devclass --- )
  OVER 0>=  IF
    DUP IOBYTEMASKS + C@  ( devcode devclass mask )
    3 C@ AND >R  ( devcode devclass )
    LSHIFT R> ( devcode-shifted iobyte ) OR ( newiobyte )
    3 C!
  ELSE DROP DROP THEN
;

DECIMAL




.bp
( FIND-DEVNAME                                  wmb,83Oct02 )
: FIND-DEVNAME ( name --- devent-addr | 0 )
  0 SWAP
  DEVTAB-END DEVTAB
  DO
    DUP I DEVNAME "=
    IF  SWAP DROP I SWAP LEAVE  THEN
  DEVENT-SIZE /LOOP  DROP
;








( CPMDEVOPEN CPMFOPEN                         wmb,83Oct02 )
: CPMDEVOPEN ( mode fd buf name --- fd buf 0   |   fd 1 )
  FIND-DEVNAME DUP ( mode fd buf devent devent )
  IF   DUP DEVCODE @ OVER DEVCLASS @ SETIOBYTE
    ( mode fd buf devent ) DEVSETUPFD ( fd ) 1
  THEN
;
: CPMFOPEN ( name mode --- fd ) ( 0 if failure )
  SWAP >R FIND-FD DUP (FIND-FBUF R@ ( mode fd buf name )
  CPMDEVOPEN ( fail: mode fd buf 0   succeed: fd 1 )
  NOT IF   OVER (FIND-FCB R@ ( mode fd buf fcb name )
           CPMDISKOPEN
  THEN R> DROP
;
