.nr HM .3
.ds LF W. M. Bradley
.ds RF Page % of 14 pages
.ds CH
.TL
Implementations of a Portable File System Interface
.AU
W. M. Bradley
.AI
302 Easy St. #29
Mountain View, CA 94043
(415) 961-1302
.AB
This paper is a companion to the paper entitled "A Portable File
System for Forth".  Herein I present the system dependent interfaces to
two different operating systems:
68000
.UX
and CP/M-80\(dd.
This work is placed in the public domain.
.AE
.FS
\(dd CP/M is a Trademark of Digital Research.
.FE
.br
.LP
.bp
.nr FM .7
.PP
This paper is a companion to the paper entitled "A Portable File
System for Forth".  Herein I present the system dependent interfaces to
two different operating systems: 68000 Unix and CP/M-80.
This work is placed in the public domain.
.PP
The glossary for this code is given in the companion paper.
Any words that I use here that are not mentioned in the glossary
are not defined as part of the file system interface.
They are implementation words and may be headerless if desired.
.PP
This is presented in three parts.  The first part is the CP/M interface.
The second part is the 68000 versions of the code words used in
the file system.  The third part is the Unix interface, which is not
specific to the 68000.
.SH
CP/M Interface
.PP
The first screen defines symbolic names for some CP/M magic numbers
and structure offsets.   The next four screens do a complete parse
of a general CP/M file name of the form "C:FILENAME.EXT", for example.
The following 7 screens define the interface routines to the higher-level
file system code.  Following is buffer allocation code and file creation
and deletion code.  Then there are several screens which implement
device independence, allowing other I/O devices to be accessed as thaough
they were files.  The last screen is the open routine, which pulls all
of this together.
.SH
68000 Code
.PP
The address interpreter is auto-incrementing, indirect threaded, with
16 bit addresses.  D7 is the relocation register -- the base address
of the Forth kernel, which must be a multiple of 64K, is always kept
in the upper half of D7.  The 16-bit offset is moved into the lower
half of D7, yielding a 32-bit absolute address.  Note the general
similarity of the 68000 code to the 8080 code for the same functions
(the 8080 code is in the companion paper).  The similarity results
from the use of structured assembler conditionals.
.SH
Unix Interface
.PP
This code works for 4.2 BSD Unix on a Sun Workstation.  It should
work with only trivial mods on any Unix.  The things which will
change are the system-call numbers.  The implementation and usage
of the word syscall is dependent on the particular implementation
of 68000 Forth, so it's definition is not given here.  Note how
much simpler it is to interface to Unix than to CP/M.  Nearly
all of the Unix code is directly concerned with implementing the
interface to the higher level file system code.  Compare this with
CP/M, where a lot of effort has to be devoted to things like
parsing a file name, making FCB's, figuring out which system call
to use for which device, etc.
