








         Implementations of a Portable File System
                         Interface


                       W. M. Bradley

                       295 Hans Ave.
                  Mountain View, CA 94043
                       (415) 961-1302


                          ABSTRACT

          This paper is a companion to the paper  enti-
     tled "A Portable File System for Forth".  Herein I
     present the system  dependent  interfaces  to  two
     different  operating  systems:  68000  UNIX*   and
     CP/M-80.   This  work  is  placed  in  the  public
     domain.




























_________________________
* UNIX is a trademark of Bell Laboratories.





W. M. Bradley          March 11, 1985     Page 1 of 14 pages








     This paper is a companion  to  the  paper  entitled  "A
Portable  File System for Forth".  Herein I present the sys-
tem dependent interfaces to two different operating systems:
68000  Unix  and CP/M-80.  This work is placed in the public
domain.

     The glossary for this code is given  in  the  companion
paper.   Any words that I use here that are not mentioned in
the glossary are not defined as  part  of  the  file  system
interface.  They are implementation words and may be header-
less if desired.

     This is presented in three parts.  The  first  part  is
the  CP/M  interface.  The second part is the 68000 versions
of the code words used in the file system.  The  third  part
is the Unix interface, which is not specific to the 68000.

CP/M Interface

     The first screen defines symbolic names for  some  CP/M
magic numbers and structure offsets.   The next four screens
do a complete parse of a general CP/M file name of the  form
"C:FILENAME.EXT",  for  example.   The  following  7 screens
define the interface routines to the higher-level file  sys-
tem  code.   Following  is  buffer  allocation code and file
creation and deletion code.  Then there are several  screens
which implement device independence, allowing other I/O dev-
ices to be accessed as thaough they were  files.   The  last
screen  is  the  open  routine,  which  pulls  all  of  this
together.

68000 Code

     The address interpreter is auto-incrementing,  indirect
threaded,  with  16  bit  addresses.   D7  is the relocation
register -- the base address of the Forth kernel, which must
be  a  multiple  of 64K, is always kept in the upper half of
D7.  The 16-bit offset is moved into the lower half  of  D7,
yielding  a 32-bit absolute address.  Note the general simi-
larity of the 68000 code to the 8080 code for the same func-
tions  (the 8080 code is in the companion paper).  The simi-
larity results from the use of structured  assembler  condi-
tionals.

Unix Interface

     This code works for 4.2 BSD Unix on a Sun  Workstation.
It  should  work  with  only  trivial mods on any Unix.  The
things which will change are the system-call  numbers.   The
implementation and usage of the word syscall is dependent on
the particular implementation of 68000 Forth, so it's defin-
ition  is  not  given  here.  Note how much simpler it is to
interface to Unix than to CP/M.  Nearly all of the Unix code
is directly concerned with implementing the interface to the



W. M. Bradley          March 11, 1985     Page 2 of 14 pages








higher level file system  code.   Compare  this  with  CP/M,
where a lot of effort has to be devoted to things like pars-
ing a file name, making FCB's,  figuring  out  which  system
call to use for which device, etc.








       ***********************************************
   The implementation code used to follow.  It has been omitted because
   the code published in the paper is now out-of-date.  The current code
   has been sent in a separate message.











































W. M. Bradley          March 11, 1985     Page 3 of 14 pages


