.nr PS 9
.nr VS 10
.nr HM .3
.nr FM .7
.ds LF W. M. Bradley
.\".ds RF Page % of nn pages
.LP
.nf
.bp
( Buffered I/O  Constants )
-1 CONSTANT EOF
13 CONSTANT CARRET
10 CONSTANT NEWLINE
 8 CONSTANT TAB
BL     256 *  TAB     +  CONSTANT  BLTAB
CARRET 256 *  NEWLINE +  CONSTANT  CRLF

( modes for fmode field )
0  CONSTANT NOT-OPEN
1  CONSTANT READ-ONLY  2 CONSTANT WRITE-ONLY
     READ-ONLY  WRITE-ONLY
OR CONSTANT READ-WRITE




( @C@++ )
( &ptr is the address of a pointer.  Fetch the pointed-to )
( character and post-increment the pointer )

\e\   : @C@++ ( &ptr --- char ) DUP @ C@   1 ROT +! ;
CODE @C@++ ( &ptr --- char )
   H POP   M E MOV  H INX  M D MOV      ( de gets ptr )
           D INX                        ( ptr++ )
           D M MOV  H DCX  E M MOV      ( put back ptr )
           D DCX   XCHG                 ( hl gets orig ptr )
           A XRA   A D MOV  M E MOV
   D PUSH
NEXT JMP END-CODE

( same but pre-decrement the pointer )
\e\   : @--C@ ( &ptr --- char ) -1 OVER +!  ( &ptr ) @ C@ ;

( @C!++ @--C! )
( &ptr is the address of a pointer.  Store the character into )
( the pointed-to location and post-increment the pointer )

\e\   : @C!++ ( char &ptr --- ) SWAP OVER @ C!  1 SWAP +! ;
CODE @C!++ ( char &ptr --- )
   H POP   M E MOV  H INX  M D MOV      ( de gets ptr )
           D INX                        ( ptr++ )
           D M MOV  H DCX  E M MOV      ( put back ptr )
           D DCX   XCHG                 ( hl gets orig ptr )
           D POP  E M MOV      ( store char at orig ptr )
NEXT JMP   END-CODE

( same but pre-decrement the pointer )
\e\   : @--C! ( char &ptr ) -1 OVER +! ( char &ptr ) @ C! ;


( BUFFERING CONSTANTS )
: FIELD ( offset size --- offset+size )
  CREATE OVER , +              ( DOES> @ + ( High-level )
  ;CODE ( fd --- fd+offset )
  D INX  XCHG  M E MOV  H INX  M D MOV     ( offset in DE )
  H POP  D DAD  H PUSH  NEXT JMP  END-CODE
: NEWSTRUCT 0 ;  : W 2 ;   : L 4 ;
NEWSTRUCT
W FIELD BFBASE   W FIELD BFLIMIT
W FIELD BFTOP    W FIELD BFEND     W FIELD BFCURRENT
W FIELD BFDIRTY  W FIELD FMODE     W FIELD FTYPE
L FIELD FSTART   L FIELD FTOP
L FIELD FSIZE    W FIELD FID
W FIELD F.READ   W FIELD F.WRITE   W FIELD F.CLOSE
W FIELD F.IOCTL
CONSTANT FDSIZE

.bp
( TOBUFADDR DBETWEEN )
: TOBUFADDR ( daddr fd --- bufaddr )
  >R R@ FSTART 2@ D- ( doffset ) DROP ( offset ) R> BFBASE @ +
;
: DBETWEEN ( d dupper_limit dlower_limit --- f )
( true if d is >= lower and < upper )
  6 PICK 6 PICK ( d dupper dlower d ) D> NOT ( d dupper f )  >R
  D< R> AND
;








( SYNC FLUSHBUF                                 wmb,83Aug29 )
: SYNC ( fd --- ) ( if current > top, move up top )
  >R R@ BFTOP @ R@ BFCURRENT @ U<
  IF    R@ BFCURRENT @  DUP R@ BFTOP !  ( bftop@ )
        R@ BFBASE @ - 0   R@ FSTART 2@ D+   R@ FTOP 2!
  THEN  R> DROP ;
: FLUSHBUF ( fd --- successf )
  DUP BFDIRTY @ NOT IF EXIT THEN >R  R@ SYNC
  R@ BFEND @  R@ BFTOP @  R@ BFBASE @  R@ FSTART 2@  R@ FID @
  R@ F.WRITE @ EXECUTE  ( bfwrittenend )
  R@ BFTOP @ U<
  IF   1 ABORT" FlushBuf error " ( 0 )   THEN
  R@ FSIZE 2@  R@ FTOP 2@  D<
  IF   R@ FTOP 2@ R@ FSIZE 2! THEN  R@ FSTART 2@ R@ FTOP 2!
  0 R@ BFDIRTY !  R@ BFBASE @ DUP R@ BFTOP ! R@ BFEND !
  R> DROP 1 ;

( FILLBUF                                       wmb,83Aug29 )
: FILLBUF ( daddr fd --- )
  >R
  R@ BFLIMIT @  R@ BFBASE @  2SWAP  R@ FID @
  ( bflimit bfbase daddr fid )  R@ F.READ @ EXECUTE
     ( newbflimit newbfbase newfstart newbftop newbfend )
  R@ BFEND  !  R@ BFTOP   !  R@ FSTART 2!
  R@ BFBASE !  R@ BFLIMIT !
  R@ BFTOP @  R@ BFBASE @  - S->D  ( nvalid )
     R@ FSTART 2@  D+   R@ FTOP 2!
  R> DROP
;





( ALIGNFRAME CLOSE )
: ALIGNFRAME ( daddr fd --- )
  >R
  R@ FLUSHBUF
  IF    R@ FILLBUF
  ELSE  2DROP          THEN
  R> DROP
;
: CLOSE ( fd --- )
  DUP FLUSHBUF DROP
  NOT-OPEN OVER FMODE !
  DUP F.CLOSE @ EXECUTE
;




.bp
( INBUF? FSEEK )
: INBUF? ( daddr fd --- f )
  >R R@ FSTART 2@ D- IF DROP 0
  ELSE R@ BFEND @ R@ BFBASE @ - U< THEN R> DROP ;
: FSEEK ( daddr fd --- eoff )
  >R R@ SYNC
  2DUP R@ INBUF? NOT ( daddr f )
  IF    ( desired byte is not buffered )
      2DUP R@ ALIGNFRAME ( daddr )
  THEN        ( daddr )
  2DUP R@ FTOP 2@ D< NOT ( daddr f ) ( at EOF? )
  IF   DDROP R@ FTOP 2@  R@ TOBUFADDR  R> BFCURRENT ! 1
  ELSE                   R@ TOBUFADDR  R> BFCURRENT ! 0
  THEN ;



( FILE@ FGETC fast get next character )
: FILE@ ( daddr fd --- byte )
  DUP >R  FSEEK ( errf )
  IF   EOF  R> DROP
  ELSE R> BFCURRENT @C@++
  THEN ;
: FGETC ( fd --- byte )
  >R   R@ BFCURRENT @   R@ BFTOP @   <
  ( true flag means desired character is in the buffer )
  IF   R> BFCURRENT @C@++
  ELSE
     R@ FSTART 2@     R@ BFEND @ R@ BFBASE @ -    M+
     R> FILE@
  THEN ;



( FILE! )
: FILE! ( byte daddr fd --- )
  DUP >R FSEEK ( byte eoff )
  ( if daddr is >= eof address, fseek will set up bfcurrent )
  ( at the eof address, so appending to the file will occur )
  R@ BFCURRENT @C!++
  1 R> BFDIRTY !
;









( FPUTC )
: FPUTC ( byte fd --- )
  >R   R@ BFCURRENT @   R@ BFEND @ U<
  IF   R@ BFCURRENT @C!++
       1 R> BFDIRTY !
  ELSE ( desired character is not in the buffer )
       R@ FSTART 2@
          R@ BFCURRENT @ R@ BFBASE @ -
       M+ R> FILE!
  THEN
;






.bp
( USEBUF USEFID USEROUTINES USESIZE             wmb,83Jun05 )
: USEBUF ( bufend bufstart fd --- )
  >R 0. R@ FSTART 2!
  R@ BFBASE !   R@ BFLIMIT !
  R@ BFBASE @  DUP R@ BFCURRENT !  DUP R@ BFEND !  R@ BFTOP !
  0. R@ FTOP 2!
  0  R@ BFDIRTY !    R> DROP ;
: USEFID ( id fd --- )  FID ! ;
: NODEV 1 ABORT" NODEV CALLED " ; ( useful as filler routine )
: NULLDEV ; ( for a routine that doesn't need to do anything )
: USEROUTINES ( read write close ioctl fd --- )
  >R   CFA R@ F.IOCTL !   CFA R@ F.CLOSE !
       CFA R@ F.WRITE !   CFA R@ F.READ  !
  R>  DROP  ;
: USESIZE ( dsize fd --- ) FSIZE 2! ;


( BETTER ASSEMBLER CONDITIONALS )
20 NEWSTACK LSTK
ASSEMBLER DEFINITIONS
: RESOLVE-LEAVES    FORTH
  BEGIN
     LSTK POP ?DUP
  WHILE
     HERE SWAP !
  REPEAT            ASSEMBLER
;
: BEGIN  HERE    0 LSTK FORTH PUSH ASSEMBLER ;
: WHILE  C,   HERE LSTK FORTH PUSH ASSEMBLER 0 , ;
: UNTIL  C, ,  RESOLVE-LEAVES ;
: REPEAT JMP   RESOLVE-LEAVES ;      : IF C, HERE 0 , ;
: THEN HERE SWAP ! ;           : ELSE TH C3 IF SWAP THEN ;
FORTH DEFINITIONS

( SKIPWHITE find next non-white in this buffer )
CODE SKIPWHITE ( endaddr addr --- endaddr addr' )
  H POP  D POP D PUSH    B PUSH
  BEGIN
     L A MOV  E CMP 0=  IF    H A MOV  D CMP 0<>
  WHILE                 THEN
     M A MOV
     BLTAB B LXI   B CMP  0<> IF    C CMP  0<> IF
     CRLF  B LXI   B CMP  0<> IF    C CMP  0=
  WHILE                         THEN THEN THEN
     H INX
  REPEAT
  B POP   H PUSH
  NEXT JMP
END-CODE


( NEXTWORD find first white char in this buffer after addr )
( addr' is 1st white char, addr'' is 1st char not included )
CODE NEXTWORD ( endaddr addr --- addr addr' addr'' )
  H POP   D POP ( H has current addr ) H PUSH  B PUSH
  BEGIN       L A MOV  E CMP 0=  IF    H A MOV  D CMP 0<>
  WHILE                          THEN
     M A MOV
     BLTAB  B LXI    B CMP 0<> WHILE   C CMP 0<> WHILE
     CRLF   B LXI    B CMP 0<> WHILE   C CMP 0<>
  WHILE
     H INX
  REPEAT            B POP  H PUSH
  L A MOV  E CMP 0<> IF  H INX  ELSE
  H A MOV  D CMP 0<> IF  H INX  THEN THEN
  H PUSH        NEXT JMP
END-CODE

.bp
( CCOPY in 8080 code )
( 12.7 sec for 10000 iterations of copy 5 bytes - 2MHz Z80 )
CODE CCOPY ( endaddr startaddr toaddr --- newtoaddr )
  D POP H POP  XTHL  H PUSH
  B H MOV  C L MOV  B POP   XTHL
  ( H start D to B end )
  BEGIN
     L A MOV  C CMP 0=  IF    H A MOV  B CMP 0<>
  WHILE                 THEN
     M A MOV  XCHG   A M MOV
     XCHG H INX  D INX
  REPEAT
  B POP   D PUSH
  NEXT JMP
END-CODE


( CCOPY in high-level Forth )
( 25.1 seconds for 10000 iterations of copy 5 bytes - 2MHz Z80 )
\e\   : CCOPY   ( FromEnd FromStart To --- ToEnd )
\e\     >R SWAP ( FromStart FromEnd )
\e\     OVER -  ( FromStart n )
\e\     R@ OVER ( FromStart n To n )  >R
\e\     SWAP    ( FromStart To n ) CMOVE
\e\     R> R> +
\e\   ;








( COPYIN                                    wmb,83Oct08 )
: UMIN ( u1 u2 --- f )
  2DUP U> IF SWAP THEN DROP ;
: COPYIN ( send scurr fd --- send newscurr )
  >R R@ BFEND @  R@ BFCURRENT @  -  ( send scurr bfremaining )
  OVER +                            ( send scurr sallowed )
  3 PICK UMIN                       ( send scurr snew )
  DUP ROT  R@ BFCURRENT @ ( send snew   snew scurr bfcurrent )
  CCOPY                             ( send snew  newbfcurrent )
  R@ BFCURRENT !   1 R> BFDIRTY !
;






( FPUTS                                         wmb,83Oct08 )

: FPUTS ( addr count fd --- )
  >R OVER + SWAP  ( endaddr startaddr )
  BEGIN  R@ COPYIN  2DUP U>
  WHILE
     R@ SYNC  R@ FTOP 2@  R@  FSEEK ( endaddr curraddr eoff )
     DROP ( endaddr curraddr )
  REPEAT
  2DROP R> DROP
;






.bp
( FILLIT )
( fill buffer and returns the start and end addresses )
( in the newly-filled buffer.  )
: FILLIT ( fd --- endaddr' addr' )
  >R
  R@ FSTART 2@  R@ BFEND @ R@ BFBASE @ -   M+ ( fend )
  R@  FSEEK   ( eoff ) DROP
  R@ BFTOP @  R@ BFCURRENT @
  R> DROP
;







( IGNOREWHITE )
( Skip to the next non-white character, crossing buffer )
( boundaries if necessary )
: IGNOREWHITE ( fd --- bufend addr )
  >R R@ SYNC
  R@ BFTOP @  R@ BFCURRENT @  ( bufend addr )
  BEGIN   SKIPWHITE    ( bufend addr_of_first_non-white )
    DUP R@ BFCURRENT !
    2DUP = IF   2DROP  R@ FILLIT  ( bufend bufcurrent )
                2DUP =
           ELSE 1   THEN
  UNTIL  ( bufend next-addr )
  R> DROP
;



( GETWORD )
20 NEWSTACK WORDPTR
: GETWORD ( fd ToAddr --- ToAddr )
  DUP WORDPTR PUSH   1+ WORDPTR PUSH    >R
  R@ IGNOREWHITE  ( bufend curr_addr )
  BEGIN
      NEXTWORD ( FirstCharAddr LastCharAddr+1 next_in_stream )
      R@ BFCURRENT !
      DUP ROT WORDPTR POP ( Last Last First ToAddr )
      CCOPY               ( Last NewToAddr )
      WORDPTR PUSH        ( Last )  R@ BFCURRENT @ =
      IF   R@ FILLIT  DDUP =    IF DDROP 1 ELSE 0 THEN
      ELSE 1  THEN
  UNTIL  WORDPTR POP WORDPTR TOP@ - 1- ( nchars )
  WORDPTR TOP@ C!   WORDPTR POP
  R> DROP ;

( NEXTCWORD find first delim char in this buffer after addr )
( addr' is first delim, addr'' is first char not included )
CODE NEXTCWORD ( endaddr addr delim --- addr addr' addr'' )
  H POP   L A MOV
  H POP   D POP ( H has current addr ) H PUSH  B PUSH A C MOV
  BEGIN
     L A MOV  E CMP 0=  IF    H A MOV  D CMP 0<>
  WHILE                 THEN
     M A MOV   C CMP 0<>
  WHILE
     H INX
  REPEAT            B POP  H PUSH
  L A MOV  E CMP 0<> IF  H INX  ELSE
  H A MOV  D CMP 0<> IF  H INX  THEN THEN
  H PUSH        NEXT JMP
END-CODE

.bp
( GETCWORD )
: GETCWORD ( char fd ToAddr --- ToAddr )
  DUP WORDPTR PUSH   1+ WORDPTR PUSH    >R ( char ) R@ SYNC
  R@ BFTOP @ R@ BFCURRENT @ ( char bufend curr_addr )
  BEGIN   3 PICK
    NEXTCWORD ( c LastCharAddr+1 next_in_stream )
    R@ BFCURRENT !
    DUP ROT WORDPTR POP ( c Last Last First ToAddr )
    CCOPY               ( c Last NewToAddr )
    WORDPTR PUSH        ( c Last )  R@ BFCURRENT @  =
    IF   R@ FILLIT DDUP = IF DDROP 1 ELSE 0  THEN
    ELSE 1 THEN
  UNTIL
  WORDPTR POP WORDPTR TOP@ - 1- ( c nchars )
  WORDPTR TOP@ C!   DROP   WORDPTR POP
  R> DROP ;

( Descriptor allocation )
8 CONSTANT #FDS
: INIT-FD ( FD --- ) FMODE NOT-OPEN SWAP ! ;
CREATE FDS  #FDS FDSIZE * ALLOT

: INIT-FDS ( --- )
  #FDS FDSIZE * FDS +   FDS
  DO   I INIT-FD FDSIZE /LOOP ;

INIT-FDS

0 FDSIZE * FDS + CONSTANT STDIN
1 FDSIZE * FDS + CONSTANT STDOUT
2 FDSIZE * FDS + CONSTANT STDERR



( descriptor management )
: ?FOPEN ( FD --- F ) FMODE @ NOT-OPEN = NOT ;
: (FIND-FD ( --- FD | 0 ) ( finds a free fd if there is one )
  #FDS FDSIZE * FDS +   FDS  ( end start )
  BEGIN  DDUP >  ( check for end of array )
      IF   DUP ?FOPEN ( END FD F )
      ELSE DROP 0 0   ( END 0 0  )  THEN
  WHILE  FDSIZE +     ( END NEXTFD )
  REPEAT  ( END FD  | END 0 )
  SWAP DROP
;
: FIND-FD ( --- FD ) (FIND-FD ?DUP NOT ABORT" All fds used " ;

