\ FCB Offsets and constants
STRUCT  ( CP/M file control block )
 1 FIELD C.DR      8 FIELD C.F1       3 FIELD C.T1
 1 FIELD C.EX      2 FIELD C.S1       1 FIELD C.RC
16 FIELD C.D0      1 FIELD C.CR
 1 FIELD C.R0      1 FIELD C.R1       1 FIELD C.R2
CONSTANT FCBSIZE
128 CONSTANT C.RECSIZE  TH FF80 CONSTANT C.RECMSK
128 CONSTANT C.DEFBUF   92 CONSTANT C.DEFFCB
C.RECSIZE 2 * BUFSIZE !  7 CONSTANT C.RECSHIFT
 10 CONSTANT C.READCONBUF
 15 CONSTANT C.OPEN     16 CONSTANT C.CLOSE
 20 CONSTANT C.READSEQ  21 CONSTANT C.WRITESEQ
 22 CONSTANT C.MAKE     19 CONSTANT C.DELETE
 23 CONSTANT C.RENAME   26 CONSTANT C.SETDMA
 33 CONSTANT C.READRAN  34 CONSTANT C.WRITERAN
 35 CONSTANT C.SIZE     36 CONSTANT C.SETRAN

\ FINDBYTE                                      wmb,83Jun11
: findbyte ( addr count byte -- [ addr ] flag )
  -rot false -rot  ( byte false addr count )
  bounds
  ?do    ( byte false )
    over i c@ =  if drop i leave then
  loop   ( byte [ false | addr ] )
  nip ?dup
;








\ DRLETTONUM SLIDE SETDR                         wmb,83Jun11
: DRLETTONUM ( drive-letter --- drive-number )
  ASCII @ -
;
: SLIDE ( addr cnt addr' --- addr' cnt' )
  1+ DUP 3 ROLL - 2 ROLL SWAP - ;
: SETDR ( fcb addr cnt --- fcb addr' cnt' ) ( scans for )
( x: in argument string and sets the appropriate drive number )
    2DUP ASCII : FINDBYTE ( fcb addr cnt [ addr' ] f )
      IF   DUP 1- C@ DRLETTONUM ( fcb addr cnt addr' dr_num )
           4 PICK C.DR C! ( Dr code )    ( fcb addr cnt addr' )
           SLIDE                         ( fcb addr' cnt' )
      ELSE 0 3 PICK C.DR C!  ( store default drive code in fcb )
      THEN
;


\ SETFNAME SETEXT                               wmb-06Sep82
: SETFNAME ( fcb addr cnt --- fcb addr' cnt' )
  ( set name field in fcb from string at addr )
  2DUP ASCII . FINDBYTE    ( fcb addr cnt [ addr' ] f )
      IF   2 PICK 2DUP - 8 MIN    ( fcb addr cnt addr' addr n )
           5 PICK C.F1 SWAP CMOVE ( fcb addr cnt addr' )
           SLIDE                  ( fcb addr' cnt' )
      ELSE 2DUP 8 MIN             ( fcb addr cnt addr n )
           4 PICK C.F1 SWAP CMOVE ( fcb addr cnt )
           + 0                    ( fcb addr' 0  )
      THEN
;
: SETEXT ( fcb addr cnt --- )
  3 MIN ROT C.T1 SWAP CMOVE
;


\ PARSEFN                                       wmb,83Jun11
\ Parse a CP/M file name and store it's constituents into
\ the indicated fcb
: PARSEFN ( "addr fcb-addr --- )
  0 OVER C.DR C!            ( "addr fcb )
  DUP    C.F1 8 BLANK       ( "addr fcb )
  DUP    C.T1 3 BLANK       ( "addr fcb )
  SWAP COUNT                ( fcb addr cnt )
  2DUP UPPER
  SETDR    SETFNAME   SETEXT
;






\ ?PARTIAL-RECORD                               wmb,83Aug29
: ?PARTIAL-RECORD ( end start --- endaddr f )
  \ If CP/M record is not full - ^Z's at the end,
  \ leave address of first ^Z and 1,
  \ else leave address of end-of-buffer and 0
  OVER ( end start test )
  BEGIN  1- DUP C@  26 ( ^Z ) =
     IF   2DUP =  ( keep looking for non-^Z character )
     ELSE 1 THEN  ( found a good character )
  UNTIL  ( end start lastvalid ) 1+
  SWAP DROP  SWAP OVER  ( lastvalid+1  end  lastvalid+1 )
  <>
;




\ CPM-READ-REC SETREC CPMALIGN
: SETREC ( d.byteno fcb --- )
    >R    C.RECSHIFT L>> SWAP DROP ( recno ) R@ C.R0 !
    0 R>  C.R2 C!
;
: CPM-READ-REC ( addr fcb --- eoff )
    >R                         ( addr )
    C.SETDMA BDOS DROP
    R@ C.READRAN BDOS       ( 0 if okay, non-0 if err )
    1 R> C.R0 +!
;
: CPMALIGN ( d.byteno --- d.baseadd )
 ( rounds down to a record boundary )
  SWAP C.RECMSK AND SWAP
;


\ CPMFSIZE

: CPMFSIZE ( fcb --- size_in_bytes )
  DUP C.SIZE BDOS  DROP  ( fcb )
  DUP C.R0 @ SWAP C.R2 C@ ( fcb d.nrecs )
  C.RECSHIFT L<<
;










\ CPMFREAD                                      wmb,83Aug29
: CPMFREAD ( bfsize bfbase l.byteno fcb -- #read l.aligned )
  ( --- bflimit bfbase fstart bftop bfend )
  >R   CPMALIGN  ( bfsize bfbase l.aligned ) LDUP R@ SETREC
  L>R  SWAP OVER + OVER  ( bfbase bflimit bfbase )
  BEGIN  2DUP >= ( bfbase bflimit addr flag )
    IF   1
    ELSE ( bfbase bflimit addr )
         DUP R@ ( addr fcb) CPM-READ-REC
         IF   1
         ELSE DUP  C.RECSIZE +  SWAP ( ... new-top last-top )
              ?PARTIAL-RECORD ( new-top' f ) THEN  THEN
  UNTIL
  SWAP -  LR>
  R> DROP
;

\ CPM-WRITE-REC ?LAST-RECORD                    wmb,83Aug29
: CPM-WRITE-REC ( addr fcb --- eoff )
    >R                         ( addr )
    C.SETDMA BDOS DROP
    R@ C.WRITERAN BDOS      ( 0 if okay, non-0 if err )
    1 R> C.R0 +!
;
: ?LAST-RECORD ( bftop bfend --- )
  OVER - 26 ( ^Z ) FILL
;







\ CPMFWRITE
: CPMFWRITE  ( bfend bftop bfbase l.byteno fcb --- bfwritten )
  >R  R@  SETREC  ( bfend bftop bfbase )
  SWAP 2 PICK     ( bfend bfbase  bftop bfend ) ?LAST-RECORD
  BEGIN  2DUP >   ( bfend current-written f )
    IF   DUP R@   ( bfend curr curr fcb )
         CPM-WRITE-REC  ( bfend curr f )
         SWAP C.RECSIZE + SWAP
    ELSE 1        ( end of buffer - stop writing )
    THEN          ( bfend new-current-written f )
  UNTIL           ( bfend new-current-wr )
  SWAP DROP   R> DROP
;




\ CPMFCLOSE SETUPFD SETFCB
: CPMFCLOSE ( fd --- )
  FID @ C.CLOSE BDOS DROP ;
: SETUPFD ( mode fcb buf fd )
  >R DUP BUFSIZE @ + SWAP   R@   USEBUF
  ( mode fcb )  R@ FID !  ( mode )
  R@ FID @ CPMFSIZE   R@ FSIZE L! ( mode )  R@ FMODE !
  ['] CPMFREAD  ['] CPMFWRITE  ['] CPMFCLOSE ['] NODEV
  R@  USEROUTINES  (  ) R> DROP
;
: SETFCB ( name fcb --- )
  >R R@ PARSEFN
  0 R@ C.EX C!  0 R@ C.S1 !  0 R@ C.RC C!  0 R@ C.CR C!
  R> DROP
;


\ FCB allocation
#FDS CONSTANT #FCBS
CREATE FCBS  #FCBS FCBSIZE * ALLOT
( Allocation strategy - make as many fcbs as there are fds. )
( Then if the n-th fd is used, alse use the n-th fcb )

: (FIND-FCB ( fd --- fcb )
  FDS - FDSIZE / FCBSIZE * FCBS +
;








\ MAKE DELETE
: DELETE ( name --- f ) ( 1 success, 0 failure )
  DUP COUNT UPPER FIND-FD DUP >R (FIND-FCB ( name fcb )
  DUP >R SETFCB    R> C.DELETE BDOS   255 <> ( f )
  R> ( f fd ) CLEAR-FD ( f )
;
: MAKE ( name --- f ) ( 1 success, 0 failure )
  DUP COUNT UPPER >R FIND-FD DUP (FIND-FCB ( fd fcb )
  R> OVER ( fd fcb  name fcb ) SETFCB
  DUP C.MAKE BDOS ( f ) 255 =
  IF    DROP 0 ( fd )
  ELSE  C.CLOSE BDOS DROP 1
  THEN ( fd f )
  SWAP CLEAR-FD
;


\ CPMDISKOPEN
: CPMDISKOPEN ( mode fd buf fcb name --- fd | 0 )
  OVER ( mode fd buf fcb   name fcb ) SETFCB
  DUP C.OPEN ( mode fd buf fcb   fcb c.open )
  BDOS ( mode fd buf fcb  f )
  255 =  ( mode fd buf fcb  f )
  IF     DROP DROP DROP ( fd ) CLEAR-FD 0
  ELSE   ROT >R SWAP R@ ( mode fcb buf fd )
         SETUPFD   R>
  THEN ;







