

\ &ptr is the address of a pointer.  fetch the pointed-to
\ character and post-increment the pointer

\ : @c@++ ( &ptr --- char ) dup @ c@   1 rot +! ;
code @c@++ ( &ptr --- char )
   h pop   m e mov  h inx  m d mov      ( de gets ptr )
           d inx                        ( ptr++ )
           d m mov  h dcx  e m mov      ( put back ptr )
           d dcx   xchg                 ( hl gets orig ptr )
           a xra   a d mov  m e mov
   d push
next jmp end-code

\ same but pre-decrement the pointer
: @--c@ ( &ptr --- char ) -1 over +!  ( &ptr ) @ c@ ;

\ &ptr is the address of a pointer.  store the character into
\ the pointed-to location and post-increment the pointer

\ : @c!++ ( char &ptr --- ) swap over @ c!  1 swap +! ;
code @c!++ ( char &ptr --- )
   h pop   m e mov  h inx  m d mov      ( de gets ptr )
           d inx                        ( ptr++ )
           d m mov  h dcx  e m mov      ( put back ptr )
           d dcx   xchg                 ( hl gets orig ptr )
           d pop  e m mov      ( store char at orig ptr )
next jmp   end-code

\ same but pre-decrement the pointer
: @--c! ( char &ptr ) -1 over +! ( char &ptr ) @ c! ;

: field ( offset size --- offset+size )
  create over , +
\  does> @ +
  ;code ( fd --- fd+offset )
    d inx  xchg  m e mov  h inx  m d mov     ( offset in de )
    h pop  d dad  h push  next jmp
end-code

\ Assembler conditionals with multiple loop exits
10 /n * stack: lstk
only forth also assembler definitions
: if c, here 0 , ;
: then here cresolve ;
: else th c3 if swap then ;
: cresolve ( start dest -- )  swap ! ;
: resolve-leaves   [ forth ]
  begin
     lstk pop ?dup
  while
     [ assembler ] then [ forth ]
  repeat            [ assembler ]
;
: begin  here    0 lstk [ forth ] push [ assembler ] ;
: while  if        lstk [ forth ] push [ assembler ] ;
: until  until  resolve-leaves ;
: repeat jmp    resolve-leaves ;
forth definitions

bl     256 *  tab     +  constant  bltab
carret 256 *  newline +  constant  crlf
( skipwhite finds next non-white in this buffer )
code skipwhite ( endaddr addr --- endaddr addr' )
  h pop  d pop d push    b push
  begin
     l a mov  e cmp 0=  if    h a mov  d cmp 0<>
  while                 then
     m a mov  ( ought to just test for a > bl )
     bltab b lxi   b cmp  0<> if    c cmp  0<> if
     crlf  b lxi   b cmp  0<> if    c cmp  0=
  while                         then then then
     h inx
  repeat
  b pop   h push
  next jmp
end-code

( nextword finds first white char in this buffer )
code nextword ( endaddr addr --- addr addr' addr'' )
  h pop   d pop ( h has current addr ) h push  b push
  begin
     l a mov  e cmp 0=  if    h a mov  d cmp 0<>
  while                 then
     m a mov  ( ought to just test for a <= bl )
     bltab  b lxi    b cmp 0<> while   c cmp 0<> while
     crlf   b lxi    b cmp 0<> while   c cmp 0<>
  while
     h inx
  repeat            b pop  h push
  l a mov  e cmp 0<> if  h inx  else
  h a mov  d cmp 0<> if  h inx  then then
  h push        next jmp
end-code
( ccopy in 8080 code )
\ 12.7 sec for 10000 iterations of copy 5 bytes - 2mhz z80
code ccopy ( endaddr startaddr toaddr --- newtoaddr )
  d pop h pop  xthl  h push
  b h mov  c l mov  b pop   xthl
  ( h start d to b end )
  begin
     l a mov  c cmp 0=  if    h a mov  b cmp 0<>
  while                 then
     m a mov  xchg   a m mov
     xchg h inx  d inx
  repeat
  b pop   d push
  next jmp
end-code

( nextcword )
code nextcword ( endaddr addr char --- addr addr' addr'' )
  h pop   l a mov
  h pop   d pop ( h has current addr ) h push  b push a c mov
  begin
     l a mov  e cmp 0=  if    h a mov  d cmp 0<>
  while                 then
     m a mov   c cmp 0<>
  while
     h inx
  repeat            b pop  h push
  l a mov  e cmp 0<> if  h inx  else
  h a mov  d cmp 0<> if  h inx  then then
  h push        next jmp
end-code

