\ Colon definition versions of some file system implementation words.
\ The words in this file are crucial to the performance of the
\ file system.
\ Once the file system is working on your machine, you should
\ rewrite these in assembly language.

: @c@++ ( &ptr -- char ) dup @ c@   1 rot +! ;
: @--c@ ( &ptr -- char ) -1 over +!  ( &ptr ) @ c@ ;
: @c!++ ( char &ptr -- ) swap over @ c!  1 swap +! ;
: @--c! ( char &ptr ) -1 over +! ( char &ptr ) @ c! ;

\ this should be written as a ;code word
: field ( offset size -- offset+size )
  create over , +
  does> @ +
;

\ addr' is the address of the first printable character between
\ addr and endaddr .  Addr' is endaddr if there are none
: skipwhite ( endaddr addr -- endaddr addr' )
  over dup rot   ( endaddr endaddr endaddr startaddr )
  ?do  i c@ bl >  if  drop i leave  then
  loop
;

\ addr' is the address of the first non-printable character between
\ addr and endaddr .  Addr' is endaddr if there are none.
\ addr'' is one more than addr' if a non-printable character is
\ found.  addr'' is endaddr if there are none.
: nextword ( endaddr addr -- addr addr' addr'' )
  swap dup dup 3 pick   ( addr endaddr endaddr  endaddr addr )
  ?do      ( addr endaddr endaddr )
       i c@ bl <=  if  2drop i i 1+ leave  then
  loop
;

\ Bytes from startaddr through endaddr-1 are copied to toaddr.
\ newtoaddr is the address after the last byte in the toaddr range.
: ccopy ( endaddr startaddr toaddr -- newtoaddr )
  -rot dup rot swap ( toaddr startaddr  endaddr startaddr)
  - ( toaddr startaddr len )
  >r over ( toaddr startaddr toaddr )
  r@ cmove r> +
;

\ addr' is the address of the first occurrence of the character char
\ between addr and endaddr .  Addr' is endaddr if there are none.
\ addr'' is one more than addr' if a the character is found.  addr''
\ is endaddr if there are none.
: nextcword ( endaddr addr char -- addr addr' addr'' )
  >r swap dup r> over 4 pick
     ( addr endaddr endaddr char endaddr addr )
  ?do      ( addr endaddr endaddr char )
       dup i c@ =
       if  drop 2drop i i 1+ 0 leave  then
  loop     ( addr addr' addr'' char)
  drop
;
