: usebuf ( bufend bufstart fd --- )
  >r 0. r@ fstart l!
  r@ bfbase !   r@ bflimit !
  r@ bfbase @  dup r@ bfcurrent !  dup r@ bfend !  r@ bftop !
  0. r@ ftop l!
  0  r@ bfdirty !
  r> drop
;
: nodev 1 abort" nodev called " ; ( useful as filler routine )
: nulldev ; ( for a routine that doesn't need to do anything )
: useroutines ( read write close ioctl fd --- )
  >r   r@ fioctl !   r@ fclose !
       r@ fwrite !   r@ fread  !
  r>  drop
;
: tobufaddr ( daddr fd --- bufaddr )
  >r r@ fstart l@ l- ( doffset )
  l->n ( offset ) r> bfbase @ +
;
: sync ( fd --- ) ( if current > top, move up top )
  >r r@ bftop @ r@ bfcurrent @ u<
  if    r@ bfcurrent @  dup r@ bftop !  ( bftop@ )
        r@ bfbase @ - n->l   r@ fstart l@ l+   r@ ftop l!
  then  r> drop
;
: flushbuf ( fd --- successf )
  dup bfdirty @ 0= if exit then >r  r@ sync
  r@ bfend @  r@ bftop @  r@ bfbase @  r@ fstart l@  r@ fid @
    r@ fwrite @ execute  ( bfwrittenend )
  r@ bftop @ u<
  if   1 abort" flushbuf error " ( 0 )   then
  r@ fsize l@  r@ ftop l@  l<
  if   r@ ftop l@ r@ fsize l! then  r@ fstart l@ r@ ftop l!
  0 r@ bfdirty !  r@ bfbase @ dup r@ bftop ! r@ bfend !
  r> drop true
;
: fillbuf ( laddr fd --- )
  lnswap l>r >r  ( ret: laddr fd )
  r@ bflimit @  r@ bfbase @  -              ( bflimit bfsize )
  r@ bfbase @
  r> lr> nlswap >r   ( bflimit bfbase laddr )
  r@ fid @   ( bflimit bfbase daddr fid )  r@ fread @ execute
          ( #read newfstart )
  r@ fstart l!   dup r@ bfbase @  +  r@ bftop   !  ( #read )
( ?? )  r@ bflimit @  r@ bfend !
  n->l   r@ fstart l@   l+   r@ ftop l!
  r> drop
;
: alignframe ( daddr fd --- )
  >r
  r@ flushbuf
  if    r@ fillbuf
  else  ldrop -1.       then
  r> drop
;
: close ( fd --- )
  dup flushbuf drop
  not-open over fmode !
  dup fclose @ execute
;
( inbuf? fseek )
: inbuf? ( laddr fd --- f ) ( true if byte is in buffer )
  >r r@ fstart l@ l-  ( l.position )
  r@ bfend @ r@ bfbase @ - s->l   0.  lwithin
  r> drop
;
: fseek ( laddr fd --- eoff )
  >r r@ sync
  ldup r@ inbuf? 0= ( daddr f )
  if    ( desired byte is not buffered )
      ldup r@ alignframe ( daddr )
  then        ( daddr )
  ldup r@ ftop l@ l>= ( daddr f ) ( at eof? )
  if   ldrop r@ ftop l@  r@ tobufaddr  r> bfcurrent ! true
  else                   r@ tobufaddr  r> bfcurrent ! false
  then
;
: file@ ( daddr fd --- byte )
  dup >r  fseek ( errf )
  if   eof  r> drop
  else r> bfcurrent @c@++
  then
;
: fgetc ( fd --- byte )
  >r   r@ bfcurrent @   r@ bftop @   <
  ( true flag means desired character is in the buffer )
  if   r> bfcurrent @c@++
  else
     r@ fstart l@     r@ bfend @ r@ bfbase @ -   n->l l+
     r> file@
  then
;
: file! ( byte daddr fd --- )
  dup >r fseek ( byte eoff )
  ( if daddr is >= eof address, fseek will set up bfcurrent )
  ( at the eof address, so appending to the file will occur )
  if   1. r@ ftop l+!  1 r@ bftop +! then  ( XXX check this out )
  r@ bfcurrent @c!++
  1 r> bfdirty !
;
: fputc ( byte fd --- )
  >r   r@ bfcurrent @   r@ bfend @ u<
  if   r@ bfcurrent @c!++
       1 r> bfdirty !
  else ( buffer is already full )
       r@ fstart l@
          r@ bfcurrent @ r@ bfbase @ -
       n->l l+ r> file!
  then
;
\ fillit: fill buffer and returns the start and end addresses
\ in the newly-filled buffer.
: fillit ( fd --- endaddr' addr' )
  >r
  r@ fstart l@  r@ bfend @ r@ bfbase @ -   n->l l+ ( fend )
  r@  fseek   ( eoff ) drop
  r@ bftop @  r@ bfcurrent @
  r> drop
;
\ ignorewhite: skip to the next non-white character,
\ crossing buffer boundaries if necessary
: ignorewhite ( fd --- bufend addr )
  >r
  r@ bftop @  r@ bfcurrent @  ( bufend addr )
  begin   skipwhite    ( bufend addr_of_first_non-white )
    dup r@ bfcurrent !
    2dup = if   2drop  r@ fillit  ( bufend bufcurrent )
                2dup =
           else 1   then
  until  ( bufend next-addr )
  r> drop
;
10 /n * stack: wordptr
: getword ( toaddr fd -- toaddr )
  swap
  dup wordptr push   1+ wordptr push    >r
  r@ ignorewhite  ( bufend curr_addr )
  begin
      nextword ( firstcharaddr lastcharaddr+1 next_in_stream )
      r@ bfcurrent !   ( firstcharaddr lastcharaddr+1 )
      dup rot wordptr pop ( last   last first toaddr )
      ccopy               ( last   newtoaddr )
      wordptr push        ( last )  dup r@ bfcurrent @ = ( last )
      if   drop r@ fillit  2dup =  ( end-of-file? )
           if   2drop eof delimiter ! 1   else  0   then
      else c@ delimiter !  1
      then
  until  wordptr pop wordptr top@ - 1- ( nchars )
  wordptr top@ c!   wordptr pop dup  count +  bl swap c!
  r> drop
;
: getcword ( toaddr char fd --- toaddr )
  rot
  dup wordptr push   1+ wordptr push    >r ( char )
  r@ bftop @ r@ bfcurrent @ ( char bufend curr_addr )
  begin   2 pick
    nextcword ( c firstcharaddr lastcharaddr+1 next_in_stream )
    r@ bfcurrent !
    dup rot wordptr pop ( c last last first toaddr )
    ccopy               ( c last newtoaddr )
    wordptr push        ( c last )  r@ bfcurrent @  =
    if   r@ fillit 2dup = if 2drop true else false  then
    else true then
  until
  wordptr pop wordptr top@ - 1- ( c nchars )
  wordptr top@ c!   drop   wordptr pop dup  count +  bl swap c!
  r> drop
;
: skipcword ( char fd --- )
  >r ( char )
  r@ bftop @ r@ bfcurrent @ ( char bufend curr_addr )
  begin   2 pick
    nextcword ( c firstaddr lastcharaddr+1 next_in_stream )
    dup r@ bfcurrent !    ( c first last next)  =
    nip                   ( c end-of-buffer? )
    if   r@ fillit 2dup = if 2drop true else false  then
    else true then
  until   ( c )
  drop
  r> drop
;
: umin ( u1 u2 --- f )
  2dup u> if swap then drop
;
: copyin ( send scurr fd --- send newscurr )
  >r r@ bfend @  r@ bfcurrent @  -  ( send scurr bfremaining )
  over +                            ( send scurr sallowed )
  2 pick umin                       ( send scurr snew )
  dup if   true r@ bfdirty !  then
  dup rot  r@ bfcurrent @ ( send snew   snew scurr bfcurrent )
  ccopy                             ( send snew  newbfcurrent )
  r> bfcurrent !
;
: fputs ( addr count fd --- )
  >r over + swap  ( endaddr startaddr )
  begin  r@ copyin  2dup u>
  while
     r@ sync  r@ ftop l@  r@  fseek ( endaddr curraddr eoff )
     drop ( endaddr curraddr )
  repeat
  2drop r> drop
;
: copyout ( send scurr fd --- send newscurr )
  >r  2dup -                     ( send scurr sremaining )
  r@ bftop @  r@ bfcurrent @  -  ( send scurr srem bfrem )
  min                            ( send scurr sallowed )
  2dup r@ bfcurrent @ rot rot ( send scur sall scur bfcur sall)
  cmove                          ( send scurr sallowed )
  dup  r> bfcurrent +!           ( send scurr sallowed )
  +                              ( send newscurr )
;
: fgets ( addr count fd --- nread )
  dup sync
  >r over + over  ( startaddr endaddr startaddr )
  begin  r@ copyout  2dup u>
  while
     r@ ftop l@  r@  fseek ( startaddr endaddr curraddr eoff )
     if  nip swap - r> drop exit then
  repeat
  nip swap - r> drop
;

\ descriptor allocation
8 constant #fds

0 constant fds
: init-fds
  #fds fdsize * alloc-mem  ( base-address )
  ['] fds >body !
;

: clear-fd ( fd --- ) fmode not-open swap ! ;

: clear-fds ( --- )
  fds    #fds fdsize *   bounds
  do   i clear-fd   fdsize +loop
;

\ buffer allocation

0  constant fbufs
: init-bufs 
  #fds bufsize @ * ( size-of-buffer-area )
  alloc-mem  ( base-address )
  ['] fbufs >body !
;
\ allocation strategy - make as many fbufs as there are fds.
\ then if the n-th fd is used, also use the n-th fbuf
\ This is sort of wasteful, since the standard i/o descriptors really
\ only need small buffers

: (find-fbuf ( fd --- fbuf )
  fds - fdsize / bufsize @ * fbufs +
;

\ descriptor management
: ?fopen ( fd --- f ) fmode @ not-open <> ;
: (find-fd ( --- fd | 0 ) ( finds a free fd if there is one )
  #fds fdsize * fds +   fds  ( end start )
  begin  2dup >  ( check for end of array )
      if   dup ?fopen ( end fd f )
      else drop 0 0   ( end 0 0  )  then
  while  fdsize +     ( end nextfd )
  repeat  ( end fd  | end 0 )
  swap drop
;
: find-fd ( --- fd ) (find-fd ?dup 0= abort" all fds used " ;
