0 #words ! 440 threshold ! 20 granularity !
\ Meta compiler source for the F83 kernel.  Very similar to Perry's
\ 68K F83 for CP/M-68K, but is relocatable on 64K boundaries, runs
\ under Unix, and keeps all variables, including vocabulary threads,
\ in the User area.
0 warning !
forth definitions : ` [compile] " pad "copy pad ;
metaon
meta definitions

initmeta

meta definitions

\ High memory layout:  <- grows down    -> grows up
\ <-par_stk (init-s0) tib-> <-ret_stk (init-r0) user-vars-> (buf1) bufs
\ ( 32-bit )   fb40      ( rts )        fbe0      ( us )     ffe0 
\ ( 16-bit )   fe40      ( rts )        fee0      ( us )     ffe0 

hex
 fffe equ em

  1 equ nscr    100 /n * equ us      a0 equ rts
  em ( 404 ) 1e nscr * - equ buf1 ( *** stacks should be moved )
        buf1 us - equ init-r0
    init-r0 rts - equ init-s0

\ some ascii characters
 0d equ acr      2e equ adot      07 equ bell       8 equ bsin
  8 equ bsout    10 equ dle       0a equ alf       0c equ ffeed

decimal

\ boot up literals                                     5jul82map
hex

\t16 0000 org    0
\t32 1.0000 org  1.0000
   voc-link-t token-t!

assembler

label cld   9000 bra
label wrm   9000 bra

meta
10 allot-t \ reserve some space

meta assembler definitions

:-h rmove ( src dest-reg --- ) ( move with possible relocation )
\t16  >r d7 word move  d7 r> long move
\t32  lmove
;-h
:-h amove ( src dest --- ) ( move an address )
32\   lmove
16\   rmove
;-h

2 constant /w
4 constant /l
32\ /l constant /n 
16\ /w constant /n
:-h /n* /n * ;-h

decimal
meta

\itc create (next
\itc assembler label (next)
\itc word ip )+ w rmove
\itc       w )+ a0 rmove   a0 ) jmp

\ This space leaves room for patching next for stuff like
\ single stepping, etc.
here /w -
 20 allot
  constant next-end

\ assembler macro to assemble a relative branch to next
meta assembler definitions
:-h next forth-h
\itc   [ labels (next) forth-h ] literal
\itc   [ assembler ] bra [ meta ]-h
\dtc   [ assembler ] ip )+ a0 rmove
\dtc   a0 ) jmp
;-h

:-h c; next end-code ;-h

meta definitions
code (lit   ip )+ sp -) move   c;
code (llit  ip )+ sp -) lmove   c;
code (dlit  ip )+ sp -) move  ip )+ sp -) move   c;
code execute   (s cfa -- )
\itc      sp )+ w  amove
\itc word  w )+ a0 rmove  a0 ) jmp
\dtc rts
end-code
code perform (s addr-of-cfa -- )
\itc      sp )+ w  amove
\itc       w )+ w  amove
\itc word  w )+ a0 rmove  a0 ) jmp
\dtc sp )+ a0 move  a0 ) a0 rmove  a0 ) jmp
end-code

code branch
label bran1
 word  ip ) ip adda   c;

code ?branch   sp )+ tst   bran1 beq
label skip     2 ip addq   c;

code (loop
  1 rp ) addq   bran1 bvc   ( increment counter and branch if not done )
  word 3 /n * rp d) rp lea  ( done; remove loop params from stack )
  /w ip addq                ( skip the branch offset )
c;
code (+loop
  sp )+ d0 move   d0 rp ) add   bran1 bvc
  word 3 /n * rp d) rp lea
  /w ip addq
c;
code (do  (s l i -- ) ( f83 )
  sp )+ d0 move   sp )+ d1 move
assembler
label pd0  ( -- r: loop-end-offset l+0x8000 i-l-0x8000 )
  ip rp -) move  ( save the do offset address )
  /w ip addq     ( skip the do offset )
32\   th 8000.0000 l# d1 add  ( 32-bit )
16\   th 8000 # d1 add  ( 16-bit )
  d1 rp -) move   d1 d0 sub    d0 rp -) move
c;
meta
code (?do  (s l i -- ) ( f83 )
  sp )+ d0 move   sp )+ d1 move  normal d0 d1 cmp
  pd0 bne   bran1 bra
end-code
code i  (s -- n )
  rp ) d0 move   /n rp d) d0 add  d0 sp -) move
c;
code j   (s -- n )
  3 /n * rp d) d0 move
  4 /n * rp d) d0 add
  d0 sp -) move
c;
code (leave  (s -- )
label pleave
  2 /n * rp addq    ( get rid of the loop indices )
   rp )+ ip move   word ip ) ip adda normal
c;
code (?leave  (s f -- )
  sp )+ tst   pleave bne
c;

: bounds over + swap ; ( f83 )

assembler label dofalse  normal sp -) clr   next
meta
hex
code digit ( char base -- digit true | char false )
   sp )+ d0 move ( base )   sp ) d1 move ( char )
  byte   30 # d1 sub  dofalse bmi
   0a # d1 cmp   0>=
   if   31 # d1 cmp   dofalse bmi   27 # d1 sub   then
   d0 d1 cmp   dofalse bpl
  normal
   d1 sp ) move
16\   1- # sp -) move
32\   -1. l# sp -) move
c;
decimal

( xx can these be improved by using auto-inc and/or dbra? )
label done assembler  a0 sp -) move  d1 sp -) move  next  meta
code skip  (s addr1 len1 char -- addr2 len2 )
  sp )+ d0 move   sp )+ d1 move  1 d1 addq
  sp )+ a0 amove
  begin  1 d1 subq  0<>
  while
    byte  a0 ) d0 cmp  normal  done bne
    1 a0 addq
  repeat
  done bra
end-code
code scan  (s addr1 len1 char -- addr2 len2 )
  sp )+ d0 move  sp )+ d1 move  1 d1 addq
  sp )+ a0 amove
  begin
    1 d1 subq  0<>
  while
    byte  a0 ) d0 cmp normal done beq
    1 a0 addq
  repeat  done bra
end-code
code hash  (s str-addr voc-ptr -- thread )
  sp )+ d1 amove  sp )+ a0 amove
  1 a0 addq
 byte a0 )+ d0 move  normal
16\  ( for 4 threads ) 3 # d0 and
32\  ( for 4 threads ) 3. l# d0 and
  d0 d0 add
\t32 d0 d0 add
  d0 d1 add
  d1 sp -) move
c;

hex
code (find    (s string link -- cfa true | str false )
  long d2 clr normal
  sp )+ d0 move
\t16  d0 d7 wmove
\t32  d0 d7 move
  begin 0<>
  while
    d7 a2 lmove                  ( save lfa for later )
    d7 a1 lmove                  ( a1 is lfa )
    sp ) a0 amove                ( a0 is string address )
    /link a1 addq                    ( bump to name field )
    byte a0 )+ d0 move           ( get the string length byte )
    a1 )+ d1 move   d1 d2 move   ( get the name field length )
    d0 d1 eor   3f # d1 and      ( mask flag bits )
    0= if
        begin                    ( compare bytes until mismatch )
          a0 )+ d0 move   a1 )+ d1 move   d0 d1 eor 0<>
        until
        7f # d1 and   0=         ( check for match without tag bit )
        normal
        if                       ( if so then word found )
             a1 sp ) move        ( leave cfa )
             byte 40 # d2 and  0<> normal   ( immediate bit set ? )
32\             if     1. l# sp -) move  ( yes, leave 1 )
32\             else  -1. l# sp -) move  ( no, leave -1 )
16\             if     1 # sp -) move  ( yes, leave 1 )
16\             else  -1 # sp -) move  ( no, leave -1 )
             then
             next                ( and return )
        then
    then                         ( no match - try next word )
    d7 a1 move
\t16   a1 ) d7 wmove
\t32   a1 ) d7 lmove
  repeat
  sp -) clr   ( not found, return 0 on top of string )
c;
/link constant /link
: link@ ( addr -- link )
\t16 wa@
\t32 l@
;
: link! ( link addr -- )
\t16 w!
\t32 l!
;
: link, ( link -- )
\t16 w,
\t32 l,
;
: vfind ( str voc-ptr -- )
  over swap hash link@ (find
;
decimal

code enclose   (s addr  delim -- addr  n1 n2 n3 )
   sp )+ d0 move   sp ) a0 amove   d7 d6 lmove
   begin  byte   a0 )+ d1 move   d1 d0 cmp   normal 0<>
   until   1 a0 subq
   a0 d7 lmove   d6 d7 sub    d7 sp -) move
   byte   a0 ) tst   normal 0=
   if   1 d7 addq   d7 sp -) move   1 d7 subq   d7 sp -) move
        next   then
   begin  a0 )+ d1 bmove  0=
     if   d6 a0 suba   1 a0 subq   a0 sp -) move
          a0 sp -) move   next
     then   byte   d0 d1 cmp   normal  0=
   until  d6 a0 suba   1 a0 subq  a0 sp -) move
                       1 a0 addq  a0 sp -) move   c;

decimal
 
code cmove ( from-addr to-addr cnt -- )
  sp )+ d0 move
  sp )+ a0 amove
  sp )+ a1 amove
  here 4 + bra  ( jump to the dbra instruction )
32\   begin
         begin
           byte  a1 )+ a0 )+ move  normal
         d0 dbra
32\     d0 word clr long
32\     1 d0 subq
32\   cs until
c;

code cmove>  ( from to count ) 
  sp )+ d0 move
  sp )+ a0 amove   d0 a0 adda
  sp )+ a1 amove   d0 a1 adda
  here 4 + bra  ( jump to the dbra instruction )
32\   begin
         begin
           byte  a1 -) a0 -) move  normal
         d0 dbra
32\     d0 word clr long
32\     1 d0 subq
32\   cs until
c;

32\ code ul*  ( ul1 ul2 -- lproduct )
32\   long
32\   sp )+ d0 move
32\   0= if   sp ) clr   next   then
32\   sp )+ d1 move
32\   0= if   sp -) clr   next   then
32\ 
32\   d0 d2 wmove
32\   d1 d2 mulu
32\   d0 d3 wmove
32\   d0 swap
32\   word  d0 tst long
32\   0= if
32\         0 d0 moveq
32\   else
32\         d1 d0 mulu
32\   then
32\   d1 swap
32\   word  d1 tst  long
32\   0<> if   d1 d3 mulu   d3 d0 add   then
32\   d0 swap
32\   word  d0 clr  long
32\   d2 d0 add
32\   d0 sp -) move
32\ c;
32\ 
32\ code *  ( l1 l2 -- lproduct )
32\   long
32\   sp )+ d0 move
32\   0= if   sp ) clr   next   then
32\   0< if   d0 neg
32\         sp )+ d1 move
32\         0= if  sp -) clr  next  then
32\         0>= if  ( 0>=  because 0> doesn't exist in the assembler )
32\                d0 d2 wmove  d1 d2 mulu  d0 d3 wmove
32\                d0 swap   d1 d0 mulu   d1 swap   d1 d3 mulu
32\                d3 d0 add  d0 swap   word d0 clr long
32\                d2 d0 add  d0 neg    d0 sp -) move
32\                next
32\         else   d1 neg
32\         then
32\   else
32\     sp )+ d1 move
32\     0= if   sp -) clr   next   then
32\   then
32\   d0 d2 wmove
32\   d1 d2 mulu
32\   d0 d3 wmove
32\   d0 swap
32\   word  d0 tst long
32\   0= if
32\         0 d0 moveq
32\   else
32\         d1 d0 mulu
32\   then
32\   d1 swap
32\   word  d1 tst  long
32\   0<> if   d1 d3 mulu   d3 d0 add   then
32\   d0 swap
32\   word  d0 clr  long
32\   d2 d0 add
32\   d0 sp -) move
32\ c;
32\ : l* * ;

code um*  (s uw1 uw2 -- l )  \ Only works if both operands < 16 bits
   sp )+ d0 move  sp )+ d1 move
   d1 d0 mulu
   d0 sp -) lmove
c;

32\ : u*d um* ;
32\ 

32\ hex
32\ 
32\ label uldiv ( l l -- l.quot )
32\ assembler
32\   long
32\                 d1 tst 
32\         0= if   ( is divisor 0? if so quick trap )
32\                 d1 d0 divu  ( will cause a trap )
32\         then
32\                 d1 d3 move
32\                 d3 word clr long
32\                 d3 swap
32\         0= if   ( if divisor <= 16 bits, do easy divide )
32\                 d0 d2 move
32\                 d2 word clr long
32\                 d2 swap
32\                 d1 d2 cmp
32\           0< if ( if quotient fits in 16 bits, hardware divide is okay )
32\                 d1 d0 divu
32\                 d0 d1 move
32\                 d1 word clr long
32\                 d1 swap
32\                 ffff. l# d0 and
32\                 rts
32\           then  ( end of <= 16-bit quotient case )
32\                 ( do 32 bit / 16 bit divide )
32\                 d1 d2 divu
32\               ( dividend.high/divisor in d2.low )
32\               ( dividend.high%divisor in d2.high )
32\                 d2 d3 move
32\                 d0 d3 word move long
32\                 ( remainder..dividend.low in d3 )
32\                 d1 d3 divu
32\                 d3 d0 move
32\                 d3 d1 move
32\                 d1 word clr long
32\                 d1 swap
32\                 ffff. l# d0 and
32\                 d2 swap
32\                 d2 word clr long
32\                 d2 d0 add
32\                 rts
32\         then ( end of 16-bit divisor case )
32\ 
32\                 0 d4 moveq
32\                 d0 d2 move
32\                 3 # d2 lsr
32\                 d1 d2 cmp
32\ 
32\          u< if ( if quotient < 8, do repeated subtraction )
32\            begin
32\                 1 d4 addq
32\                 d1 d0 sub
32\            u<= until
32\            0<> if
32\                 1 d4 subq
32\                 d1 d0 add
32\            then
32\         d0 d1 move
32\         d4 d0 move
32\         rts
32\     then ( end of repeated subtraction case )
32\ 
32\      ( no special cases to take advantage of ! )
32\      ( however, the quotient has to fit in 16 bits, since the )
32\      ( divisor is more than 16 bits )
32\                 d0 d2 move
32\                 d1 d3 move
32\                 1 d3 subq
32\           begin  ( scale divisor to fit in 16 bits )
32\                 1 d4 addq
32\                 1 # d3 lsr
32\                 ffff. l# d3 cmp
32\           u<= until
32\ 
32\                 1 d3 addq
32\                 ffff. l# d3 cmp
32\           u> if
32\                 1 # d3 lsr
32\                 1 d4 addq
32\           then
32\      ( d3 is scaled divisor )
32\      ( d4 is shift count for scaling )
32\                 d4 d2 lsr
32\      ( d2 is scaled dividend )
32\                 d3 d2 divu
32\                 d1 d3 move
32\                 d1 d5 move
32\      ( unscaled divisor in d3 and d5 )
32\                 d3 swap
32\      ( divisor.upper in d3.lower )
32\      ( divisor.lower in d5.lower )
32\                 d2 d5 mulu
32\                 d2 d3 mulu
32\                 d3 swap
32\                 d3 word clr long
32\                 d3 d5 add
32\      ( quotient * divisor in d5 )
32\                 d5 d0 sub
32\      ( remainder in d0 )
32\                 d0 d1 cmp
32\           <= if ( if remainder >= divisor, tweak the quotient )
32\                 1 d2 addq
32\                 d1 d0 sub
32\           then
32\ 
32\                 d0 d1 move
32\                 d2 d0 move
32\                 ffff. l# d0 and
32\                 rts
32\ meta
32\ decimal
32\ code um/mod ( ul.dividend un.divisor -- un.remainder un.quotient )
32\   long
32\   sp )+ d1 move   ( divisor in d1 )
32\   sp )+ d0 move   ( dividend in d0 )
32\   uldiv bsr
32\   d1 sp -) move   ( remainder in d1 )
32\   d0 sp -) move   ( quotient in d0 )
32\ c;
32\ 
32\ code /mod ( n.dividend n.divisor -- n.rem n.quot )
32\   long
32\   sp )+ d1 move   ( divisor in d1 )
32\   sp )+ d0 move   ( dividend in d0 )
32\   0< if
32\          d0 neg
32\         d1 tst
32\         0< if
32\                 d1 neg
32\                 uldiv bsr
32\                 d1 neg
32\                 d1 sp -) move
32\         else
32\                 d1 sp -) move
32\                 uldiv bsr
32\                 d0 neg
32\                 d1 tst
32\                 0<> if
32\                         1 d0 subq
32\                         d1 sp ) sub ( fix for floored division )
32\                 else
32\                         d1 sp ) move
32\                 then
32\         then
32\   else
32\         d1 tst
32\         0< if
32\                 d1 sp -) move
32\                 d1 neg
32\                 uldiv bsr
32\                 d0 neg
32\                 d1 tst
32\                 0<> if
32\                         1 d0 subq
32\                         d1 sp ) add ( fix for floored division )
32\                 else
32\                         d1 sp ) move
32\                 then
32\         else
32\                 uldiv bsr
32\                 d1 sp -) move
32\         then
32\   then
32\   d0 sp -) move         ( quotient in d0 )
32\ c;

16\ code um/mod (s d1 n1 -- Remainder Quotient )
16\    sp )+ d0 move
16\    long   sp ) d1 move   d0 d1 divu
16\    d1 swap   d1 sp ) move   word
16\ c;
 
code and sp )+ d0 move  d0 sp ) and  c;
code or  sp )+ d0 move  d0 sp ) or   c;
code xor sp )+ d0 move  d0 sp ) eor  c;
code not sp ) notw c;

code +   sp )+ d0 move  d0 sp ) add  c;
code -   sp )+ d0 move  d0 sp ) sub  c;
code negate    sp ) neg   c;
code ?negate   sp )+ tst  0< if  sp ) neg  then   c;
code abs   sp )  tst  0< if sp ) neg  then   c;

16\ code d+        long   sp )+ d0 move   d0 sp ) add   c;
16\ code d-        long   sp )+ d0 move   d0 sp ) sub   c;
16\ code dnegate   long   sp ) neg   c;
16\ code ?dnegate   sp )+ tst  0< if   long   sp ) neg  then   c;
16\ code dabs  sp )  tst  0< if   long   sp ) neg  then   c;
16\ code d2/ (s d -- d/2 )  long sp ) asr  c;

code l+        long   sp )+ d0 move   d0 sp ) add   c;
code l-        long   sp )+ d0 move   d0 sp ) sub   c;
code lnegate   long   sp ) neg   c;
code ?lnegate   sp )+ tst  0< if   long   sp ) neg  then   c;
code labs  sp )  tst  0< if   long   sp ) neg  then   c;
code l2/ (s d -- d/2 )  long sp ) asr  c;

16\ code s->d  sp )+ a0 move   a0 sp -) lmove   c;

code min
   sp )+ d0 move   sp ) d0 cmp
   < if   d0 sp ) move   then   c;
code max
   sp )+ d0 move   sp ) d0 cmp
   > if   d0 sp ) move   then   c;

16\ code dmin   long
16\    sp )+ d0 move   sp ) d0 cmp
16\    < if   d0 sp ) move   then   c;
16\ code dmax    long
16\    sp )+ d0 move   sp ) d0 cmp
16\    > if   d0 sp ) move   then   c;

code lmin   long
   sp )+ d0 move   sp ) d0 cmp
   < if   d0 sp ) move   then   c;
code lmax    long
   sp )+ d0 move   sp ) d0 cmp
   > if   d0 sp ) move   then   c;

code up@   up sp -) move   c;
code sp@   sp sp -) move   c;
code rp@   rp sp -) move   c;
code up! ( new-up --- ) sp )+ up amove c;
code sp!   sp )+ sp amove   c;
code rp!   sp )+ rp amove   c;
code >r    sp )+ rp -) move   c;
code r>    rp )+ sp -) move   c;
code r@    rp )  sp -) move   c;
code exit   rp )+ ip amove   c;
code unnest rp )+ ip amove 
  ( duplicate next here to save a microsecond or so every time )
\itc     ip )+ w  rmove
\itc      w )+ a0 rmove   a0 ) jmp
\dtc   next
end-code
code tuck  (s n1 n2 -- n2 n1 n2 )
  sp )+ d0 move  sp )+ d1 move  d0 sp -) move d1 sp -) move  d0 sp -) move
c;
code nip (s n1 n2 -- n2 ) sp )+ sp ) move  c;
code flip  (s w1 -- w2 )  ( byte swap )
  sp ) d0 move  word 8 # d0 rol  normal d0 sp ) move
c;
code wflip  (s l1 -- l2 )  ( word swap )
  sp ) d0 lmove   d0 swap   d0 sp ) lmove
c;

assembler definitions
:-h leaveflag  ( condition -- )
( macro to assemble code to leave a flag on the stack )
    d0 [ forth ] swap [ assembler ] setif
     d0 extw
32\  d0 extl
     d0 sp -) move
;-h
meta definitions
code 0=  sp )+ tst  0=  leaveflag c;
code 0<> sp )+ tst  0<> leaveflag c;
code 0<  sp )+ tst  0<  leaveflag c;
code 0<= sp )+ tst  0= if -1. l# sp -) move next then
                   0<  leaveflag c;
code 0>  sp )+ tst  0= if sp -) clr next then
                   0>= leaveflag c;
code 0>= sp )+ tst  0>= leaveflag c;

\ the odd sense of the comparisons is because the operands
\ come off the stack in the wrong order.
assembler definitions
:-h compare  normal sp )+ d0 move  sp )+ d0 cmp ;-h
meta definitions

code <   compare >   leaveflag c;
code >   compare <   leaveflag c;
code =   compare 0=  leaveflag c;
code <>  compare 0<> leaveflag c;
code u>  compare u<  leaveflag c;
code u<= compare u>= leaveflag c;
code u<  compare u>  leaveflag c;
code u>= compare u<= leaveflag c;
code >=  compare <=  leaveflag c;
code <=  compare >=  leaveflag c;

16\ code d0=  long  sp )+ tst  0=  leaveflag c;
16\ code d0<> long  sp )+ tst  0<> leaveflag c;
16\ code d0<  long  sp )+ tst  0<  leaveflag c;
16\ code d0<= long  sp )+ tst  0= if word -1 # sp -) move next then
16\                           0<  leaveflag c;
16\ code d0>  long  sp )+ tst  0= if word sp -) clr next then
16\                           0>= leaveflag c;
16\ code d0>= long  sp )+ tst  0>= leaveflag c;
16\ 
16\ assembler definitions
16\ :-h dcompare  [ assembler ] long  sp )+ d0 move  sp )+ d0 cmp ;-h
16\ meta definitions
16\ code d<   dcompare >   leaveflag c;
16\ code d>   dcompare <   leaveflag c;
16\ code d=   dcompare 0=  leaveflag c;
16\ code d<>  dcompare 0<> leaveflag c;
16\ code du>  dcompare u<  leaveflag c;
16\ code du<= dcompare u>= leaveflag c;
16\ code du<  dcompare u>  leaveflag c;
16\ code du>= dcompare u<= leaveflag c;
16\ code d>=  dcompare <=  leaveflag c;
16\ code d<=  dcompare >=  leaveflag c;
16\ 
16\ : dbetween ( test lower upper -- f )
16\   >r >r 2over ( test lower test ) d>
16\   if   r> r> 2drop 2drop false
16\   else  r> r> ( test upper ) d<=
16\   then
16\ ;

code drop  sp )+ d0 move   c;
code dup   sp ) sp -) move    c;
code over  /n sp d) sp -) move    c;
code swap
16\  long   sp ) d0 move   d0 swapw   d0 sp ) move
32\     sp )+ d0 move  sp )+ d1 move
32\     d0 sp -) move  d1 sp -) move
 c;
code rot (s n2 n1 n0 -- n1 n0 n2 )
   sp )+ d1 move   sp )+ d2 move   sp ) d0 move
   d2 sp )  move   d1 sp -) move   d0 sp -) move   c;
code -rot (s n2 n1 n0 -- n0 n2 n1 )
  sp )+ d2 move  sp )+ d0 move  sp ) d1 move
  d2 sp )  move  d1 sp -) move  d0 sp -) move
c;

16\ code 2drop  (s d -- )     sp )+ d0 lmove   c;
16\ code 2dup   (s d -- d d ) sp ) sp -) lmove   c;
16\ code 2over  (s d2 d2 -- d1 d2 d1 )
16\     2 /n * sp d) sp -) lmove   c;
16\ code 2swap     (s d1 d2 -- d2 d1 )
16\   long  sp )+ d0 move   sp ) d1 move   d0 sp ) move
16\         d1 sp -) move   c;

32\ code 2drop  (s d -- )     sp )+ d0 lmove   sp )+ d0 lmove c;
32\ code 2dup   (s d -- d d ) /n sp d) sp -) move /n sp d) sp -) lmove
32\ c;
32\ code 2over  (s d1 d2 d3 d4 -- d1 d2 d3 d4 d1 d2 )
32\     3 /n * sp d) sp -) lmove  3 /n * sp d) sp -) move c;
32\ code 2swap     (s d1 d2 d3 d4 -- d3 d4 d2 d1 )
32\   sp )+ d0 move   sp )+ d1 move   /n sp d) sp -) move  /n sp d) sp -) move
32\   d0 2 /n * sp d) move   d1  3 /n * sp d) move
32\ c;

code pick    (s nm ... n1 n0 k -- nm ... n2 n0 nk )
  sp )+ d0 move   d0 d0 add
32\  d0 d0 add
  0 d0 sp di) sp -) move
c;
: roll    (s nk nk-1 ... n1 n0 k --- nk-1 ... n1 n0 nk )
  >r  r@ pick   sp@ dup  na1+
  r> 1+ /n*
  cmove> drop
;

: 3dup (s a b c -- a b c a b c ) dup 2over rot ;
: 4dup (s a b c d-- a b c d a b c d ) 2over 2over ;
: 2rot (s a b c d e f -- c d e f a b ) 5 roll 5 roll ;
 
code 1+   1 sp ) addq   c;
code 2+   2 sp ) addq   c;
code 1-   1 sp ) subq   c;
code 2-   2 sp ) subq   c;

16\ code 2*     sp ) asl  c;
16\ code 2/     sp ) asr  c;
16\ code u2/    sp ) lsr  c;
16\ code 4*     sp ) asl  sp ) asl  c;
16\ code 8*     sp )+ d0 move  3 # d0 asl  d0 sp -) move  c;

32\ code 2*   sp ) d0 move  1 # d0 asl  d0 sp ) move c;
32\ code 2/   sp ) d0 move  1 # d0 asr  d0 sp ) move c;
32\ code u2/  sp ) d0 move  1 # d0 lsl  d0 sp ) move c;
32\ code 4*   sp ) d0 move  2 # d0 asl  d0 sp ) move  c;
32\ code 8*   sp ) d0 move  3 # d0 asl  d0 sp ) move  c;

code cset (s byte-mask addr -- )
  sp )+ a0 amove   sp )+ d0 move
  byte  d0 a0 ) or  c;
code creset (s byte-mask addr -- )
  sp )+ a0 amove   sp )+ d0 move   d0 notw
  byte   d0 a0 ) and  c;
code ctoggle (s b addr -- )
  sp )+ a0 amove   sp )+ d0 move
  byte   d0 a0 ) eor   c;
code on (s addr -- )
  sp )+ a0 amove
32\  ( true ) -1. l# a0 ) move
16\  ( true ) -1 # a0 ) move
c;
code off (s addr -- )
 sp )+ a0 amove  a0 ) clr c;

code +! (s n addr -- )
  sp )+ a0 amove  a0 ) d0 move sp )+ d0 add  d0 a0 ) move
  c;
code toggle  (s addr byte-mask -- )
  sp )+ d0 move   sp )+ a0 amove
  byte   d0 a0 ) eor   c;

( requires alignment on a word boundary )
code @   sp )+ a0 amove  a0 ) sp -) move c;
code l@   sp )+ a0 amove  a0 ) sp -) lmove c;
code w@  sp )+ a0 amove   d0 clr
32\  word   a0 ) d0 move  normal  d0 sp -) move
16\  a0 ) sp -) move
c;
code <w@  sp )+ a0 amove ( with sign extension )
  word   a0 )+ a0 move  normal  a0 sp -) move    c;
code c@  sp )+ a0 amove   d0 clr
  byte   a0 ) d0 move   normal  d0 sp -) move    c;
( requires alignment on a word boundary )
code !   sp )+ a0 amove  sp )+ a0 ) move c;
( doesn't require alignment on a word boundary )
code w!  sp )+ a0 amove
32\  sp )+ d0 move d0 a0 ) wmove
16\  sp )+ a0 ) move
c;
code c!  sp )+ a0 amove  sp )+ d0 move
  byte   d0 a0 ) move   c;
code 2@  sp )+ a0 amove
  /n a0 d) sp -) move  a0 ) sp -) move  c;
code 2!  sp )+ a0 amove
  sp )+ a0 )+ move  sp )+ a0 )+ move   c;

code fill (s start-addr count char -- )
     sp )+ d1 move
     sp )+ d0 move
     sp )+ a0 amove
     here 4 + bra   ( jump to the dbra instruction )
32\    begin
          begin
            byte  d1 a0 )+ move   normal
          d0 dbra
32\     d0 word clr long
32\     1 d0 subq
32\    cs until
c;
code noop  c;

\t16 code rel    ( addr --- d.addr )
\t16   sp )+ d0 move d0 sp -) rmove
\t16 c;

\t16 code wa->a  ( 16-bit-addr -- 32-bit-addr )
\t16 32\  sp )+ d0 move d0 sp -) rmove
\t16 16\  sp )+ sp -) rmove
\t16 c;

32\ code n->l ( n.unsigned -- l ) c;
32\ code s->l ( n.signed -- l )   c;
32\ code l->n ( l -- n ) c;
32\ code n->a c;
32\ code l->w   d0 clr   sp )+ d1 move   d1 d0 wmove   d0 sp -) move c;
32\ code n->w   d0 clr   sp )+ d1 move   d1 d0 wmove   d0 sp -) move c;
32\ code lwsplit ( l -- w.low w.high )  ( split a long into two words )
32\   sp )+ d0 move  d2 clr
32\   d0 d2 wmove  d2 sp -) move
32\   d0 swap  d0 d2 wmove d2 sp -) move
32\ c;
32\ code wljoin ( w.low w.high -- l )
32\   sp )+ d0 move   d0  sp ) wmove
32\ c;
32\ : lnswap ( l n -- n l ) swap ;
32\ : l0= 0= ;
32\ : ldup dup ;
32\ : nlswap ( n l -- l n ) swap ;
32\ : ldrop drop ;
32\ : l2dup 2dup ;
32\ code lr> ( -- l ) long rp )+ sp -) move  c;
32\ code l>r ( l -- ) long sp )+ rp -) move  c;

\t16 code wa@  ( addr -- address )
\t16   sp )+ a0 amove  a0 ) sp -) rmove
\t16 c;
code ca+  ( addr index -- addr+index*/c )
  sp )+ d0 move d0 sp ) add c;
code wa+  ( addr index -- addr+index*/w )
  sp )+ d0 move   1 # d0 lsl   d0 sp ) add c;
code la+  ( addr index -- addr+index*/l )
  sp )+ d0 move   2 # d0 lsl   d0 sp ) add c;

code na+  ( addr index -- addr+index*/n )
  sp )+ d0 move
32\   2 # d0 lsl
16\   d0 d0 add
  d0 sp ) add
c;

code ca1+ ( addr -- addr+/w ) /c d0 moveq  d0 sp ) add c;
code wa1+ ( addr -- addr+/w ) /w d0 moveq  d0 sp ) add c;
code la1+ ( addr -- addr+/l ) /l d0 moveq  d0 sp ) add c;
code na1+ ( addr -- addr+/n ) /n d0 moveq  d0 sp ) add c;

32\ : l! ! ;
1 constant /c
2 constant /w
4 constant /l
32\ /l constant /n
16\ /w constant /n

code /c* ( n -- n*/c ) c;
code /w* ( n -- n*/w ) sp ) d0 move  d0 sp ) add c;
code /l* ( n -- n*/l ) sp )+ d0 move  2 # d0 lsl  d0 sp -) move c;
code /n* ( n -- n*/n )
  16\   sp ) d0 move  d0 sp ) add
  32\   sp )+ d0 move  2 # d0 lsl  d0 sp -) move
c;

16\ code n->l ( n.unsigned -- l ) 0 # sp -) move c;
16\ code s->l ( n.signed -- l )  sp )+ a0 move   a0 sp -) lmove   c;
16\ code l->n ( l -- n ) sp )+ d0 move  c;
16\ code n->a ( n -- a ) c;
16\ code l->w   sp )+ d0 move  c;
16\ code n->w  c;
16\ code lwsplit ( l -- w.low w.high )  ( split a long into two words )  c;
16\ code wljoin ( w.low w.high -- l )  c;
16\ : lnswap ( l n -- n l ) rot rot ;
16\ : l0= d0= ;
16\ : ldup 2dup ;
16\ : nlswap ( n l -- l n ) rot ;
16\ : ldrop 2drop ;
16\ : l2dup 2over 2over ;

16\ : l! 2! ;

0 constant 0   1 constant 1      2 constant 2
3 constant 3  32 constant bl    64 constant c/l
-1 constant true                 0 constant false

5 equ nvocs
nvocs constant #vocs

us constant user-size
( First 3 user variables are used for multitasking )
0 /n * user tos
1 /n * user entry  ( entry address for this task )
2 /n * user link   ( link to next task )

( next 2 user variables are used for booting )
3 /n * user up0     ( initial up )
4 /n * user #user   ( next unallocated user location )
5 /n * next-user-t !

: ualloc ( size --- new-user-number )
  ( allocates size bytes of user space )
  #user @ user-size >= abort" User area used up!"
  #user @  swap #user +!
;

: nuser ( --namex ) ( like user but allocates space for you )
  /n ualloc user
;
: tuser ( --namex ) ( like user but allocates space for you )
  /token ualloc user
;

nuser sp0         ( initial parameter stack )
nuser rp0         ( initial return stack )
nuser dp          ( dictionary pointer )
nuser 'tib        ( terminal input buffer )

nuser width       ( width of name field )
nuser warning     ( control of warning messages )
nuser fence       ( barrier for forgetting )
tuser voc-link    ( points to newest vocabulary )
\ nuser blk         ( block number to interpret )
nuser >in         ( offset into input stream )
nuser >out        ( number of characters emitted )
nuser scr       ( screen last listed or edited )
nuser offset    ( relative to absolute disk block 0 )
nvocs /n * ualloc-t user context   ( vocabulary searched first )
nuser current   ( vocabulary which gets definitions )
nuser state     ( compilation or interpretation )
nuser base      ( for numeric input and output )
nuser dpl       ( numeric input punctuation )
nuser ptr       ( numeric input punctuation )
nuser fld       ( output field width )
nuser csp       ( for stack position error checking )
nuser r#        ( editing cursor position )
nuser hld       ( points to last character held in pad )
nuser blocks    ( range available for writing )
nuser erasech   ( user's erase character - usually bs or del )
nuser ?interactive ( control over prompts )
nuser numberok  ( status variable for number1 )

nuser  (#out        ( number of characters emitted )
nuser  (#line       ( the number of lines sent so far )

nuser  prior     ( used for dictionary searches )
nuser  last      ( points to nfa of latest definition )
nuser  span      ( number of characters expected )
nuser  #tib      ( number of characters to interpret )

/l ualloc-t user syscall-vec ( long address of system call vector )
( Other user locations are used for deferred words )

vocabulary forth

defer #out
defer #line
defer emit
defer key
defer key?
defer bye
defer cr

decimal
bsout constant bs         bell constant bell
alf   constant linefeed   acr  constant carret
nuser caps

: here   (s -- addr )    dp @   ;
: allot  (s n -- )       dp +!   ;
: ,      (s n -- )       here   /n allot    !   ;
: c,     (s char -- )    here   /c allot   c!   ;
: w,     (s w -- )       here   /w allot   w!   ;
: l,     (s l -- )       here   /l allot   l!   ;
/token constant /token
: token, (s cfa -- )
\t16 w,
\t32 l,
;
: token@ (s addr -- cfa )
\t16 wa@
\t32 l@
;
: token! (s cfa addr -- )
\t16 w!
\t32 l!
;
code ta1+ ( addr -- addr+/token ) /token d0 moveq  d0 sp ) add c;

: space  (s -- )         bl emit   ;
: ?dup   (s n -- [n] n ) dup if   dup   then   ;
: between (s n min max -- f )
   >r over <= swap r> <= and ;
: within (s n1 min max+1 -- f )
   1- between
;

 
: erase      (s addr len -- )   0 fill   ;
: blank      (s addr len -- )   bl fill   ;
: pad        (s -- addr )   here 80 +   ;
: depth      (s -- n )   sp@ sp0 @ swap - /n /   ;

: hex        (s -- )   16 base !  ;
: decimal    (s -- )   10 base !  ;
: (compile  (s cfa -- )  token, ;
: compile   (s -- )   r> dup /token + >r   token@ (compile   ;
: immediate (s -- )   64 last @ ctoggle ;
: align     (s -- )   here 1 and  if  bl c,  then ;
: even      (s n -- n | n+1 )  dup 1 and + ;

: ?comp   state @  0= abort" Compilation Only " ;
: ?exec   state @     abort" Execution Only " ;
: ?pairs  - abort" Conditionals not paired " ;
\ : ?loading     blk  @  0= abort" Use only when Loading" ;
: ?stack
   sp@ sp0 @ swap u<  if   ." Stack Underflow" sp0 @ sp! abort then
   sp@ pad u<   abort" Stack Overflow"   ;
: ?enough   (s n -- )
   depth 1- >   abort" Not enough Parameters" ;

\ For 32-bit tokens, dodoes just happens to be the same as docolon
here-t doestarget !
assembler label dodoes
  normal
  ip rp -) move   sp )+ ip lmove
\itc   w sp -) move
  next
meta
resolves <dodoes>

16\ code *d  (s n1 n2 -- d# )
16\    sp )+ d0 move  sp )+ d0 muls  d0 sp -) lmove c;

\ doesn't work unless the quotient will fit in 16 bits
16\ code m/mod (s d1 n1 -- Remainder Quotient )
16\    sp )+ d1 move
16\    sp )+ d0 lmove   d1 d0 divs
16\     d0 swap  d0 sp -) lmove
16\ c;
16\ code * (s n1 n2 -- n3 ) ( for 16-bit stacks )
16\  sp )+ d0 move   sp )+ d0 muls   d0 sp -) move   c;
16\ code /mod (s n2 n1 -- Remainder Quotient )
16\   long d1 clr  word sp )+ d1 move
16\   sp )+ d0 move long d0 ext d1 d0 divs
16\   d0 swap d0 sp -) move
16\ c;

32\ : m/mod ( l.dividend n.divisor -- n.remainder n.quotient ) /mod ;

: /     (s n1 n2 -- quot )   /mod  nip ;
: mod   (s n1 n2 -- rem )    /mod  drop  ;

16\ : */mod (s n1 n2 n3 -- rem quot ) >r  *d  r>  m/mod  ;
16\ : */    (s n1 n2 n3 -- n1*n2/n3 )     */mod  swap  drop  ;

32\ code */mod (s w1 wmult wdiv -- wrem wquot )
32\    sp )+ d2 move  sp )+ d0 move  sp )+ d1 move
32\    d1 d0 muls   d2 d0 divs
32\    d0 d1 move   d1 swapw  d1 extl   d1 sp -) move
32\    d0 extl  d0 sp -) lmove   next
32\ c;
32\ code */ (s w1 wmult wdiv -- wquot )
32\    sp )+ d2 move  sp )+ d0 move  sp )+ d1 move
32\    d1 d0 muls   d2 d0 divs
32\    d0 extl  d0 sp -) lmove   next
32\ c;

32\ : mu/mod (s d# n1 -- rem d#quot ) ( size dependent )
32\   um/mod
32\ ;

16\ : mu/mod (s d# n1 -- rem d#quot )
16\    >r  0  r@  um/mod  r>  swap  >r  um/mod  r>   ;

code upc (s char -- upper-case-char )
  sp )+ d6 move   byte ascii a # d6 cmpi  >=
  if   ascii z #  d6  cmpi  <=  if  bl # d6 subi   then
  then   normal d6 sp -) move
c;
code lcc (s char -- lower-case-char )
  sp )+ d6 move   byte ascii A # d6 cmpi  >=
  if   ascii Z #  d6  cmpi  <=  if  bl # d6 addi   then
  then   normal d6 sp -) move
c;
: upper  (s addr len -- )
  bounds  ?do i dup c@ upc swap c!  loop
;
: lower  (s addr len -- )
  bounds  ?do i dup c@ lcc swap c!  loop
;
( string compare - case sensitive )
code comp (s addr1 addr2 len -- -1 | 0 | 1 )
  sp )+ d0 move  1 d0 addq
  sp )+ a0 amove  sp )+ a1  amove
  begin  1 d0 subq  0<>
  while  byte   a1 )+ a0 )+ cmpm   normal
32\          0<> if   0<  if    1. l# sp -) move
32\                       else -1. l# sp -) move
16\          0<> if   0<  if    1 # sp -) move
16\                       else -1 # sp -) move
                      then  next
                  then
  repeat  sp -) clr
c;

( string compare - case insensitive )
: caps-comp (s addr addr2 len -- -1 | 0 | 1 )
  1 abort" caps-comp: fix me, I'm not implemented!"
;
: compare caps @ if  caps-comp  else  comp then ;
: spaces   (s n -- )
   0  max  0 ?do  space  loop  ;
: backspaces (s n -- ) 0 ?do bs emit loop ;
: beep  (s -- ) bell emit ;
: (lf  linefeed emit ;
: (cr  carret emit ;
: lf   (s -- )    (lf  #out off  1 #line +! ;
: crlf   (s -- )  (cr lf ;

: tib     (s -- adr )   'tib @  ;
defer query
: (query   (s -- )
  tib 80  expect  span @ #tib !   ( blk off )  >in off  
;

: hold   (s char -- )   -1 hld +!   hld @ c!   ;
: <#     (s -- )     pad  hld  !  ;
: #>     (s l# -- addr len )    ldrop  hld  @  pad  over  -  ;
: sign   (s l# n1 -- l# )  0< if  ascii -  hold  then  ;
: #      (s n1 l# -- n1 l# ) ( for upper case hex output, change 39 to 7 )
  base @ mu/mod           ( n1 nrem l# )
  nlswap                  ( n1 l# nrem )
  9 over < if  39 + then  ( n1 l# nrem' )
  48  +  hold
;
: #s     (s -- )     begin  #  ldup l0=  until  ;

: (u.)  (s u -- a len )   n->l    <# #s #>   ;
: u.    (s u -- )       (u.)   type space   ;
: u.r   (s u len -- )     >r   (u.)   r> over - spaces   type   ;
: (.)   (s n -- a len )   dup abs n->l   <# #s   nlswap sign   #>   ;
: s.    (s n -- )       (.)   type space   ;
: .r    (s n l -- )     >r   (.)   r> over - spaces   type   ;

: (ul.) (s ul -- a l )  <# #s #>   ;
: ul.   (s ul -- )      (ul.)   type space   ;
: ul.r  (s ul l -- )    >r   (ul.)   r> over - spaces   type  ;

: (l.)  (s l -- a l )   tuck labs   <# #s   rot sign  #>   ;
: l.    (s l -- )       (l.)   type space   ;
: l.r   (s l l -- )     >r   (l.)   r> over - spaces   type   ;
16\ : d.    (s l -- )       (l.)   type space   ;
16\ : d.r   (s l l -- )     >r   (l.)   r> over - spaces   type   ;
\ smart print that knows that signed hex numbers are uninteresting
: .     (s n -- ) base @ 10 = if s. else u. then ;
: ?     (s addr -- )    @  . ;

: (.s        (s -- )
  depth 0 ?do  depth i - 1- pick .  loop
;
: .s         (s -- )
   depth 0<
   if   ." Stack Underflow "
   else depth
        if (.s else ." Empty " then
   then
;

: /string   (s addr len n -- addr' len' )
   over min   rot over +   -rot -   ;
: place     (s str-addr len to -- )
   2dup c!   1+ swap move   ;
: (source    (s -- addr len )
\   blk @ ?dup if  block b/buf 
\   else
   tib #tib @
\   then
;
-1 constant eof
defer source
nuser delimiter ( delimiter actually found at end of word )
defer parse
defer parse-word

: (parse-word   (s char -- addr len )
   >r    source >in @         ( addr len n )
   /string                     ( addr' len' )
   over swap r@                ( addr' addr' len' char )
   skip                        ( addr' addr2 len2 )
   over swap r>                ( addr' addr2 addr2 len2 char )
   scan                        ( addr' addr2 addr3 len3 )
   if   dup c@ delimiter !   else   eof delimiter !   then
   2dup                        ( addr' addr2 addr3 addr2 addr3 )
   swap -  >r                  ( addr' addr2 addr3 )
   rot - 1+ >in +! r>         ( addr2 addr3-addr2 )
;

: (parse   (s char -- addr len )
   >r   source >in @ /string   over swap r> scan
   drop over -  dup 1+ >in +!  ;

: 'word   (s -- addr )
   here 20 + ( out of the way of potential link and view fields )
;
: (word    (s char -- addr )
   parse-word  'word place
   'word dup count + bl swap c!   ( stick blank at end )   
;
: .(   (s -- )  ascii ) parse type   ; immediate
: (    (s -- )  ascii ) parse 2drop  ; immediate
: \  delimiter @ linefeed <> if linefeed word drop then  ; immediate

4 constant #threads

: find   (s str -- cfa flag | addr false )
   prior off
   false   ( str found? )
   #vocs 0   ( loop over all vocabularies in search order)
   do   drop
      context i na+ @ dup               ( str voc-ptr voc-ptr )
      if   dup prior @ over prior !  =  ( str voc-ptr voc-ptr=prior? )
         if   drop false                ( str false )
         else   vfind                   ( cfa [ -1 | 1 ] | str false )
                dup ?leave
         then
      then
   loop
;

: canonical ( str-addr -- str-addr )
  caps @ if dup count lower then
;
: defined   (s -- here 0 | cfa [ -1 | 1 ] )
   bl word  canonical  find   ;

defer status (s -- )

: ?missing   (s f -- )
  if   'word count type   true abort"  ?"   then   ;
: literal     (s n -- )
  compile  (lit  , ;  immediate
: lliteral    (s l -- )
   compile  (llit l, ;  immediate
: ascii  (s -- n )
  bl word 1+ c@
  do-literal
; immediate
code ('  ip )+ sp -) rmove  c;
: '   (s -- cfa )   defined 0= ?missing   ;
: ['] (s -- )       ' compile (' token, ; immediate
: [compile]   (s -- )   ' (compile   ; immediate
: ("s  (s -- str-addr )   r> dup count + even >r ;
: ("   (s -- addr len )   r> count 2dup + even >r  ;
: (."  (s -- )            r> count 2dup + even >r   type   ;
: ",   (s addr len -- )
  tuck here place ( len ) 1+ allot align
;
: ,"   (s -- )    ascii " parse ",  ;
: ."   (s --str )   compile (."   ,"   ;   immediate
: "    (s --str str-addr )  ascii " parse pad place  pad  ;
: ["]  (s Compile-time: --str ) (s Run-time: -- str-addr )
  compile ("s    ,"
;   immediate
: ""   (s --namex str-addr )  bl parse-word pad place  pad ;
: [""] (s Compile-time: --namex ) (s Run-time: -- str-addr )
  compile ("s  bl parse-word  ",
;   immediate
\ ",  --> given addr\len, emplace the string at here and allot space
\ ,"  --> accept a "-terminated string and emplace it.
\ "   --> accept a "-terminated string and leave it's address on the stack
\ ["] --> accept a "-terminated string and emplace it.
\         At run time, leave it's address on the stack.
\ ""  --> accept a blank delimited string and leave it's address on the stac
\ [""]--> accept a blank delimited string and emplace it.
\         At run time, leave it's address on the stac

: trim   (s faddr voc-addr -- )
   #threads 0
   do   2dup     link@       ( faddr thread  faddr link )
      begin
        2dup u<=               ( faddr thread  faddr link   f )
      while      link@       ( faddr thread  faddr link' )
      repeat
      nip over link!              ( faddr thread )
   /link +   loop
   2drop
;

\t16 origin-t constant origin-rel
\t16 : origin origin-rel rel ;
\t32 origin-t constant origin

: (forget   (s cfa -- )
\  >view 
   >link
   dup fence @ u< abort" below fence"  ( addr )
 ( first forget any vocabularies defined since the word to forget )

   dup voc-link
   begin   link@ 2dup  u>= until     ( addr voc-link-addr )
   dup voc-link link! nip             ( addr voc-link-addr )

 ( now, for all remaining vocabularies, forget words defined )
 ( since the word to forget )
   begin
     dup origin <>  ( any more vocabularies? )
   while
     2dup /n - ( addr voc-link-addr addr voc-pfa )
     >user     ( addr voc-link-addr addr voc-threads-addr )
     trim      ( addr voc-link-addr )
     link@        ( addr new-voc-link-addr )
   repeat
   drop   dp !
;

: forget   (s -- )
   bl word   canonical
   current @ vfind 0= ?missing
   (forget
;
defer where
defer ?error
: (?error   (s adr len f -- )
   if  >r >r   sp0 @ sp!   ( printing off )
\       blk @ if  >in @ blk @ where  then
       r> r> error-output space type space  where restore-output abort
   else  2drop
   then
;
: (abort"   (s f -- )
   r@ count rot ?error   r> count + even >r
;
: abort"   (s -- )
    compile (abort"  ," ;   immediate

: ?condition   (s f -- )
   not abort" Conditionals Wrong"   ;
: >mark      (s -- addr )    here 0 w,   ;
: >resolve   (s addr -- )    here over - ( addr offset ) swap w!   ;
: <mark      (s -- addr )    here    ;
: <resolve   (s addr -- )    here - w,   ;

: ?>mark      (s -- f addr )   true >mark   ;
: ?>resolve   (s f addr -- )   swap ?condition >resolve  ;
: ?<mark      (s -- f addr )   true   <mark   ;
: ?<resolve   (s f addr -- )   swap ?condition <resolve  ;

: leave   compile (leave                           ; immediate
: ?leave  compile (?leave                          ; immediate

: begin   ?<mark                                   ; immediate
: then    ?>resolve                                ; immediate
: do      compile (do    ?>mark                    ; immediate
: ?do     compile (?do   ?>mark                    ; immediate
: loop
    compile (loop   2dup 2+ ?<resolve ?>resolve    ; immediate
: +loop
    compile (+loop  2dup 2+ ?<resolve ?>resolve    ; immediate
: until   compile ?branch    ?<resolve             ; immediate
: again   compile  branch    ?<resolve             ; immediate
: repeat  2swap [compile] again   [compile] then   ; immediate
: if      compile  ?branch  ?>mark                 ; immediate
: else    compile  branch ?>mark  2swap ?>resolve  ; immediate
: while   [compile] if                             ; immediate

: ,view  (s -- ) ( 0 , ) ;
: "header (s str -- )
   warning @                                  ( str f )
   if dup find                                ( str [ cfa 1 | str 0 ] )
     if   ( str cfa ) over count type ."  isn't Unique " cr  then
     drop 
   then                                       ( str )
   align   ,view here 0 link, ( temp link field )  ( str lfa )
   here last !   ( remember nfa )
   swap ( str ) count here place
   here                                      ( lfa nfa )
   current @ hash dup link@                  ( lfa tha prev)
   here /link - rot link! ( hook to thread ) ( lfa prev )
   swap link!             ( resolve link field )
   here  dup  c@  width  @    min  1+  allot   align
   128 swap cset   128 here 1- cset   ( delimiter bits )
;
hex
: "create ( str -- )
  "header
\itc   0 w,
\dtc   4eb9 w, 0 l, \ [ assembler ] 0 l#) jsr  [ meta ]
  ;code
\itc     normal  w sp -) move
c;
resolves <variable>
decimal
: dump cr bounds ?do i w@ 8 u.r /w +loop ;
: (create   (s -- )
  bl word canonical "create
;

\ Extensible Layer            Defining Words          07SEP83HHL
: !csp   (s -- )   sp@ csp !   ;
: ?csp   (s -- )   sp@ csp @ <>   abort" Stack Changed "  ;
: hide      (s -- )
   last @   dup n>link link@    swap current @ hash link!   ;
: reveal   (s -- )
   last @   dup n>link       swap current @ hash link!   ;
: (;uses      (s -- )   r> @  last @ name>
\itc   w!
\dtc   2+ ( skip over jsr opcode) l!  ( store absolute address)
;
\ vocabulary assembler
: ;uses       (s -- )   ?csp   compile  (;uses
   [compile] [   reveal   ( assembler ) noop  ; immediate
: (;code     (s -- )   r>    last @ name>  ( code-address cfa-of-latest-word)
\itc  w!
\dtc  2+ ( skip over jsr opcode) l!  ( store absolute address)
;
: ;code       (s -- )   ?csp   compile  (;code
    [compile] [   reveal   ( assembler ) noop  ; immediate

hex
\ does> is implemented with a relative branch-to-subroutine to dodoes.
\ The range of a relative branch on the 68000 is only 32K bytes, so
\ a new copy of dodoes needs to be made when the dictionary size approaches
\ 32k.  The address of the new copy should be stored in "dodoesaddr" so
\ that does> will then generate bsr's to the new copy

tuser dodoesaddr

: does>   (s -- )   compile (;code
  ( when does> executes, it compiles a bsr to dodoes )
\t16  6100 w, ( bsr ) dodoesaddr token@ here - w,
\t32  4eb9 w, ( jsr ) dodoesaddr token@ token,
; immediate
decimal

\ extensible layer            defining words          27sep83map

: :   (s -- )
   !csp   current @ context !   create hide    ]
     ;code
      normal
\itc     ip rp -) move   w ip lmove
\itc ( duplicate next here to save a microsecond or so every time )
\itc     ip )+ w  rmove
\itc      w )+ a0 rmove   a0 ) jmp
\dtc  ip  rp -) move   sp )+  ip move   next
end-code  immediate
resolves <colon>
: ;   (s -- )
   ?csp   compile unnest   reveal   [compile] [
;   immediate

defer word

code traverse (s addr direction -- addr' )
  sp )+ d0 move  sp )+ a0 amove  d0 a0 adda
  begin
     \ a0 ) 7 # btst   0=
      7 # a0 ) btst 0=
  while
     d0 a0 adda
  repeat
  a0 sp -) move
c;
: forth-83   (s -- )
  ." This implementation is nearly FORTH-83 standard," cr
  ." but it lacks mass storage words and uses 32 bit stacks." cr
; immediate
: .version   (s -- )
  ." 3.0.0"
;
: n>link     /link -   ;
: l>name     /link +   ;
: name>      1 traverse   1+   ;
: link>      l>name   name>   ;
: body>
\itc      /w -
\dtc      6 -
;
: >body
\itc      /w +
\dtc  6 +    ( jsr + offset )
\dtc \ xxx should be smarter.  What about 16-bit branch offsets, etc.?
;
: >name      1- -1 traverse   ;
: >link      >name   n>link   ;
\ : >view      >link   /w -   ; ( No view fields in this forth )
\ : view>      /w +   link>   ;

hex
: long? (s -- f ) dpl @ 1+ 0<> ;
: convert (s l addr --- l' addr' )
  ( convert 32-bit number, leaving unconv. addr. *)
   begin  1+  dup  >r     ( l addr' ) ( r: addr+1 )
      c@  base  @  digit  ( l digit )
   while    >r  base @ ul*  r>  l+
      long?  if  1  dpl  +!  then  r>
   repeat  drop  r>
;
: number? ( str --- d' flag )
   0. nlswap                       ( 0. addr )
   dup 1+ c@ ascii - =  dup  >r  - ( 0. baddr-of-first-numeric ) ( r: -sign?)
   -1 dpl !
   begin  convert  dup c@ dup ascii - = swap  ascii . = or
   while  0 dpl ! 
   repeat               ( l. addr' )
    ( negate if there was a minus sign )
   lnswap  r>
   if   lnegate  then
    ( success if the first unconverted character was a blank )
   nlswap c@ bl =          ( d. f )
;
: (number (s addr -- d# )
  number? 0= ?missing ;

defer number

decimal

\ : count      (s addr --- addr+1 len )
\    dup 1+   swap c@   ;
code count     (s addr --- addr+1 len )
  sp )+ a0 amove
  d0 clr
  a0 )+ d0 bmove
  a0 sp -) move
  d0 sp -) move
c;
: length      (s addr --- addr+2 len )
   dup 2+   swap @   ;
: move ( from to len -- )
  -rot  2dup u< if  rot cmove>   else  rot  cmove then ;
: type       (s addr len -- )
   0 ?do   dup c@ emit   1+ loop   drop   ;
: -trailing  (s addr len -- addr len' )
   dup 0 do   2dup + 1- c@   bl <> ?leave  1-    loop   ;

defer expect
\ Version which assumes that somebody else has done the editing
: (expect   ( addr len --- )
   swap 0 >r begin
      over r@ =    ( end of buffer ? )
       if  + 0 swap c! r> span ! exit then
      key dup 10 =     ( newline ? )
       if    drop r> dup span !      ( maxlen addr current-len )
             + 0 swap c! ( put a null at the end )
             drop #out off 1 #line +! exit          ( discard the newline )
       else  over r@ + c!      ( maxlen addr )  ( store character )
             r> 1+ >r      ( bump pointer )
       then
   again
;

defer create

: control  (s -- n )
  bl word 1+ c@  bl 1- and
  do-literal
; immediate

\ : complain
\    here count type   ."  not recognized "
\ ;
: (where
 input-from-file?
 if  state @
    if   ." Compiling "
    else ." Latest word was "
    then
    last @ .id cr
  then
;
: lose ." Undefined word encountered " cr abort ;
hex

defer error-output
defer restore-output
defer literal?      ( str -- str false  |  literal true )

defer do-defined    ( cfa -1 | cfa 1  -- ?? )
defer do-literal    ( literal -- ?? )
defer do-undefined  ( str -- )

: "compile ( str -- )
  canonical find ( str 0  |   cfa -1   |   cfa 1 )
  dup
  if   do-defined    (   )
  else drop          ( str )
       literal?      ( str false | ?? true )
       if    do-literal        ( ?? )
       else  do-undefined      (    )
       then
  then
;
: interpret-do-defined  ( cfa -1 | cfa 1 -- ?? )
  drop execute
;
: compile-do-defined    ( cfa -1 | cfa 1 -- )
  0> if   execute   ( if immediate )
     else (compile  ( if not immediate )
     then
;
: (literal?  ( str -- str false  | literal true )
  >r r@ number?   ( l f )
  if    r> drop  true
  else  drop r> false
  then
;
: interpret-do-literal ( l -- l | n )
16\  long? 0= if drop then
;
: compile-do-literal ( l -- )
  long? if [compile] lliteral else [compile] literal then
;  
: interpret-do-undefined ( str -- )
  error-output
    count type ."  ?" cr
  restore-output
  quit
;
: compile-do-undefined   ( str -- )
  error-output
    count type ."  ?"  where
  restore-output
  compile lose
;
: [
  ['] (literal?              ['] literal?     (is
  ['] interpret-do-defined   ['] do-defined   (is
  ['] interpret-do-literal   ['] do-literal   (is
  ['] interpret-do-undefined ['] do-undefined (is
  state off
; immediate
: ]
  ['] (literal?              ['] literal?     (is
  ['] compile-do-defined     ['] do-defined   (is
  ['] compile-do-literal     ['] do-literal   (is
  ['] compile-do-undefined   ['] do-undefined (is
  state on
;
: more? ( str -- str f )
  dup c@
;
: (interpret  (s -- )
  begin   ?stack
          bl word   ( str )
          more?     ( str f )
  while
          "compile
  repeat
  drop
;
defer interpret

hex
: .id     (s nfa -- )
   dup 1+ dup c@ rot c@ ( length field )
   1f and 0
   ?do
      dup 7f and emit
      80 and  ( if the end has been reached, fill out with _ to length )
      if 0df ( _ with 80 bit set ) else 1+ dup c@ then
   loop
   2drop space
;

\ Extensible Layer            Defining Words          16Oct83map
: recursive (s -- )   reveal ;   immediate

: user
     constant   ;code
\itc     w ) d0    move     \ 12
\itc     up  d0    add      \ 8
\itc     d0  sp -) move     \ 12  --> 32
\dtc     sp )+ a0    move   \ 12
\dtc     a0 )  d0    move   \ 12
\dtc     up    d0    add    \ 8
\dtc     d0    sp -) move   \ 12  --> 44
c;
resolves <user>

: >user ( pfa --- addr-of-user-var ) @  up@ + ;
: constant   (s n -- )
   create ,   ;code
\itc  w  )  sp -) move   \ 20  --> 20
\dtc  sp )+ a0    move   \ 12
\dtc  a0 )  sp -) move   \ 20  --> 32
c;
resolves <constant>

: variable  (s -- )
   create 0 ,
;
: wvariable (s -- )
  create 0 w,
;

\ defer (is is
\ Also known as execution vectors.
\ Usage:   defer bar
\ : foo ." Hello" ;  ' foo is bar
\ Alternatively: ' foo ' bar (is 

\ Since the execution of an execution vector doesn't leave around
\ information about which deferred word was used, we have to try
\ to find it by looking on the return stack
\ if the vector was EXECUTE'd, we don't know what it was.  This
\ will be the case if the deferred word was interpreted from the
\ input stream

: crash ( -- ) ( unitialized execution vector routine )
  r@ /token - token@         ( use the return stack to see who called us )
  dup ['] execute =
  if   'word count type space else   >name .id  then
  ." <--deferred word not initialized" abort
;

\ Allocates a user area location to hold the vector
: defer (s -- )
  create here /n ualloc ,                ( allocate a user location )
  >user  ['] crash   swap !   ( initialize to crash )
  ;code ( -- )
\itc    ( w has the pfa which contains the user # for the vector )
\itc    w ) d0 move                  ( get user number )
\itc    0 d0 up di) w rmove    ( get cfa from user area )
\itc           w )+ a0 rmove   a0 ) jmp
\dtc  ( addr-of-user-number-of-word-to-execute )
\dtc  sp )+ a0 move
\dtc  a0 )  d0 move
\dtc  0 d0 up di)l a0 rmove
\dtc  a0 ) jmp
end-code
\ or in high-level, does> >user @ execute ;
resolves <defer>
: (is ( target-cfa vector-cfa --- ) >body >user token! ;
: is  ( target-cfa --vector-name ) ' (is ;
hex

\ makes a sealed vocabulary with the top-of-voc pointer in user area
\ parameter field of vocabularies contains:
\ user-#-of-voc-pointer ,  voc-link ,
: voc-link, ( -- )  ( links this vocabulary to the chain )
  here   voc-link token@  token,   voc-link token!
;
: vocabulary ( --namex )
  create 
    ( make threads )  #threads /link *   ( size-of-threads )
    dup  ualloc   dup ( user#, ) ,       ( size user# )
    up@ +   swap erase                   ( init threads to 0)
    voc-link,
  does> >user context !
; resolves <vocabulary>
decimal
: definitions   (s -- )
   context @ current !   ;

\ Extensible Layer            Defining Words          06Oct83map
: 2constant
   create   , ,     (s d# -- )
  ;code             (s -- d# )
\itc      w )+ sp -) lmove
\itc 32\  w )+ sp -) lmove
\dtc  sp )+ a0    move   \ 12
\dtc  a0 )+ sp -) move   \ 20
\dtc  a0 )+ sp -) move   \ 20  --> 52
c;
: 2variable
  create 0. , 0. ,   (s -- )
;
nuser avoc
: code   (s -- )      create  hide
\itc   here  dup body> w!
\dtc   here  dup body> - negate allot   ( get rid of the jsr )
  context @ avoc !   ( assembler  ) noop ;
\ assembler definitions
: end-code  avoc @ context !   reveal   ;
\ forth definitions   meta in-meta

\ Initialization              High Level              29Sep83map
: .ok  #out @ if cr then status ." ok " ;
: ok ;
defer prompt
: (prompt
   input-from-file?
   0= if
     ?interactive @ if .ok then
   then
;
defer quit
: (quit   (s -- )
   sp0 @ 'tib !   [compile] [
   begin 
      rp0 @ rp!
      state @ 0= if  prompt  then 
      query  interpret
   again
;
: (abort    sp0 @ sp! quit  ;
defer abort

:-h >user#  ( cfa-t -- user#-t )
  >body-t @-t
\ If the host system is 16 bits and the target system is 32-bits,
\ then we need to convert the long offset to a normal so it can be
\ used as an assembler displacement
32\ l->n  ( this should be l-t->n )
;-h
meta assembler definitions
:-h 'user# ( --name  user# )
  [ meta ]-h
    '  ( cfa-of-user-variable )
    >user#
  [ assembler ]-h
;-h
:-h 'body ( --name  pfa )
  [ meta ]-h
    '  ( cfa-of-variable )
    >body-t
  [ assembler ]-h
;-h
meta definitions

\ I/O for running under Unix with a C program providing actual I/O routines
code syscall ( ... call# --- ... )
     'user# syscall-vec
           ( user variable # of syscall-vec )
                up  d)   a0   lmove  ( addr of table )
                sp   )+  a0    adda  ( addr of table entry )
                a0   )   a0    lmove ( addr of routine )
                         a0 )  jsr   ( and execute it )
c;
code retval ( -- return_value )     d0 sp -) move   c;
code lretval ( -- l.return_value )  d0 sp -) lmove  c;

defer (emit

\ Here is all the kernel needs from Unix
decimal
: unix-emit n->l 04 syscall ldrop ;
: (key  00 syscall retval ;
: (key? ( --- f ) 32 syscall retval ;
: (bye 0 36 syscall ;
: input-from-file?  48 syscall retval ;
hex

\ Don't pause inside emit because escape sequences could screw up.
\ The correct way to do this is to have a two-level vector.
\ The low-level vector selects the output device.  The high-level
\ vector performs processing like 1 #out +!.  Terminal control
\ with escape sequences could use the low-level vector.

: emit1 (emit 1 #out +! ;

: title ." 68000 Forth 83 - Unix version " .version cr ;
\itc : \itc ; immediate
\itc : \dtc  [compile] \ ; immediate
\dtc : \itc  [compile] \ ; immediate
\dtc : \dtc ; immediate
\t16 : \t16 ; immediate
\t16 : \t32  [compile] \ ; immediate
\t32 : \t16  [compile] \ ; immediate
\t32 : \t32 ; immediate

\ Some hooks for multitasking
\ Main task points to the initial task
0 constant main-task
: init-user
    up@  up0 @  user-size  cmove  ( copy user area to its new home )
    up0 @ ( final-up ) up!
    up@ ['] main-task >body !
;
: (cold-hook
   [compile] forth definitions
   decimal
   ?interactive on
;
: stand-cold-hook ;
defer cold-hook
: cold
   init-user
   cold-hook   
   quit
;
defer pause  ( for multitasking )
: single (s -- ) \ Turn off multitasking
  ['] noop ['] pause (is
;
: warm   (s -- )
  main-task up!
  single
  warm-hook quit
;
defer warm-hook
: (warm-hook sp0 @ sp!  ;

/l ualloc-t user caller-stack  ( The initial stack frame )
32\ 0 constant gargc
32\ 0 constant gargv

\ 0 ( stack space for remembering an address )

\ XXX FIXME should use absolute long branch?
create cold-code
  here-t cld 2 + swap over - swap w!-t  ( cold entry point )
\ Executed with the stack containing:
( gargv gargc syscall-vector ending-address return-address --- )
assembler

  4  sp  d) d7 lmove  ( get top address of the forth system )

( for some unknown reason, using "us" instead of 200 doesn't work )
32\ (  us ) th 400. l# d7 sub   ( find the start of the user-init-table )
16\ (  us ) th 200. l# d7 sub   ( find the start of the user-init-table )
       d7 up lmove    ( point "up" to user-init-table )

   \ get base address of syscall table and put it in the user variable
   \ "syscall-vec"
  8 sp d)    'user# syscall-vec  up d)   lmove
   \ Remember the current value of the stack pointer in "caller-stack"
  sp  'user# caller-stack up d)   lmove

32\  \t32  td 12 sp d) 'body gargc l#)   lmove
32\  \t16  'body gargc #  a0 rmove     td 12  sp d)  a0  lmove

32\  \t32  td 16 sp d) 'body gargv l#)  lmove
32\  \t16  'body gargv #  a0 rmove     td 16  sp d)  a0  lmove

\ Remember this address ( no longer needed )
\ drop here

\ This is also an entry point for the stand-alone code.
\ At this point, the stack pointer has been set to the top of the stack area
\ and the user pointer has been set to the bottom of the initial user area
\ image.

32\   400. l#  sp  suba  ( allocate user area )
32\   sp  rp  lmove
32\   rp  'user# up0   up d)  lmove
32\   rp  'user# rp0   up d)  lmove
32\   100. l#  sp  suba  ( allocate return stack )
32\   sp  'user# 'tib  up d)  lmove
32\    20. l#  sp  suba  ( for safety )
32\   sp  'user# sp0   up d)  lmove

16\   'user# rp0       up d)  rp  lmove
16\   'user# sp0       up d)  sp  lmove

\t16      meta ' cold >body-t assembler  # ip  rmove
\t32      meta ' cold >body-t assembler l# ip  rmove
next
meta

\ ( Address that was remembered above )  constant startup

decimal
create warm-code
here-t wrm 2 + swap over - swap w!-t  ( warm entry point )
assembler
  word
    th 41fa , 0 ,  ( this is a "lea 0(pc ,a0" instruction )
    a0 d7 lmove
\t16      meta ' warm >body-t assembler  # ip rmove
\t32      meta ' warm >body-t assembler l# ip rmove
next
meta

( initialization of user area )
label user-init-table
:-h >user-t ( user# -- user-init-table-addr )
  >user#  here-t +
;-h
:-h user-init ( val cfa-of-user-var --- )
  >r n->n-t r>
  >user-t  !-t
;-h
:-h user-init-a ( val cfa-of-user-var --- ) ( for absolute addresses )
  >r n->a-t r>
  >user-t !-t
;-h
:-h user-init-t ( val cfa-of-user-var --- ) ( for tokens )
\t16  >user-t  w!-t
\t32  >user-t  l!-t
;-h
:-h user-init-n ( addr cfa-of-user-array n -- ) ( init n bytes in user space )
   >r
   >user-t ( addr start-address-in-user-init-table )
   r> cmove-t
;-h

decimal

init-r0     ' up0       user-init-a
init-s0     ' sp0       user-init-a
init-r0     ' rp0       user-init-a
init-s0     ' 'tib      user-init-a
031         ' width     user-init
1           ' warning   user-init
user-init-table ' fence user-init-a
user-init-table ' dp    user-init-a
' forth >body-t /n + ' voc-link  user-init-t
bsin        ' erasech   user-init
next-user-t @ ' #user user-init
current-t @     ' forth  #threads-t /link-t *    user-init-n

' noop  ' pause    user-init-t
' lf    ' cr       user-init-t
' emit1 ' emit     user-init-t
' unix-emit  ' (emit user-init-t
' (key  ' key      user-init-t
' (key? ' key?     user-init-t
' (bye  ' bye      user-init-t
' (expect   ' expect    user-init-t
' (word      ' word      user-init-t
' (#out      ' #out      user-init-t
' (#line     ' #line     user-init-t
' (number    ' number    user-init-t
' (create    ' create    user-init-t
' (interpret ' interpret user-init-t
' (warm-hook ' warm-hook user-init-t
' (cold-hook ' cold-hook user-init-t
' (prompt    ' prompt    user-init-t
' (quit      ' quit      user-init-t
' (abort     ' abort     user-init-t

' (source    ' source    user-init-t
' (parse     ' parse     user-init-t
' (parse-word ' parse-word user-init-t
' (query     ' query     user-init-t
' (where     ' where     user-init-t
' noop       ' error-output    user-init-t
' noop       ' restore-output  user-init-t
' (?error    ' ?error    user-init-t
' noop       ' status    user-init-t
1            ' ?interactive user-init
assembler dodoes meta
             ' dodoesaddr user-init-t

us allot-t

forth-h
metaoff
  ' 0 is key?
only forth also definitions
' symbols fixall
\t16 fix-does-words
