\ Meta compiler.  Host system: 68K F83  Target system: 68K F83

0 warning !

only forth also definitions

vocabulary meta
meta definitions

meta assembler definitions
: normal long ;
: wmove size @ >r word move r> size ! ;
: bmove size @ >r byte move r> size ! ;
meta definitions

: lobyte th 0ff and ;
: hibyte 8 >> lobyte ;

2 constant /w-t
4 constant /l-t
/l-t constant /n-t
/n-t constant /thread-t
\itc-t /w-t constant /cf-t
\dtc-t 6 constant /cf-t
\t16-t /w-t constant /token-t
\t32-t /l-t constant /token-t
\t16-t /w-t constant /link-t
\t32-t /l-t constant /link-t
/token-t constant /defer-t

: >body-t /cf-t + ;
\ 32 bit forth compiling 32-bit kernel
: l->n-t ;
: n->l-t ;
: n->n-t ;

origin th 1.0000 l+ lconstant compilation-base

0. lconstant origin-t
variable compilation-offset

: n->a-t
\t16-t origin-t l+
;

decimal

\ What we really need here is to set the offset based on the
\ value passed to the "org" command
: rel-t ( target-address -- host-address )
  compilation-offset @    l+
;
: c!-t ( n add --- ) rel-t c!l ;
: c@-t ( target-address --- n ) rel-t c@l ;

: w!-t ( n add --- ) over hibyte over c!-t
                 ca1+ swap lobyte swap c!-t ;
: l!-t ( l add --- ) >r lwsplit r@ w!-t r> /w-t + w!-t ;
: !-t  ( n add --- ) l!-t ;

: w@-t ( target-address --- n )
  dup c@-t 8 << swap 1+ c@-t or
;
: l@-t ( target-address --- n )
  dup >r /w-t + w@-t  r> w@-t  wljoin
;
( should this be the normal host size or target size ? )
: @-t  ( target-address --- n ) l@-t ;

: cmove-t ( from to-t n -- )
  0 do over c@  over c!-t  1+ swap 1+ swap loop  2drop
;
: "copy-t ( from to-t -- )
  over c@ 2+  cmove-t
;
: toggle-t ( addr-t n -- ) swap >r r@ c@-t xor r> c!-t ;
variable dp-t
: allot-t dp-t +! ;

: c,-t dp-t @ c!-t 1 dp-t +! ;
: w,-t dp-t @ w!-t /w-t dp-t +! ;
: l,-t dp-t @ l!-t /l-t dp-t +! ;
: ,-t l,-t ;  ( for 32 bit stacks )

: token@-t ( target-address -- token )
\t16-t w@-t
\t32-t l@-t
;
: token!-t ( token target-address -- )
\t16-t w!-t
\t32-t l!-t
;
: token,-t ( token -- )
\t16-t w,-t
\t32-t l,-t
;
: link@-t ( target-address -- target-address' )
\t16-t w@-t
\t32-t l@-t
;
: link!-t ( target-address target-address -- )
\t16-t w!-t
\t32-t l!-t
;
: link,-t ( target-address -- )
\t16-t w,-t
\t32-t l,-t
;
: link-t@ ( host-address -- target-address )
\t16-t w@
\t32-t l@
;
: link-t! ( target-address host-address -- )
\t16-t w!
\t32-t l!
;
: token-t@ ( host-address -- )
\t16-t w@
\t32-t l@
;
: token-t! ( token host-address -- )
\t16-t w!
\t32-t l!
;


: here-t dp-t @ ; 
lvariable voc-link-t
4 constant #threads-t
code hash-t  (s str-addr voc-ptr -- thread )
  sp )+ d1 move  sp )+ a0 amove
  byte  a0 )+ tst   a0 )+ d0 move
  ( #threads-t 1- ) long 3. l# d0 andw
  normal d0 d0 add
\t32-t d0 d0 add
  d0 d1 add
  d1 sp -) move
c;
create threads-t   #threads-t /link-t * allot
variable current-t

variable last-t  0 last-t !
: initmeta
( also initialize target user area )
  threads-t   #threads-t /link-t *   erase
  threads-t current-t !
;

: n>link-t /link-t - ;
: l>name-t /link-t + ;

decimal
: align-t here-t 1 and if bl c,-t then ;
( can't use existing align because we need the meta here-t and c, )

: (s [compile] ( ; immediate

: entercode [compile] assembler [ assembler ] normal [ meta ] ;

: org dup dp-t !  ['] origin-t >body l!
  compilation-base origin-t -  compilation-offset !
;

only forth also meta also forth definitions

: link> ( lfa -- cfa ) l>name name> ;

( given cfa of a vocabulary, search only that vocabulary )
: vcurrent ( voc-cfa --- addr-of-top-pointer ) >body >user ;

( xxx should just use the search path mechanism )
( voc-ptr is the address of the first thread )

vocabulary symbols 0 ,
: sfind ( str --- cfa [ -1 1 ] | str false )
  ['] symbols vcurrent vfind
;

vocabulary labels 0 ,
: lfind  ( str --- cfa [ -1 1 ] | str false )
  ['] labels vcurrent vfind
;

: equ ( value --- )
  current @ context @ [compile] labels definitions
        rot constant
  context ! current !
;
: label ( --- )
     [ meta ] here-t equ
;

\ This is a version of create that creates a word in a specific vocabulary.
\ The vocabulary is passed as an explicit argument. This would be somewhat
\ easier if the search-order stuff was implemented in a less "hard-wired"
\ manner.

: vcreate ( str voc-cfa -- )
  context @ >r current @ >r
  warning @ >r
  vcurrent dup context ! current !
  0 warning !
  "create
  r> warning !
  r> current ! r> context !
;
\ end of duplicate create

\ Symbol entries in "symbols" vocabulary:  

\    The "first-occurrence" field is the head of a linked list
\ its value is a pointer to an occurrence of this word in the
\ target dictionary.  Each node in the list is one 16-bit word.
\ The last node contains 0.  If there are no occurrences, the
\ first-occurrence field contains 0.
\    The "resadd" field contains the compilation address of the
\ word, or 0 if the word hasn't been defined yet.
\    Symbols should probably be "does>" words, but aren't for
\ historical reasons.

: first-occurrence ( cfa --- first-occurrence-add ) >body ;
: resadd  ( cfa --- resolution_add ) >body /token-t + ;

: resolution ( cfa --- resolution ) resadd token-t@ ;
: resolvesym ( cfa resolution --- ) swap resadd token-t! ;

\ Add a new occurrence of word to the linked-list of occurrences.
\ The "first-occurrence" field is the head of the list.  If the list
\ is empty, it contains 0.  If the list isn't empty, it contains the
\ non-relocated target address of the most-recent
\ occurrence of the word.  That location, in turn, points to the
\ previous occurrence.  The last one in the list contains 0.

: linkin     ( cfa occurence --- )
  over first-occurrence token-t@  ( cfa occurrence old-first-link )
  over token!-t     ( link old list to occurrence ) ( cfa occurrence )
  swap first-occurrence    ( occurrence head-of-list-node )
  token-t!      ( link occurrence to head-of-list-node )
;
: addlink ( cfa --- ) here-t linkin /token-t allot-t ;
: makesym ( str --- cfa ) ( makes a new symbol entry )
    ['] symbols vcreate
    here body>   ( leave cfa for downstream code )
    ( initialize first-occurrence ) 0 ,
    ( initialize resolution ) 0 ,
  does> ( pfa )
    body>  ( cfa )
    dup >name c@ th 40 and
    if  >name .id
        ."  is immediate in the target system but it" cr
        ." hasn't been defined yet in the metacompiler."  abort
    else addlink
    then
;
: ?already ( cfa --- f ) ( true if already resolved )
  resolution ;

\ Words to manipulate the symbol table vocabulary at the end of compilation.

\ resolve is used to replace all the references chained to
\ its argument cfa with the associated referent
: .x  ( -- ) depth 30 u< 
  if  base @ >r hex .s r> base !
  else ." Underflow"
  then
;
: resolve ( cfa --- ) ( replace all links with the resolution )
  dup resolution >r        ( return-stack: resloution )
  first-occurrence token-t@             ( first-occurrence )
( If there are no occurrences, the resolution is just put in the )
( "first-occurrence" field, which doesn't hurt anything )
  begin dup    ( current-occurrence f )
  while
    ( first grab link to next occurrence before clobbering it )
      dup token@-t        ( current-occurrence next-occurence )
      r@ rot token!-t     ( put the resolution value in the current-occ. )
    ( next-occurrence )
  repeat
  drop  r> drop
;

\ print the addresses of all the places where this word is used
: where-used ( cfa --- )
  first-occurrence token-t@  ( first-occurrence )
  begin  dup  while  dup u. token@-t  repeat
  drop
;
: name? ( cfa --- ) >name .id space ;
: defined ( cfa --- ) resolution u. ;

\ "show" prints the name of the word, its compilation address, and
\ all the places it's used.  Basically a cross-reference listing
\ for the word.
: show  ( cfa --- ) ( name, defined, occurrences )
  dup name?   dup defined   where-used ;
: n' ( voc-cfa --namex cfa )
  [compile] "
  swap vcurrent vfind 0=
  if count type ."  not found" abort then
;
: whats ( --- ) ['] symbols n' show ;
: whatl ( --- ) ['] labels  n' show ;

\ used in scanning a multi-threaded vocabulary.  copied from "words"
: largest (s addr n -- addr' val )
   over 0 swap rot 0  ( addr 0 addr  n 0 )
   do   2dup link@ u<   ( addr-largest largest thisaddr  largest<thisone? )
      if   nip nip      ( this-addr )
           dup link@ over  ( this-addr this-one this-addr )
      then              ( largest-addr largest this-addr )
      /link +
   loop   drop   ;

\ Given a the cfa of an action word and the cfa of a vocabulary,
\ executes the action word for every word in the vocabulary.
\ The lfa is on the stack when the action word executes, and it must
\ be removed from the stack by the action word.

: over-vocabulary   (s voc-cfa word-to-execute --- )
   swap vcurrent   ( word voc-threads )
   here #threads /link * cmove
   begin   
     here #threads largest   dup origin u>
   while dup  ( word  addr  lfa lfa )
     3 pick execute
     ( word addr lfa )  link@ swap link!
   repeat   2drop drop
;

: nwords-hook ( lfa -- ) l>name .id 2 spaces  ;
: nwords ( voc-cfa --- ) ['] nwords-hook over-vocabulary ;

: cref-hook ( lfa -- )  link> cr show ;
: cref  ( voc-cfa --- )  ['] cref-hook over-vocabulary ;

: undef-hook ( lfa -- )
   dup link> ?already 0=  ( lfa f )
   if  l>name .id space  else  drop  then
;
: undef ( voc-cfa --- )  ['] undef-hook over-vocabulary ;

: fixall-hook ( lfa -- )
  dup link> dup ?already  ( lfa cfa f )
     if    ( over l>name .id cr )  resolve  drop
     else drop l>name .id ." not defined" cr then
;
: fixall ( voc-cfa --- ) ['] fixall-hook over-vocabulary ;

only forth also meta definitions

\ Defines a new target symbol with name str.
\ If there is no symbol with the same name, or
\ if a symbol with the same name has already been resolved
\ a new one is created and resolved.  If a symbol of the
\ same name exists but is unresolved, it is resolved. 
\ Smudging is not done
variable last-s
: create-s ( str --- )
  dup sfind               ( str cfa f | str str false )
   if   dup ?already ( str cfa f )
        if   drop dup count type ."  isn't unique in target" cr
             makesym
        then   ( str cfa )
   else ( str str ) makesym      ( str cfa )
   then
   ( str cfa ) >name last-s !
   drop
;

\ "compile takes a string and compiles a reference to that word in the
\ target dictionary.  In the case of a forward reference, this may
\ involve creating an entry in the symbol vocabulary.  Even if the
\ word has already been defined, we don't emplace the compilation address
\ yet.  Instead, we just add this location to a linked list of references
\ to the word.  For what its's worth, this makes generating a
\ cross-reference list easy at the end of the metacompilation.

: "compile ( str --- ) ( compile symbol whose name is at str )
   sfind        ( see if we have encountered this one before )
   0= if makesym then                  ( make it if it's new )
   ( cfa ) addlink         ( in any case, add this reference )
;

\ mcompile is used inside a definition.  It takes an in-line string
\ argument and stores the string somewhere in the definition.  When the
\ definition executes, that string is "compile'd.  This allows
\ immediate words to compile run-time words, even if the run-time
\ word hasn't yet been defined in the target system.

: mcompile ( --namex )
 ( example : foo mcompile bar ; )
 ( when foo executes, it will then search for the word bar and )
 ( compile a reference to it.  The STRING bar is stored within foo )
  [compile] "" [compile] "literal
          compile "compile
; immediate

: literal ( n --- )  mcompile (lit ,-t   ; immediate
: lliteral ( l --- ) mcompile (llit l,-t ; immediate
: dliteral ( d --- ) swap mcompile (lit ,-t mcompile (lit ,-t ; immediate
: ascii   ( --word  char )
  bl word 1+ c@ state @ if mcompile (lit n->l-t ,-t then
; immediate

\ Try to parse a number and either leave it on the stack or compile it
\ depending on state.  This word only gets called when the state is
\ "metacompiling", ie in the middle of a target definition, so I
\ think it always actually compiles the number.  I'm not quite sure though

: trynumber ( str --- f )  number?
  if dpl @ 0< if   l->n-t [compile] literal 
              else        [compile] lliteral
              then true
  else ldrop false then ;

\ This is pretty complicated.  This is what you get if you try to do
\ a "good" job of metacompiling <ha!> and allow the user to write
\ source code for his kernel that looks much like normal Forth.
\ There are all sorts of cases to consider, which I'm not going to
\ try to explain, partly because I don't quite remember.

variable mcfa  variable scfa  variable case  variable symname

\ / is integer divide, % is mod
\ n/3=0 not already defined in symbols
\ n/3=1 defined in symbols not immediate
\ n/3=2 defined in symbols immediate
\ n%3=0 not already defined in forth or meta
\ n%3=1 defined in forth or meta not immediate
\ n%3=2 defined in forth or meta immediate

\ Try to figure out what kind of word this is, even if it isn't already
\ defined in the target system, by seeing if it's already defined in the
\ host system and if so, what kind of word it is.

: gen_case ( str --- n ) ( returns a number between 0 and 9 )
  >r  r@ symname !
  r@ sfind   ( cfa [ -1 1 ] | str false )
     dup
     if   swap scfa ! 0>         ( already defined in symbols )
          if 6 else 3 then       ( immediate? )
     else 2drop 0                ( not defined in symbols )
     then case !
  r> find   ( cfa [ -1 | 1 ] | addr false )   ( defined in forth ? )
     dup
     if   swap mcfa !   ( flag is 1 if immediate, -1 if not )
          0>  if  2  else 1 then
     else 2drop 0
     then case +!
  case @
;

\ not-previously-defined words are either labels, numbers, or forward
\ references.  Labels may be found by searching the "labels" vocabulary.
\ Numbers may be parsed.  If both these tests fail, it must be a
\ forward reference.

: do-undefined ( --- )
( 3 possibilities - label, number, or forward reference )
  symname @ lfind ( cfa [ -1 1 ] | str false )   ( is it a label? ) 
  if   execute                \ it's a label
  else trynumber 0=           \ is it a number?
    if symname @ makesym addlink then    \ must be forward reference
  then
;

\ Based on the classification of the word made by "gen_case",
\ handle this word.  An indexed case statement would clearly
\ have been a nicer implementation, but what the heck?

: "comp ( n --- ) ( handle a symbol in compile state )
  >r    r@ 2 > r@ 6 < and if  scfa @ addlink   ( backward ref )
  else  r@ 2 = r@ 8 = or  if  mcfa @ execute  ( immediate )
  else  r@ 0 = r@ 1 = or  if  do-undefined
  else  r@ 6 = r@ 7 = or  abort" immediates must be in meta"
  then then then
  r> drop
;

\ This trynumber is used in "execute1, which is called when the
\ state is not "metacompiling".  It never compiles a number into the
\ target dictionary, although it may compile a number into the
\ host dictionary

: trynumber-execute ( str -- ?? true | str false )
  dup number?   ( str d. f )
  if   l>r drop lr> state @
       if   [ forth ] dpl @ -1 =
            if   l->n [compile] literal  else [compile] lliteral then
            [ meta ]
       else dpl @ -1 = if l->n then
       then
       true
  else ldrop false
  then
;

\ This could be simplified a lot now that we have real search-paths.
\ Trylabel can just go away, along with the test for it in "execute1

: trylabel ( str --- n true | str false )
  lfind   ( cfa [ -1 1 ] | str false )
  if execute true else false then
;

\ This is mostly a duplication of the interpreter loop in the kernel.
\ It is included here because the built-in interpreter loop doesn't
\ handle exceptional conditions very well.  Also because the metacompiler
\ was originally written for an F79 system, and the semantics were
\ subtly different.  I didn't have time to rethink things.

variable wordname
: "execute1 ( str --- ? )
  dup wordname !
  find  ( cfa [ -1 | 1 ]  |  str false )
  dup
  if   0>     ( flag is 1 if immediate, 0 if not )
       if   execute       ( because the word was immediate )
       else state @       
            if   [ forth ] token, [ meta ]  ( because we are compiling )
            else execute
            then
       then
  else drop  trylabel 0=
       if   trynumber-execute  0=
            if
                 cr count type ."  not recognized" cr abort
            then
       then
  then
;

\ Interpret/compile a single word given the string representing its name.
\ I never have figured out why most forth implementations don't factor
\ it this way, rather than burying this algorithm inside a loop.

th 80 constant metacompiling
: "interpret1 ( str --- )
  state @ metacompiling =
   if   gen_case "comp
   else "execute1
   then
;
\   This is the loop that gets the next word and calls "interpret1
\ It takes care of exiting at the end of the line, rather than
\ interpreting a null word, which is horribly unstructured.
\    The metacompiler is turned on by changing the "interpret" vector
\ to execute minterpret

: minterpret ( --- )
  begin [compile] "" more?    ( str not-end-of-line? )
  while  "interpret1  repeat
  drop
;

\   "Transition" words.  Versions of compiling words which are defined
\ in the host environment but which compile code into the target
\ environment.
\   Once compiling words are redefined, care must be taken to select
\ the old instance of that word for use in other definitions.  For instance,
\ when "if" is redefined, subsequent definitions will frequently want to use
\ the old "if", so the search order must be explicitly controlled in order
\ to access the old one instead of the new one.

variable doestarget

\ "resolves" gives a name to the run-time clause specified by the most-
\ recently-defined "does>" or ";code" word.  A number of defining words
\ assume that their appropriate run-time clause will be resolved with a
\ particular word.  For instance, "constant" references a run-time clause
\ called <constant>.  When the run-time code for constants is defined
\ in the kernel source, "resolves" is used to associate its address with
\ the name <constant>.  See the kernel source for examples.

: resolves ( --namex ) [compile] "
  sfind  ( cfa [ -1 1 ] | str false )
  0= if makesym then ( cfa )
  doestarget @ resolvesym
;

\ This is a smart equ which defines words that can be later used
\ inside colon definitions, in which case they will compile their
\ value as a literal

: equ  [ forth ] create , immediate does>  @
  [ meta ] state @ metacompiling = if [compile] literal then ;

\ Transition version of control constructs.  These compile relative
\ branches.  The distribution version of F83 uses absolute branches,
\ which don't work in the case of a 68000 where the code is somewhere
\ other than in bank 0.

/w-t constant /branch
: branch! ( from target -- ) over - ( from offset ) swap  w!-t ;
: branch, ( target -- ) here-t - w,-t ;

: ?>mark    (s -- addr ) here-t here-t branch, ;
: ?>resolve (s addr -- ) here-t branch! ;
: ?<mark    (s -- addr ) here-t ;
: ?<resolve (s addr -- ) branch, ;
: ?comp    state @ metacompiling <> abort" compile only" ;

: begin  ?comp  ?<mark 1  ;                  immediate
: then     ?comp 2 ?pairs    ?>resolve  ;  immediate
:  ?do     ?comp    mcompile (?do  ?>mark ; immediate
:  do      ?comp    mcompile (do   ?>mark ; immediate
:  loop    mcompile (loop  dup /branch +  ?<resolve ?>resolve  ; immediate
: +loop    mcompile (+loop dup /branch +  ?<resolve ?>resolve  ; immediate
: leave    mcompile (leave  ; immediate
: ?leave   mcompile (?leave ; immediate

: until    1  ?pairs  mcompile ?branch ?<resolve  ; immediate
: again    1  ?pairs  mcompile  branch ?<resolve  ; immediate

: repeat   >r  >r  [compile]  again
              r>  r>  2  -  [compile]  then  ;  immediate
: if       mcompile ?branch ?>mark  2  ;     immediate
: else     2 ?pairs mcompile branch ?>mark
           swap  ?>resolve  2  ;      immediate
: while   [compile]  if  2+  ;    immediate

\ Transition versions of tick and bracket-tick.  Forward references
\ are not allowed because in the case of tick, there is no way of knowing
\ what the user does with the address once he gets it.  The mechanism for
\ eventually resolving forward references depends on the assumption that
\ the forward reference resolves to a compilation address which is compiled
\ into a definition.  This assumption probably doesn't hold for tick'ed
\ words, so we don't allow them to be forward references.  In the case of
\ bracket-tick, the assumption holds, but historically, bracket-tick
\ used to compile the pfa, and the meta compiler would have had to make
\ heroic efforts to sort out those cases where it had to resolve to a pfa
\ instead of a cfa.

: ?'err ( str 0 | ??? 1 --- )
   [ forth ]
   0= if
    ." Ticking " count type ."  Sorry, no forward references with [']" cr quit
   then
   [ meta ]
;

\ From now on we start to see familiar words with "-h" suffixes.  These
\ are aliases for the familiar word, used because we have redefined the
\ word to operate in the target environment, but we still need to use the
\ original word.  Rather that having to do [ forth ] foo [ meta ] all the
\ time, we make an alias foo-h for foo.

forth definitions
: '-h ( --namex cfa ) ' ;
meta definitions
: ' ( --- cfa )
  [compile] ""
  dup sfind  ?'err   ( make sure the word is defined )
  resolution         ( str resolution )
  ?dup                          ( make sure the word is resolved )
       ?'err nip ( drop str )  ( resolution )
;
forth definitions
: [']-h ( --namex cfa ) [compile] ['] ; immediate
meta definitions

: ['] ( --namex ) '
  mcompile (' token,-t
; immediate

\ Emplace a string into the target dictionary
: ",-t ( str --- ) ( cram the string at here )
      dup here-t "copy-t
      c@ 1+  allot-t  align-t
;
: ."     mcompile (."     [compile] " ",-t ; immediate
: abort" mcompile (abort" [compile] " ",-t ; immediate

1024 constant b/buf

\ actually does the smudging in the symbols vocabulary
: smudge        last-s @   th 20 toggle ;

meta assembler definitions
: end-code
  current @ context ! [ meta ] smudge [ assembler ]
; ( need right smudge )

\ Some debugging words.  Allow the printing of the name of words as they
\ are defined.  threshhold is the number of words that must be defined
\ before any printing starts, and granularity is the interval between
\ words that are printed after the threshhold is crossed.  This is very
\ useful if the metacompiler crashes, because it helps you to locate
\ where the crash occurred.  If needed, start with threshhold = 0 and
\ granularity = 20, then set threshhold to whatever word was printed
\ before the crash and granularity to 1.

forth definitions
variable #words       0 #words !
variable threshold   10000 threshold !
variable granularity 10 granularity !
variable prev-depth  0 prev-depth ! ( expected depth )
: .debug ( -- )
  #words @ 5 .r space
  [ meta ] last-s [ forth ] @ .id
  depth 0 <> if  space .x then
  cr
;
: ?debug ( -- )
  depth  prev-depth @ <>
  if   .debug  depth prev-depth !
  else   #words @ threshold @ >=
       if  #words @ granularity @ mod
           0= if  .debug  then
       then
  then
  1 #words +!
;

\ Create a header in the target image
meta definitions
: link, link,-t ;
: "create-t   (s str -- ) ( make a header in the target area )
   dup current-t @ ( str   str voc-ptr ) hash-t  ( str thread )
   dup link-t@  ( fetch the first link from the private meta thread area)
   align-t link,-t ( link this word to existing list ) ( str thread )
   here-t last-t !
   here-t n>link-t swap link-t!  ( link top of list to this word )   ( str )
   dup here-t "copy-t
   here-t     swap c@  width  @  min  1+  allot-t  align-t
   ( nfa ) th 80  toggle-t  here-t 1-  th 80  toggle-t
;

\ Perform a create for the target system.  This includes making or
\ resolving a symbol table entry.  A partial code field may be generated.

\ For itc, the code field is a 16-bit pointer.  For dtc, the code field
\ is a jsr instruction with an absolute 32-bit address, except for code
\ words, where there is no code field.
: startcf
\dtc-t th 4eb9 ( l#( jsr ) w,-t
\dtc-t \t16-t     2 ( XXX high address word ) w,-t
;
: create-t ( --- )
  [ forth ] [compile] ""  [ meta ] ( get name )
  dup create-s  ( symbol table entry )
  "create-t     ( make header )
  last-s @ name>   here-t   resolvesym  ( resolve it )
  startcf
;

variable next-user-t

: fixcode
\itc-t     here-t /w-t allot-t   here-t swap w!-t
\dtc-t     -2 allot-t
\dtc-t \t16-t -2 allot-t  ( get rid of the 2 also )
;

: constant create-t mcompile <constant> s->l  ( XXX ) ,-t ?debug ;
: create   create-t mcompile <variable>                   ?debug ;
: variable create-t mcompile <variable> 0.    ( XXX ) ,-t ?debug ;
: user     create-t mcompile <user>    n->l-t ( XXX ) ,-t ?debug ;
: code     create-t fixcode smudge entercode              ?debug ;

: ;code     (s -- )
   ?csp   mcompile (;code here-t doestarget !
   [compile] [  ( smudge ) entercode
;  immediate

: does>
   mcompile (;code  here-t doestarget !
\t16-t   th 6100 w,-t ( bsr )    mcompile dodoes
\t32-t   startcf  mcompile <dodoes>
; immediate

: [compile] [compile] "" "compile ; immediate

( Automatic allocation of space in the user area )

: ualloc-t ( n --- next-user-# ) ( allocate n bytes and leave a user number )
  next-user-t @ swap next-user-t +! ;
: user, ( n -- ) ( allocates a word in the user area and emplaces n )
  /n-t ualloc-t ( n user# ) ( up@ + ! ) drop drop
;
: nuser ( --namex ) /n-t ualloc-t user ;
: tuser ( --namex ) /token-t ualloc-t user ;

\ This vocabulary allocates space for its threads in the user area
\ instead of in the dictionary.  It is therefore ROMable.  The existence
\ of the voc-link in the dictionary does not compromise this, since
\ the voc-link is only written once, when the vocabulary is created.
: voc-link, here  voc-link-t token-t@   token,-t  voc-link-t  token-t! ;
: vocabulary   create-t mcompile <vocabulary>
  ( make threads )  #threads-t /link-t * ualloc-t
  ( user#, ) n->n-t ,-t
  voc-link,     ( space for voc-link )
  ?debug
;
\ /defer-t  is the number of user area bytes to alloc for a deferred word

: defer create-t mcompile <defer> /defer-t ualloc-t n->n-t ,-t ;

forth definitions

: 32\ ; immediate
: 16\ [compile] \ ; immediate

: :-h  [compile] :  ;
: ;-h [ forth ] [compile] ; ; immediate
: ]-h   ]  ;
: forth-h [compile] forth ; immediate

meta definitions

: ;  ( -- )
  ?csp mcompile exit
  smudge [ forth ] [compile] [  [ meta ]
; immediate

: ]  ( -- )
  metacompiling state !  ;-h

: :  ( --namex )
 sp@ csp !  create-t mcompile <colon> smudge ]   ?debug ;-h

:-h immediate-h immediate ;-h

:-h immediate ( -- )
  last-t @   th 40 toggle-t ( fix target header )
  last-s @   th 40 toggle   ( fix symbol table )
;-h

\ Turn on the metacompiler by revectoring "interpret" to use "minterpret"
\ and changing the words used by the assembler to store into the dictionary.
\ They should store into the target dictionary instead of the host one.

forth definitions

: metaon
  [compile] meta definitions
  [ meta ]-h [']-h minterpret [ forth ] ['] interpret  (is
  [ meta ]-h [']-h w,-t   [ assembler ] ['] ,          (is
  [ meta ]-h [']-h here-t [ assembler ] ['] here       (is
  [ meta ]-h [']-h c!-t   [ assembler ] ['] c!         (is
;

( Undo metaon )

: metaoff
  [compile] forth definitions
  [ forth ] ['] (interpret          ['] interpret  (is
  [ forth ] ['] ,         [ assembler ] ['] ,    [ forth ] (is
  [ forth ] ['] here      [ assembler ] ['] here [ forth ] (is
  [ forth ] ['] c!        [ assembler ] ['] c!   [ forth ] (is
;
only forth meta also forth also definitions

\ Save an image of the target system in the Unix file whose name
\ is the argument on the stack.

: u_write-t ( n buf-t fd -- nwritten )
  >r >r n->l r> rel-t r> n->l td 24 syscall
  retval >r ldrop ldrop ldrop r>
;

variable fd
: save-meta ( str --- )
  default-mode over u_creat fd ! ( make a new file )
  fd @ -1 = 
  if   ." can't create " ".
  else drop ( get rid of filename )
       here-t  origin-t -   origin-t
             fd @  u_write-t
       dup   here-t origin-t -  <>
       if ." only wrote " . ." bytes!" else drop then
       fd @ u_close
  then
;

\ Nasty kludge to resolve the use of dodoes within "forth" and other
\ "does>" words.  This is only needed for 16-bit tokens. The problem
\ is that my 16-bit implementation of does> takes a relative branch offset
\ for relocatability, whereas the resolving mechanism in the meta-compiler
\ can only cope with absolute symbols

: fix-does-words
   [""] dodoes  labels  find   forth  ( cfa true | str false )
   if  execute >r  else ." Can't find dodoes in labels" cr drop exit then
  ( dodoes address )
   [""] dodoes  symbols  find  forth
   if  first-occurrence token-t@
       begin dup
       while dup
         [ meta ]-h token@-t [ forth ] swap ( next-occurrence occurrence )
             r@ over -  ( next-occurrence occurrence offset )
             swap [ meta ]-h w!-t [ forth ]
       repeat
       drop
    else   drop ." Can't find dodoes in symbols" cr
    then
    r> drop
;

:-h /n /n-t ;-h
:-h /w /w-t ;-h
:-h /l /l-t ;-h
:-h /token /token-t ;-h
:-h /link  /link-t ;-h

:-h \itc [compile] \itc-t ;-h immediate-h
:-h \dtc [compile] \dtc-t ;-h immediate-h
:-h \t16 [compile] \t16-t ;-h immediate-h
:-h \t32 [compile] \t32-t ;-h immediate-h
only forth also definitions

1 warning !
