\ Terminal control for ansi-standard terminals (e.g. Sun)

only forth also terminals definitions
\ Fast decimal output conversion
\ Only works for unsigned 16 bit input operands and always uses decimal radix

code utoa ( n -- bytes len )
  0 d2 moveq     ( counter )
  sp )+ d0 move  ( number )
  td 10 # d1 wmove
  begin  d1 d0 divu
       word  d0 swapw  ascii 0 # d0 add  d0 a0 wmove  normal a0 sp -) move
       1 d2 addq
       word d0 clr d0 swap   
  0= until
  normal
  d2 sp -) move
c;
: n. utoa 0 ?do (emit loop ;
\ : n. ( n --- ) ( print in decimal with no spaces )
\   base @ >r  decimal
\   n->l <# #s #> 
\   bounds ?do i c@ (emit loop  \ can't use type because it calls emit
\   r> base !
\ ;
: ansi-at ( row col -- )
  escape (emit ascii [ (emit
  swap 1+ n.     \ Terminal origin is 1,1 not 0,0
  ascii ; (emit
  1+ n.  ascii H (emit
;
: ansi-ic ( char -- )     esc[ @    (emit  ;

\ The Sun ROM monitor doesn't implement save and restore cursor position,
\ but we just happen to know where the monitor keeps the row and column
\ information
: sun-save ( -- ) ( remember cursor position )
  syscall-vec @     ( romvec )
  td 42 la+ @ ( v_gp )
  th 250 +   ( address of romvec->g_ax )
  dup  @ 1+ saved-x !  ( store x position )  ( addr )
  /l + @ 1+ saved-y !
  ['] pause >is token@ saved-pause !
 \ We can't allow another process to get in, because a save ... restore
 \ sequence is not re-entrant ( although it could potentially be
 \ if saved-x and saved-y were kept in the user area.  Would that work? )
  ['] noop ['] pause (is
;
: sun-restore ( -- )
  saved-y @   saved-x @   cursor-to-row-column
  saved-pause @ ['] pause (is
;
terminal: ansi
for #lines        34
for #columns      80
for beep          ctl G
for left          ctl H
for right         esc[ C
for set-position  ansi-at
for insert-char   ansi-ic
for delete-char   esc[ P
for kill-line     esc[ K
for kill-screen   esc[ J
for insert-line   esc[ L
for delete-line   esc[ M
for erase-screen  ctl L
for save-position    sun-save
for restore-position sun-restore
\ for save-position    esc[ s
\ for restore-position esc[ u
end-terminal

only forth also terminals also forth definitions
: ansi ansi ;
: sun ansi ;
only forth also definitions
