\ Get the arguments passed from the program
\ This only works in the 32-bit stack version.
\
\ Gargv leaves the address of the C-program gargv variable;
\  that variable contains a pointer to a longword which contains
\  the address of the file currently being interpreted.
\ Gargc leaves the address of the C-program gargc variable
\ 
32-bit
requires getenv.f

\ Return a pointer to a packed string which is the arg#'th next argument.
\ The 0'th argument is the name of the current input file.
\ If the arg#'th argument doesn't exist, returns 0.
: arg ( arg# -- argument-string )
  dup gargc l@ >=  ( arg# f)  ( f is true if that arg doesn't exist )
  if   drop 0
  else gargv l@ swap la+ l@  ( address-of-arg-string )
       cscount ( l.addr len)
       here place  here dup c@ 1+ even allot
  then
;

\ Get the next argument from the command line and bump gargc and gargv
\ so that that argument is "eaten", i.e. successive calls to nextarg will
\ get get successive arguments.  Furthermore, arguments that are gotten
\ by nextarg will not be subsequently interpreted by the C wrapper program.
\ Returns 0 when there are no more arguments.
: nextarg ( -- argument-string )
  1 arg
  gargc l@  1. l-  gargc l!
  gargv l@ /l +    gargv l!
;
