\ structures with bit fields for long base addresses
variable bitoffset
: bitalign ( offset size -- offset' size )
( moves to next byte boundary if the bit offset is nonzero )
  bitoffset @ if
    0 bitoffset !   swap 1+ swap
  then
;
: bstruct 0 bitoffset ! 0 ;
: bfield ( offset size -- newoffset )
    create bitalign over , +
    does> ( structure-base -- structure-member-address )
          @ n->l l+
;
\ reserves an n-bits field
: resbits ( offset #bits -- newoffset )
  bitoffset @ +   8 /mod  ( offset bitoffset_mod_8 bitoffset/8 )
  swap bitoffset !  +
;  
\ bits are allocated from left-right, or from msb to lsb.
\ however, they are numbered from lsb=0 to msb=7
\ left-right generates the correct bit number
: left-right-bit# ( #bits -- #bits bit# )
  bitoffset @ over +  8 swap -
  dup 0< abort" Bit fields can't cross byte boundaries"
;
\ defines an n-bit field
: bits ( offset #bits --namex newoffset )
  create  over w, left-right-bit# w, dup w,  ( offset #bits )
  resbits
  does> ( struct_addr pfa -- byte_addr bit# #bits )
     >r r@ w@ w->l l+  ( byte_addr )
        r@ wa1+ w@ ( byte_addr bit# )
     r>   2 wa+ w@ ( byte_addr bit# #bits )
;
hex
create masks
   0 w,
   1 w,   3 w,   7 w,  0f w,   1f w,   3f w,   7f w,   ff w,
 1ff w, 3ff w, 7ff w, fff w, 1fff w, 3fff w, 7fff w, ffff w,
decimal
: bitmask ( n -- mask ) masks swap wa+ @ ;

: nbit@ ( byte_addr. bit# #bits -- n )
  >r >r c@l ( bit# #bits byte )
  r> >> ( #bits byte>>#bits )
  r> bitmask and
;
code 1bit@ ( byte_addr. bit# -- f )
  normal sp )+ d0 move
  sp )+ a0 lmove
  d0 a0 ) btst
  0= if sp -) clr
     else 1. l# sp -) move ( XXX size dependent ) then
c;
: bit@ ( byte_addr. bit# #bits -- n )
  dup 1 =
  if   drop 1bit@
  else nbit@
  then
;
code 1bit! ( f byte_addr. bit# -- )
  sp )+ d0 move
  sp )+ a0 lmove
  sp )+ tst
  0<> if d0 a0 ) bset  else d0 a0 ) bclr then
c;
code 1bitset ( byte_addr. bit# -- )
  sp )+ d0 move
  sp )+ a0 lmove
  d0 a0 ) bset
c;
code 1bitclr ( byte_addr. bit# -- )
  sp )+ d0 move
  sp )+ a0 lmove
  d0 a0 ) bclr
c;
code nbitx! ( n byte_addr. bit# bitmask -- )
  sp )+ d0 move  ( d0 is bitmask )
  sp )+ d1 move  ( d1 is bit# )
  sp )+ a0 lmove
  sp )+ d2 move  ( d2 is n )
  d0 d2 andw
  d1 d2 lsl ( masked, shifted, n in d2 )
  d1 d0 lsl ( shifted mask in d0 )
  d0 not ( inverted mask in d0 )
  byte d0 a0 ) andw
       d2 a0 ) orw
  normal
c;
  
: nbit! ( n byte_addr. bit# #bits -- )
  bitmask nbitx!
;
: bit! ( n byte_addr. bit# #bits -- )
  dup 1 =
  if   drop 1bit!
  else nbit!
  then
;

