\ Convert block files to stream files.  Block files contain a
\ sequence of records each with c/l (64 usually) characters.
\ Each record is converted to a variable-length line terminated
\ by a newline character, without trailing blanks.
\ Upper case letters are converted to lower case.

variable bfile
variable ffile

: 1line ( -- flag )  \ False when end of block file
  pad c/l bfile @ fgets  ( #gotten)      \ Grab a record
  ?dup
  if    pad swap  -trailing  ( addr len) \ Strip trailing blanks
        2dup lower           ( addr len) \ Change to lower case
        ffile @ fputs        ( )         \ Write to output file
        newline ffile @ fputc            \ Add a newline
        true
  else false
  then
;
: (btof  ( block-name file-name -- )
  \ Create the output file
  dup  make  0=  if ." Can't make " count type  cr abort then
  \ And open it
  dup  write open
  ?dup if  ffile !  drop  else  ." Can't open " count type cr abort then
  \ Open the input file
  ( block-name )
  dup  read  open
  ?dup if  bfile !  drop  else  ." Can't open " count type cr abort then
  \ Process all the records
  begin  1line  while repeat
  ffile @ close
  bfile @ close
;
: btof ( -- ) ( Input Stream: block-file file-name )
  bl word pad "copy pad  bl word
  (btof
;
