decimal
create cload.f

variable cload-base

\ Move up to a longword boundary for the Sun loader, which
\ likes to align everything on a longword boundary
: lalign ( -- ) here 3 and negate 3 and  allot ;

\ Ought to set this to the current value of the break
\t16 th 3.0000 lconstant cload-base0
\t32 : cload-base0 here ;
0 cload-base !

struct  ( "exec" structure - a.out header )
  /l field a_magic
  /l field a_text
  /l field a_data
  /l field a_bss
  /l field a_syms
  /l field a_entry
  /l field a_trsize
  /l field a_drsize
constant /exec
create exec /exec allot

: /text  ( -- size-of-text-segment )   exec a_text @ ;
: /data  ( -- size-of-data-segment )   exec a_data @ ;
: /bss   ( -- size-of-bss-segment )    exec a_bss  @ ;
: /syms  ( -- size-of-symbol-table )   exec a_syms @ ;
: /reloc ( -- size-of-relocation )     exec a_trsize @  exec a_drsize @  + ;

: text0  ( -- file-address-of-text ) /exec ;
: data0  ( -- file-address-of-data ) text0 /text + ; 
: reloc0 ( -- file-address-of-relocation ) data0 /data + ; 
: syms0  ( -- file-address-of-symbols ) reloc0 /reloc + ; 
: string0 ( -- file-address-of-strings ) syms0 /syms + ; 

variable sym#
variable tf
: initsym 0 sym# ! ;
struct ( symbol table entry )
  /l field strx
  /c field sym_type
  /c field other
  /w field desc
  /l field value
constant /sym
: #syms  ( -- number-of-symbols )  /syms /sym / ;

create sym /sym allot
: getsym ( sym# -- )
  /sym *  syms0 + tf @ fseek  drop
  sym /sym tf @ fgets
  /sym <> if ." Couldn't get symbol" then
;
: moresyms?  sym# @ #syms < ;
: nextsym ( -- )
  sym# @  #syms >=  abort" No more symbols"
  sym# @ getsym
       1 sym# +!
;
: getsymname ( -- name )
  sym strx l@  ( index into string table )
  string0 +  tf @ fseek  drop
  pad  0  tf @  getcword
;

: .symname ( -- )
  getsymname count type
;
: .sym ( -- )
  .symname  getsymname count nip  ( name-length )  td 14 swap - spaces
  ." Type "  sym sym_type c@ u.
  ." Other " sym other    c@ u.
  ." Desc "  sym desc     w@ 5 u.r space
  ." Value " sym value    l@ 8 u.r
  cr
;
: opena.out ( name -- )
  read open
  ?dup 0= abort" Can't open file"
  tf !
  exec /exec tf @ fgets
  /exec <> abort" Can't read header"
  exec a_magic l@  th 107 <> if  ." Magic number is not (octal) 407" then
  initsym
;
nuser (fret
nuser (ret  ( depends on these 2 being allocated consequetively )
code ret ( -- last-function-return-value )
  'user# (ret   up d)  sp -) lmove
c;

: text-sym: ( -- )
  getsymname "create   sym value l@  l,
 ;code  w ) a0 lmove   a0 ) jsr
  d1  'user# (fret  up d)  lmove
  d0  'user# (ret   up d)  lmove
c;
: data-bss-sym: ( -- )
  getsymname "create   sym value l@  l,  ( basically a constant )
  ;code  w ) sp -) lmove
c;

: process-symbol ( -- )
  sym value l@   cload-base @  >=
  if    sym sym_type c@   5 =
        if   text-sym:
\             .symname space
        else sym sym_type c@ dup 7 = swap 9 = or
             if   data-bss-sym:
             else cr .symname space ." is not a recognizable symbol" abort
             then
        then
  then
;
: textload ( -- )
  text0  tf @ fseek drop
  \ FIXME Should sbrk here ( actually allot should do it )

  \ allocate the text segment and fill it from the file
  here                     ( text-start )
    /text allot            ( text-start )
       /text tf @  fgets
       /text <> abort" Can't load text segment"

  \ allocate the data segment and fill it from the file
  lalign here              ( data-start )
    /data allot            ( data-start )
       /data  tf @ fgets
       /data <> abort" Can't load data segment"

  \ allocate the bss segment and fill it with zeroes.
  lalign here              ( bss-start )
    /bss  allot            ( bss-start )
       /bss erase
;

: cload ( name -- )
  opena.out
  textload
  initsym
  begin moresyms?
  while nextsym  process-symbol
  repeat
\t16  /text /data /bss +  cload-base +!
  tf @ close
;
: .a.out ( name -- )
  opena.out
  initsym
  hex
  begin moresyms?
  while nextsym  .sym  
  repeat
  tf @ close
;
: :ccall ( addr name -- )
  "create   l,
  ;code  w ) a0 lmove   a0 ) jsr
  d1  'user# (fret  up d)  lmove
  d0  'user# (ret   up d)  lmove
c;

requires spawn.f

: f.out ( -- str ) [""] f.out ;
: n->str ( n -- hex-str)
  base @ hex
    swap n->l  <# #s #>  pad  place
  base !
  pad
;
: rename ( old-str new-str -- )
  argv-strings
  [""] mv  carg    swap carg   carg   [""] /bin/mv  spawn
  0= abort" Rename failed"
;
: base-syms ( -- str )
  cload-base @  0=
  if   \ [""] /usr/local/forth
       [""] forth
  else [""] f.out  [""] f.base  rename
       [""] f.base
  then
;
: clink ( object-file -- ) ( argument is name of object file)
  base-syms     \ Has to be done here so as not to clobber argv
  lalign
  cload-base0  cload-base !
  argv-strings
  [""] ld        carg
  [""] -A        carg
  ( symbol-file) carg
  [""] -T        carg
  ( convert cload-base to a string )
  cload-base @ n->str carg
  [""] -x        carg
  [""] -N        carg
  ( object file) carg
  [""] -o        carg
  [""] f.out     carg
  [""] -lm       carg
  [""] -lc       carg
  [""] /bin/ld   spawn
\  [""] /bin/echo   spawn
  0= abort" Link Failed"
  f.out  cload
;
