( From Perry/Laxen, with suitable modification for the Unix F83 )

\ Warning!!! This version has been superceded by a version that
\ decompiles conditionals.

\    A Forth decompiler is a utility program that translates
\ executable forth code back into source code.  Normally this is
\ impossible, since traditional compilers produce more object
\ code than source, but in Forth it is quite easy.  The decompiler
\ is almost one to one, failing only to correctly decompile the
\ various Forth control stuctures and special compiling words.
\ It was written with modifiability in mind, so if you add your
\ own special compiling words, it will be easy to change the
\ decompiler to include them.  This code is highly implementation
\ dependant, and will NOT work on other Forth system.  To invoke
\ the decompiler, use the word SEE <name> where <name> is the
\ name of a Forth word.

\ The "word type" is a number which distinguishes one type of word
\ from another.  For itc, it is the contents of the code field.
\ For dtc, it is the address of the code that is executed for that
\ word.  This code is reached by a  jsr instruction with a long absolute
\ address.
: word-type ( cfa -- word-type )
\dtc \t16 4 + ( skip jsr opcode and high word of address )
\dtc \t32 2 + ( skip jsr opcode )
  token@
;
: >is ( cfa -- data-address )
  dup word-type  ( cfa code-field-word )
  dup ['] #user word-type  = swap      ( user variable? )
  dup ['] key   word-type  = swap      ( deferred? )
  dup ['] forth word-type  = swap      ( vocabulary )
  drop or or
  if  >body >user  else  >body then
;
\ Positional case defining word                       28AUG83HHL
( Subscripts start FROM 0 )
: out   ( # apf -- ) ( report out of range error )
   cr  ." subscript out of range on "  dup body> >name
   .id  ."    max is " ?   ."    tried " .  quit   ;
: map  ( # apf -- a ) ( convert subscript # to address a )
   2dup @  u< if   na1+ swap na+   else   out  then   ;
: maptoken  ( # apf -- a ) ( convert subscript # to address a )
   2dup @  u< if   na1+ swap /token * +   else   out  then   ;

: case:   (s n --  ) ( define positional case defining word )
   constant  hide    ]
   does>   ( #subscript -- ) ( executes #'th word )
     maptoken  token@  execute   ;

\ associative:                table lookup def. word  01mar82hhl
: associative:
   constant
   does>         (s n -- index )
      dup @              ( n pfa cnt )
      -rot dup @ 0       ( cnt n pfa cnt 0 )
      do   na1+   2dup @ = ( cnt n pfa' bool )
         if 2drop drop   i 0 0   leave   then
            ( clear stack and return index that matched )
      loop   2drop
;
\ pf contains: n ( normal ) token, token, ...
: tassociative:
   constant
   does>         (s n -- index )
      dup @              ( n pfa cnt )
      dup >r -rot na1+        ( cnt n table-addr )
      r> 0                    ( cnt n table-addr cnt 0 )
      do   2dup token@ =          ( cnt n pfa' bool )
         if 2drop drop   i 0 0   leave   then
            ( clear stack and return index that matched )
         /token +
      loop   2drop
;

\ decompile each type of word                         02oct83map
defer (see
vocabulary hidden
hidden definitions
: probably-cfa? ( n -- f )
 ( Guess whether or not n is a cfa )
 ( if n is in the active dictionary, it is likely to be a cfa )
  dup  origin here  within  ( n f )
  ( but only if a name field precedes it, so check for a tag bit )
  if  dup 1- c@ 128 and   ( n f )
     ( and for the 68000, the number must be even! )
     if   1 and 0=
     else drop false  then
  else drop false
  then
;
: classify-literal ( n -- ) ( guess what kind of constant n is )
\  dup probably-cfa?
\  if   ." ['] " >name .id
\  else ( perhaps it is an ascii character? )
       dup printable?
       if   ." ascii " dup emit ."  ( " . ." ) "
       else . then
\  then
;
\ first check for word being immediate so that it may be preceded
\ by [compile] if necessary
: check-[compile] ( cfa -- cfa )
  dup immediate? if ." [compile] " then
;
: .word       (s ip -- ip' )
   dup token@ check-[compile] >name .id   /token +   ;
: .inline     (s ip -- ip' )
   ta1+ dup @  classify-literal  na1+   ;
: .llit       (s ip -- ip' )
   ta1+ dup l@ l. la1+  ;
: .branch     (s ip -- ip' )
   .word   dup <w@ .   wa1+   ;
: .quote      (s ip -- ip' )
   .word   .word   ;
: .string     (s ip -- ip' )
   .word   count 2dup type ascii " emit space  + even ;
: .[']   (s ip -- ip' )
   ta1+  ." ['] " dup token@ >name .id  ta1+ ;

\ decompile each type of word                         27aug83hhl
th 6100 constant does-op
: does?   (s ip -- ip' f )
   dup /w + /w + swap w@ does-op =  ;
: .(;code    (s ip -- ip' )
   .word   does? if  ." does> "  else  drop false  then  ;
: .unnest     (s ip -- ip' )
   ." ; "   drop   0   ;
: .finish     (s ip -- ip' )
   .word   drop   0   ;

\ classify each word in a definition                  23jun83hhl
18 tassociative: execution-class
   (  0 ) [compile]  (lit            (  1 ) [compile]  ?branch
   (  2 ) [compile]  branch          (  3 ) [compile]  (loop
   (  4 ) [compile]  (+loop          (  5 ) [compile]  (do
   (  6 ) [compile]  compile         (  7 ) [compile]  (."
   (  8 ) [compile]  (abort"         (  9 ) [compile]  (;code
   ( 10 ) [compile]  unnest          ( 11 ) [compile]  ("
   ( 12 ) [compile]  (?do            ( 13 ) [compile]  (;uses
   ( 14 ) [compile]  exit            ( 15 ) [compile]  ("lit
   ( 16 ) [compile]  (llit           ( 17 ) [compile]  ('

\ classify each word in a definition                  23jun83hhl
19 case: .execution-class
   (  0 )     .inline                (  1 )     .branch
   (  2 )     .branch                (  3 )     .branch
   (  4 )     .branch                (  6 )     .branch
   (  6 )     .quote                 (  7 )     .string
   (  8 )     .string                (  9 )     .(;code 
   ( 10 )     .unnest                ( 11 )     .string
   ( 12 )     .branch                ( 13 )     .finish
   ( 14 )     .unnest                ( 15 )     .string
   ( 16 )     .llit                  ( 17 )     .[']
  ( default ) .word
;

\ decompile a : definition                            15mar83map
: .pfa   (s cfa -- )
   >body   begin
      ?cr   dup token@ execution-class .execution-class
      dup 0= key? or   until   drop   ;
: .immediate   (s cfa -- )
   immediate? if   ." immediate"   then   ;

\ display category of word                            27sep83map
: .constant    (s cfa -- )
   dup >body ?   ." constant "   >name .id   ;
: .variable    (s cfa -- )
   dup >body .   ." variable "   dup >name .id
   ." value = " >body ?   ;
: .:           (s cfa -- )
   ." : "  dup >name .id 2 spaces  .pfa   ;
\ the wa1+ is used to skip the "bsr" instruction in the does clause
\ It is not needed in dtc because the dtc does> clause looks exactly
\ like a colon definition, so .pfa works directly.
: .does>       (s cfa -- )
   dup >name .id
   dup >body @ ." ( Parameter field: " . ." ) "
   ." does> "
   word-type      ( address-of-does-clause)
\itc     wa1+
  .pfa
;
: .user-variable   (s cfa -- )
   dup >body ?   ." user variable "   dup >name .id
   ." value = "   >is  ?   ;

\ display category of word                            11oct83hhl
: .defer   (s cfa -- )
   ." deferred " dup >name .id   ." is "  >is token@ (see   ;
: .user-defer   (s cfa -- )
   ." user deferred "   dup >name .id  ." is "  >is token@ (see   ;
: does? ( cfa -- f )  ( True if the cfa is for a does> word )
   word-type token@
   ['] forth word-type token@  =
   ( forth is an example of a create does> definition )
;
: code? ( cfa -- f ) ( True if the cfa is for a code word )
\itc   token@ over >body =    ( cfa points to the pfa in code words )
\dtc   w@ th 4eb9  ( jsr opcode ) <>
;
\ Given an ip, scan backwards until you find the cfa.  This assumes
\ that the ip is within a colon definition, and it is not absolutely
\ guaranteed to work, but in practice it nearly always does.
\ This is dependent on the alignment requirements of the machine.
\ For a byte-aligned machine, change the /w to a /c.
: find-cfa ( ip -- cfa)
   begin
      /w - dup token@ ( ip' token )
      ['] here token@ =  ( look for the cfa of a : defn )
   until  ( ip)
;
: .other   (s cfa -- )
   dup code? if   >name .id ." is code"   exit   then
   dup word-type find-cfa c.id  ( print name of definer )
   dup c.id                     ( print name of child )
   dup >body @ ." ( Parameter field: " . ." ) "
;

\ classify a word based on its cfa                    09sep83hhl
: cf, ( --name ) ( find the next word and compile its code field value )
  ' word-type token,
;
variable isvar
6 tassociative: definition-class
   ( 0 )   cf,   (quit  ( 1 )   cf,     0
   ( 2 )   cf,   isvar  ( 3 )   cf,  base 
   ( 4 )   cf,   key    ( 5 )   cf,  emit

7 case:   .definition-class
   ( 0 )     .:                  ( 1 )     .constant
   ( 2 )     .variable           ( 3 )     .user-variable
   ( 4 )     .defer              ( 5 )     .user-defer
   ( 6 )     .other      ;

\ top level of the decompiler see                     29sep83map
: ((see   (s cfa -- )
   ( cr )  dup dup word-type   definition-class .definition-class
   .immediate   ;   ' ((see  is (see 

forth definitions

: see   (s -- )
   '   (see     ;
