\ DVORAK makes the Sun keyboard a Dvorak keyboard (sans labels)
\ QWERTY turns it back into a qwerty keyboard
\ Defaults to sun2 keyboard.  To use with a klunker or a vt100 keyboard,
\ type KLUNKER or VT100 first, then subsequent QWERTY's or DVORAK's
\ will apply to that kind of terminal.  SUN2 will also explicitly work
\ for sun2 keyboards.

requires keyboard.f

decimal
: setkeyx ( ascii station -- )  ( tablemask must already be set )
  kio station c!
  kio kentry c!
  0 kio kstring c!
  dosetkey
;

: setrange ( start-station str -- )
  count bounds
  ?do  ( station )
      i c@ over setkeyx
      1+
  loop
  drop
;

\ Probably should do something about the control characters too.  What?

: dvorak
  openkeyboard

  0.  kio tablemask l!

  toprow  @ [""] ',.pyfgcrl  setrange
  homerow @ [""] aoeuidhtns  setrange
  botrow  @ [""] :qjkxbmwvz  setrange

  SHIFTMASK kio tablemask l!

  toprow  @ [""] ",.PYFGCRL  setrange
  homerow @ [""] AOEUIDHTNS  setrange
  botrow  @ [""] ;QJKXBMWVZ  setrange
  cfd @ u_close
;
: qwerty
  openkeyboard

  0.  kio tablemask l!

  toprow  @ [""] qwertyuiop  setrange
  homerow @ [""] asdfghjkl;  setrange
  botrow @  [""] zxcvbnm,./  setrange

  SHIFTMASK kio tablemask l!

  toprow @  [""] QWERTYUIOP  setrange
  homerow @ [""] ASDFGHJKL:  setrange
  botrow @  [""] ZXCVBNM<>?  setrange
  cfd @ u_close
;
: sun2
   54 toprow  !
   77 homerow !
  100 botrow  !
;
: klunker
   54 toprow  !
   77 homerow !
  101 botrow  !
;
: vt100
   40 toprow  !
   59 homerow !
   78 botrow  !
;
sun2
