\ To allow C routines to call Forth routines

create cregs 16 /l * allot
create fregs  td 16 /l* allot

\ We have to save UP and RP whenever we enter C code,
\ because if the C program calls Forth again, we must establish
\ the correct task and return stack
: make-c-entry ( ip-value #args -- )
[ assembler ]
   normal
   th fffe #  sp -)  movem
\   fregs l#)  th 7fff #  movem
    fregs l#)  th 4800 #  movem   \ Restore rp and up
   ( ip #args )
   dup ( ip #args #args )
   0
   ?do   ( cfa #args )
      dup /l* td 15 /l* +  ( offset of C arguments - 15 is # registers saved)
             sp d)  sp -) lmove
   loop
   drop  ( cfa )

\   illegal
   l# ip lmove
   next
;
\ We have to save UP and RP whenever we enter C code,
\ because if the C program calls Forth again, we must establish
\ the correct task and return stack
code 0vals
   th 4800 #  fregs l#) movem   \ UP and RP
   sp )+  th 7fff #  movem
   rts
end-code

code 1val
   th 4800 #  fregs l#) movem   \ UP and RP
   sp )+ sp ) lmove
   sp )+  th 7fff #  movem
   rts
end-code

: centry:  ( #args #returns cfa -- )  ( Input Stream:  Name )
  here -rot ( #args ip #returns cfa )
  token,    ( #arg ip #returns )
  dup 0 = if  compile 0vals then
  dup 1 = if  compile 1val  then
      1 > abort" Can't return more than 1 value"
  ( #args ip )
  create  
  swap make-c-entry
;
hex
