\ This file repeats the definitions of (next and dodoes.  This is necessary
\ because the assembler compiles a relative branch to (next and does>
\ compiles a relative branch-to-subroutine.  The range of relative branches
\ on the 68000 is only 32K bytes, so when the dictionary size gets over
\ 32K, the code for (next and for dodoes gets out of the range of the
\ branches.  A solution is to repeat the code for (next and dodoes somewhere
\ near the 32K point, and to fix next and does> to compile branches to the
\ new copies.  Does> and next are defined so that they get the addresses of
\ the (next and dodoes code from the variables nextaddr and dodoesaddr.

\ Load this file when the dictionary size approaches 32K.

only forth also assembler definitions
create (newnext
  word
      ip )+ w rmove
       w )+ a0 rmove   a0 ) jmp

(newnext nextaddr w!

only forth also definitions
create (newdodoes
assembler
  normal
  ip rp -) move   sp )+ ip lmove
   w sp -) move   next   hex
forth

(newdodoes dodoesaddr w!
