\ Interface words to a few selected Unix system calls.
\ Used by save-forth and save-stand for writing out an
\ image of the Forth system

td 8 base !
0644 constant default-mode
decimal

: u_open ( mode str --- fd )
  swap n->l nlswap cstr 8 syscall retval >r ldrop ldrop r>
;
: u_creat ( mode str --- fd )
  swap n->l nlswap cstr 12 syscall retval >r ldrop ldrop r>
;
: u_close ( fd --- )
  n->l 16 syscall ldrop
;
: u_read  ( n buf fd --- nread )
  >r >r n->l r> n->a r> n->l 20 syscall
  retval >r ldrop ldrop ldrop r>
;
: u_write  ( n buf fd --- nwritten )
  >r >r n->l r> n->a r> n->l 24 syscall
  retval >r ldrop ldrop ldrop r>
;
: u_ioctl ( addr l.command fd -- errf )  ( True if error occurred )
  >r l>r n->a lr> r> 28 syscall
  retval >r ldrop ldrop ldrop r>
;
: u_lseek ( whence l.byteno unix_fd --- d.byteno )
  >r l>r n->l lr> r> n->l  ( convert whence and unix_fd to longs )
  40 syscall lretval
  l>r ldrop ldrop ldrop lr> ( get rid of arguments )
;
