\ iterated interpretation                             27sep83map
\ times is used on a command line to repeat the line several times
\ E.g.   here . cr  10 times
\
\ Many is similar to times, but it repeats until a key is typed
\
\ Loops using times or many are much slower than compiled loops,
\ because the command line is re-interpreted every time through
\
\ When is used in a colon definition to repeatedly test a condition
\ and proceed when the condition becomes true.
\ E.g.  : waitforkey ( -- ) key? when ;
\ Restrictions:  the test for the condition must be a single word
\ !! when can't be used from the command line or the system will crash

variable #times   ( # times already performed )   1 #times !
: times   ( n -- )
   1 #times +!  #times @
   < if  1 #times !  else  >in off  then   ;
: many   (s -- )
   key? 0= if   >in off   then   ;
\ Suppose you do : bar foo when ;  This will continually to execute foo
\ until foo leaves a true flag.
\ This is kind of screwy.
\ : when   (s f -- )
\   pause
\   0= if   r> /token - /token - >r   then   ;
