\ Interface to 4.2 memory mapping facilities.
\ mmap and valloc are just as described in the Unix manual
\ mapin is a simplified interface.  It takes a physical address,
\ a size, and the name of the device, and returns a virtual address.
\ The size should be divisible by the page size.

: mmap ( phys fd 1 3 size virt -- errf ) ( 3 is RW, 1 is SHARED )
  60 syscall lretval l>r
  ldrop ldrop ldrop ldrop ldrop ldrop
  lr>
;
: valloc ( #bytes -- virt ) ( #bytes must be a multiple of the page size )
  56 syscall lretval nip
;
: mapin ( phys size devname -- virt )
  2 swap  u_open                ( size fd )
     dup  0<  abort" mapin: Can't open file"  ( phys size fd )
  over valloc                  ( phys size fd virt )
     dup  0=  abort" mapin: Can't get virtual memory"  ( phys size fd virt )
  >r swap >r 1 3   ( phys size 1 3 ) ( r: virt size )
  r> r@  ( phys fd 1 3 size virt )  mmap  ( errf )
  abort" mapin: mmap failed"
  r>
;
