\ Package for defining menus
only forth also hidden also forth definitions
10 stack: menu-stack
create temp-array  /token 2*  td 30 *  allot  ( space for 30 items)
variable #items
variable menu-dirty?
alias ta+ la+
: menu-start   #items off ;
: .item ( item-address -- next-item-address )
  dup token@ c.id  ta1+  td 20 to-column
  dup token@ count type ta1+
;
: item ( cfa string-addr -- )
  temp-array #items @ 2* ta+  ( cfa string table-entry )
  rot over token!
  ta1+ token!
  1 #items +!
;
: .menu ( pfa -- )
  menu-stack top@
  clear-screen
  dup @ swap na1+  ( #items array-start )
  ascii a rot bounds
  do   ( item-address )
       space i emit space  .item    cr
  loop
  drop
  menu-dirty? off
;
: make-table ( -- )
  #items @ ,  ( &#items )
  here  #items @ /token 2* * dup allot  ( new-table-address size )
  temp-array -rot cmove
;
: get-selection ( menu-pfa -- index )
  @  ( #items)
  begin   ( #items)
     #out @ if cr then
     ." Selection: " kill-to-eol-on-screen
     key  space ascii a -  2dup swap 0  swap  ( #items index  index 0 #items )
     within 0=
  while  (cr ." I don't recognize that selection. " drop
  repeat   ( #items index )
  nip
;
: execute-selection ( menu-pfa index -- )
  2* ta+
  ta1+  ( skip menu-start and menu-size fields )
  token@ execute
;
: to-execution-area ( -- )
  cr kill-to-eol-on-screen
;

: menu: ( -- )
  create
  make-table
  does> ( pf has menu-size, entry-table )
     menu-stack push
     menu-dirty? on
     begin
       menu-dirty? @ if .menu then
       menu-stack top@ dup get-selection  ( pfa index)
       to-execution-area
       execute-selection  ( ??)
       menu-stack top@ 0=
     until
     menu-stack pop drop
     menu-dirty? on
;

\ Example menu:

: fword ( -- )
  ." Forth code to execute: " query interpret
;

: up ( -- )   menu-stack pop drop  0 menu-stack push ;
: up-item ( -- ) ['] up    ["] Exit this menu"          item ;
: f-item ( -- )  ['] fword ["] Execute some forth code" item ;
: redisplay ( -- ) ['] .menu ["] Redisplay the menu"  item ;

: m" ( -- ) here ," ;

menu-start
 redisplay
 f-item
 up-item
 ' +     m" Add the top two stack items"         item
 ' -     m" Subtract the top two stack items"    item
 ' *     m" Multiply the top two stack items"    item
menu: arithmetic

menu-start
 redisplay
 f-item
 up-item
 ' .s         m" Print the stack"                     item
 ' dup        m" Duplicate the top of the stack"      item
 ' drop       m" Get rid of the top of the stack"     item
 ' swap       m" Exchange the top two stack elements" item
 ' arithmetic m" Perform arithmetic"                  item
menu: stack

sun
