\ Klaus Schliesiek's structured number input words
\ Useful for parsing custom number formats.

: <$ ( addr len --- sign end addr ud true )
  false -rot over + swap   -1 dpl !   0 0 true
;
: $  ( end addr ud1 f1 --- end addr+1 ud2 true  |  end ud1 false )
   drop 2 pick 2 pick u>
   if   over  c@  base @ digit
        if   swap base @ u* drop   rot base @ u*   l+
             rot 1+ -rot   dpl @ 1+ ?dup
             if   dpl ! then  true  exit
   then then false
;
: $s  ( end addr ud1 f1 --- end addr+1 ud2 true  |  end ud1 false )
   $ >r begin  true $ not until  r>
;
: $> ( sign end addr ud f --- d true | false )
  drop 2swap - if   2drop drop false exit then
  rot  if   lnegate then true
;
: required ( end addr ud f --- 0 addr ud false | end addr ud true )
  dup if   exit then 3 roll  drop 0  3 -roll
;
: (ascii? ( end addr ud f ch --- end addr+1 ud true | end addr ud false )
  >r drop 2 pick 2 pick u>  ( end addr ud f )
  2 pick c@ r> = and       ( addr ud f )
  if   rot 1+ -rot  true else false then
;
: ?dpl ( f -- f )
  dup if   0 dpl ! then
;
: ?sign    dup if   4 roll  1+  4 -roll then
;
: more?    3 pick   3 pick u> ;
: -sign?   ascii - (ascii? ?sign ;
: number? ( addr len - l true | false )
  <$                          ( sign end addr ud true )
  -sign? ascii . (ascii? ?dpl $ required
  begin $s more? while  ascii . (ascii? ?dpl required repeat
  $>
;
: nnum? ( addr len --- l true | false )
  <$  -sign?
  begin $s more? while ascii . (ascii? ?dpl required repeat
  $>
;
