\ Routine to open a file which resides in a directory specified
\ by a list of directories to look in.
\ The list of directories is an array of pointers to packed strings.
\ Each such string is a pathname in which to search for the file.
\ The end of the array is marked by a 0 pointer )

: open-with-prefix ( name prefix -- fp | 0 )
  pad  "copy  ( name )
  [""] / pad "cat ( name ) ( add a / to the path name)
  pad  "cat   ( append file name to path prefix )
  pad  read  open  ( fd | 0 )
;
: more-path-prefixes? ( path-list-pointer -- path-list-pointer f )
  dup @
;

: next-path-prefix ( list-of-paths -- next-item-in-list-of-paths )
  na1+
;
: path-open ( name list-of-paths -- fp | 0 )
  ( name is the address of a packed string )
  ( list-of-paths is the address of an array of pointers to packed strings )
  ( each such string is a pathname in which to search for the file )
  ( The end of the array is marked by a 0 pointer )
  ( Output is a file pointer for the found file, or 0 if none found )
  begin
     more-path-prefixes?    ( name list-of-paths f )
     if   2dup @ open-with-prefix  ( name list-of-paths [ fd | 0 ] )
          ?dup          ( name list-of-paths [ fd true  |  false ] )
     else  0 true  then ( name list-of-paths [ fd true  |  false ] )
  0= while
     next-path-prefix
  repeat   ( name list-of-paths [ fd  |  0 ] )
  nip nip  ( fd | 0 )
;
