\ Interpreter that can be used to poke around, so that the
\ stack state is not lost.  Start with "poke-around", end
\ with "done".

variable finished?
create new-tib td 100 allot

variable old-tib   variable old->in  variable old-state

: poke-around   (s -- ) 
   finished? off
   'tib @ old-tib !  ( Save the input buffer state)
   >in @  old->in !  ( Ditto)
   new-tib 'tib !   ( Move the terminal input buffer to a new place)
   state @ old-state !
   [compile] [      ( Make sure the state is interpreting, not compiling)
   begin 
      state @ 0= if  ." >> "  then  ( Different prompt )
      query                         ( Get the next line of input )
      interpret                     ( And handle everything on the line )
      finished? @
   until
   old-tib @ 'tib !
   old->in @ >in !
   old-state @ state !
;
: done finished? on ;
