\ Given a list of field separators, extract the next field from the string.

\ Returns the position of the first occurrenct of the character in the
\ string, or -1 if the character does not appear in the string.
: cindex ( char string -- index )
  -1 -rot
  count 0
  ?do  ( flag char base )
       2dup i + c@ = if  rot drop i -rot leave  then
  loop
  2drop
;

: -char ( addr len -- addr+1 len-1 )
  dup if 1- swap 1+ swap then
;

: scan-field ( addr len separators -- addr' len' actual-separator )
  >r
  begin  dup  while  ( addr' len' )
      over c@ r@  cindex
      0>=  if  r> drop  -char over 1- c@ exit  then
      -char
  repeat    ( addr' 0 )  \ No separator found
  r> drop -1
;
: skip-separators ( addr len separators -- addr' len' separators )
  >r
  begin  dup  while  ( addr' len' )
      over c@ r@  cindex
      0<  if  r> exit  then
      -char
  repeat    ( addr' 0 )  \ No separator found
  r>
;
variable separator
: next-field ( addr len separators -- addr' len' field-addr field-len )
  skip-separators  ( field-addr len separators)
  2 pick >r        ( field-addr len separators)
  scan-field       ( addr' len' actual-separator)
  separator !      ( addr' len' )
  r>               ( addr' len' field-addr)
  2 pick over -    ( addr' len' field-addr field-len+1)
  separator @ -1 <>
  if  1-  then
;
