\ For setting line characteristics (baud rates, parity, etc)
\ on Unix serial lines.  See tty(4) for a description of the
\ options available

create stty.f
\ associative:                table lookup defining word
: associative:
   constant
   does>         (s n -- index )
      dup @              ( n pfa cnt )
      -rot dup @ 0       ( cnt n pfa cnt 0 )
      do   na1+   2dup @ = ( cnt n pfa' bool )
         if 2drop drop   i 0 0   leave   then
            ( clear stack and return index that matched )
      loop   2drop
;

16 associative: >baud-magic
 0      , ( 0 )
 50     , ( 1 )
 75     , ( 2 )
 110    , ( 3 )
 134    , ( 4 )
 150    , ( 5 )
 200    , ( 6 )
 300    , ( 7 )
 600    , ( 8 )
 1200   , ( 9 )
 1800   , ( 10 )
 2400   , ( 11 )
 4800   , ( 12 )
 9600   , ( 13 )
 19200  , ( 14 )
 38400  , ( 15 )

\ Interesting values for flags.  There are lots of other possibilities
\ but these are the only ones that are likely to get used.  The rest
\ of the flags are defined in <sys/ioctl.h>

hex
00000002 constant CBREAK   \ half-cooked mode
00000008 constant ECHO     \ echo input
00000010 constant CRMOD    \ map \r to \r\n on output
00000020 constant RAW      \ no i/o processing
00000040 constant ODDP     \ get/send odd parity
00000080 constant EVENP    \ get/send even parity
000000c0 constant ANYP     \ get any parity/send none
decimal

th 80067409  constant STTY
th 40067408  constant GTTY

: char  /c field ;
: short /w field ;
struct ( sgttyb )
    char sg_ispeed
    char sg_ospeed
    char sg_erase
    char sg_kill
   short sg_flags
constant /sgttyb

create sgttyb /sgttyb allot

: stty ( buf unix-fd -- )
  STTY swap u_ioctl 0< abort" stty failed"
;
: gtty ( buf unix-fd -- )
  GTTY swap u_ioctl 0< abort" gtty failed"
;

: setbaud  ( baud unix-fd -- )
  >r >baud-magic
  sgttyb r@ gtty
  ( baud-magic ) dup sgttyb sg_ispeed c!  sgttyb sg_ospeed c!
  sgttyb r> stty
;
: setmode ( new-flags unix-fd -- )
  >r
  sgttyb r@ gtty
  ( flags ) sgttyb sg_flags w!
  sgttyb r> stty
;
