\ This code is preliminary.  It works but the interface is going to change.
\
\ Network interface code.  Uses the prom drivers to do the actual
\ sending and receiving of packets.

\ Generate the ones complement checksum of count 16-bit words
\ starting at addr.

32-bit
: oc-checksum ( addr count -- checksum)
  0 -rot   ( zero accumulator)
  bounds
  do   i  w@ +   ( current checksum)
       dup th 1.0000 u>=
       if   th 1.0000 - 1+ then    ( carries wrap around to the low bit)
  /w +loop
  not  th 0.ffff and
;

: struct 0 ;
variable active-struct

: sfield ( offset size -- new-offset )
  create over , +
  does> @ active-struct @ +
;
alias xc!  c!
alias xw!  w!
alias xl!  l!

struct ( ether-header )
  6 sfield en-dest-addr
  6 sfield en-source-addr
  2 sfield en-type
constant /ether-header

struct ( ip-header )
  1 sfield ip-version
  1 sfield ip-service
  2 sfield ip-length
  2 sfield ip-id
  2 sfield ip-fragment
  1 sfield ip-ttl
  1 sfield ip-protocol
  2 sfield ip-checksum
  4 sfield ip-source-addr
  4 sfield ip-dest-addr
constant /ip-header

struct ( udp-header )
  2 sfield udp-source-port
  2 sfield udp-dest-port
  2 sfield udp-length
  2 sfield udp-checksum
constant /udp-header

\ These things hardly ever change, so we make them variables

variable ttl   td 123 ttl !
variable ip-sequence
variable my-ip-addr
variable his-ip-addr
create my-en-addr  6 allot    my-en-addr  6  th ff  fill
create his-en-addr 6 allot    his-en-addr 6  th ff  fill
variable my-udp-port
variable his-udp-port
th 800 constant IP_TYPE
th 806 constant ARP_TYPE
td 17 constant UDP

variable total-length

: prepare-udp-packet ( data-addr data-len -- buffer total-len)
  even
  dup /udp-header +    ( data-len udp-len)
  dup /ip-header  +    ( data-len udp-len ip-len)
  dup /ether-header +  ( data-len udp-len ip-len ether-len)
  dup >r                  ( rs: total-len)
   get-buffer          ( data-len udp-len ip-len buffer)
  dup >r                  ( rs: total-len buffer )
  active-struct !      ( data-len udp-len ip-len)
    my-en-addr    en-source-addr  6 cmove
    his-en-addr   en-dest-addr    6 cmove
    IP_TYPE  en-type xw!
  /ether-header active-struct +!
    th 45    ip-version xc!    ( 45 is ip version 4, length 5 longwords )
    0        ip-service xc!
    ( ... ip-len) ip-length xw!
    ip-sequence @  ip-id    xw!    1 ip-sequence +!
    0        ip-fragment xw!
    ttl @    ip-ttl      xc!
    UDP      ip-protocol xc!
    0        ip-checksum xw!
    my-ip-addr  l@ ip-source-addr xl!
    his-ip-addr l@ ip-dest-addr   xl!
    active-struct @  /ip-header  oc-checksum   ip-checksum  xw!
  /ip-header active-struct +!
    my-udp-port  @  udp-source-port xw!
    his-udp-port @  udp-dest-port   xw!
    ( ... udp-len)  udp-length      xw!
    0 udp-checksum  xw!
  /udp-header active-struct @ +     ( data-addr data-len buffer-addr)
    swap cmove       ( )
    r> r>
;

\ Test with echo packets

decimal
create pi-ip-addr     192 c,  9 c,  1 c, 16 c,
create hwlab1-ip-addr 192 c,  9 c,  1 c, 41 c,
hex

struct ( arp-packet)
  2 sfield arp-hw       ( set to 1 for ethernet )
  2 sfield arp-protocol ( set to IP_TYPE )
  1 sfield arp-hwlen    ( set to 6 for ethernet )
  1 sfield arp-protolen ( set to 4 for IP )
  2 sfield arp-opcode   ( 1 for request, 2 for reply)
  6 sfield arp-sha      ( sender hardware address)
  4 sfield arp-spa      ( sender protocol address)
  6 sfield arp-tha      ( target hardware address)
  4 sfield arp-tpa      ( target protocol address)
constant /arp-packet

create arp-buf  
: send-arp-packet ( -- error? )
  /arp-packet /ether-header +  ( ether-len)
  dup >r                  ( rs: total-len)
   get-buffer          ( data-len udp-len ip-len buffer)
  dup >r                  ( rs: total-len buffer )
  active-struct !      ( )
    my-en-addr  en-source-addr  6 cmove
    broadcast-en-addr en-dest-addr    6 cmove
    ARP_TYPE  en-type xw!
  /ether-header active-struct +!
    1       arp-hw xw!
    IP_TYPE arp-protocol xw!
    6       arp-hwlen    xc!
    4       arp-protolen xc!
    1       arp-opcode   xw!
    my-en-addr        arp-sha 6 cmove
    my-ip-addr @      arp-spa xl!
    his-en-addr       arp-tha 6 cmove
    his-ip-addr @     arp-tpa xl!
    r> r> ec-send
;

create echo-buf 27 c, td 255 allot
: set-addresses ( -- )
  hwlab1-ip-addr @  my-ip-addr  !
  pi-ip-addr   @    his-ip-addr !
  test-id   my-en-addr  6 cmove
  his-en-addr 6  th ff fill
;

variable #echo td 256 #echo !

: send-echo-packet ( -- error? )
  1234  ip-sequence !
  7 his-udp-port !     ( Port for echo service)
  td 1234 my-udp-port  !
  echo-buf  #echo @  prepare-udp-packet ec-send
;
: decode-arp-packet ( addr len -- )
  drop                              \ We don't need the length
  dup active-struct !               \ Look at ether header structure
  en-type w@  ARP_TYPE <>  abort" Not ARP packet"  ( addr )
  /ether-header + active-struct !   \ Look at arp structure
  arp-sha  his-en-addr  6  cmove    \ grab his Ethernet address
;  
: do-arp ( -- )
  his-en-addr  w@  th ffff =
  if
    send-arp-packet
    if   ." ARP send failed" cr exit then
    filtered-receive
    if  ." Timeout waiting for ARP packet" cr  exit  then
    decode-arp-packet
    return-buffer
  then
;
: echo-init ( -- )
  ec-init
  set-addresses
  my-en-addr  set-addr
  receive-init
  do-arp
;
: echo ( -- )
  send-echo-packet
  if   ." X send" cr exit then
  filtered-receive
  if   ." X receive" cr exit then
  2drop return-buffer
;
: dump-echo ( -- )
  1 #echo !
  echo-buf c@
  td 27 echo-buf c!
  echo
  echo-buf c!
;
