\ Trivial File Transfer Protocol

: die (quit ;

decimal

1 constant RRQ
2 constant WRQ
3 constant DATA
4 constant ACK
5 constant ERROR


struct ( tftp packet )
2 sfield opcode
0 sfield block#
0 sfield filename
2 sfield errorcode
0 sfield errmsg
512 sfield data
constant /tftp-packet

variable sid    th 1234 sid !  ( "random" number )
variable did
variable this-block
variable #retries
10 constant max-retries

create packet-to-send  /tftp-packet allot
variable #packet

: .error ( -- )
  ." Got error packet: Error Code "
  errorcode w@ .  ." Message: "
  errmsg
  begin dup c@
  while dup c@ emit 1+
  repeat drop
;
: cstrput ( forth_string to-addr -- end-addr )
  2dup >r count r> swap  ( fstr toadd  faddr toadd len )
  cmove       ( fstr toadd )
  swap c@     ( toadd len )
  +  ( end-1 )
  0 over c!
  1+
;
: setup-read-request ( file-name-str -- )
  1 this-block !
  packet-to-send active-struct !
  1 sid +!
  69 did !
  RRQ opcode w!    ( file-name-str )
  filename cstrput ( mode-addr )
  [""] octet  swap cstrput   ( end-addr )
  packet-to-send  -  #packet !
;
: setup-ack-packet ( -- )
  packet-to-send  active-struct !
  ACK opcode w!
  this-block @  block#  w!
  4 #packet !
  1 this-block +!
;
variable dbuf
variable dlen
: check-data-packet ( [ buffer udp-packet-addr packet-len ] | 0 --
    ( ... -- [ buffer data-addr data-len ] | 0 )
  2dup dlen !  dbuf !
  dup 0=
  if  exit then
  drop  active-struct !

 \ Check source id.
  udp-dest-port w@   sid @ <>
  if ." Got packet addressed to wrong port"  die then

 \ Check destination id.  If it mismatches, error unless did is currently 69
  udp-source-port w@  did @ <>
  if    did @  69 =
        if  \ Lock on to his port
            udp-source-port w@  did !
        else ." Got packet from wrong source port" die
        then
  then
  udp-length w@  /udp-header -  4 -   ( data-length )

  /udp-header active-struct +!

 \ Check packet type
  opcode w@  ERROR =  if .error abort then
  opcode w@  DATA <>  if ." Got a non-data packet" die then

 \ Check block number
  block# w@  this-block @ =
  if  \ Packet is okay
       data swap
  else   ( buffer len )
       drop return-buffer 0
  then
;
: send-current-packet ( -- )
  1234 ip-sequence !
  did @ his-udp-port !
  sid @ my-udp-port !
  packet-to-send  #packet @ prepare-udp-packet ( addr len )
  0 -rot
  begin
    receive-init
    2dup ec-send  ( retry-count addr len error? )
  while
     rot 1+ dup 10 > if ." Send-current-packet failed 10 times" die then
     -rot
  repeat    ( retry-count addr len )
  2drop drop
;
: receive-udp-packet ( -- buffer udp-packet packet-len )
  filtered-receive   ( -- [ buffer addr len ] | 0 )
  if  false exit  then
        /ether-header -  /ip-header -
  swap  /ether-header +  /ip-header +  swap
;
: get-data-packet ( addr -- addr' more? )
  #retries off
  begin
     send-current-packet
     receive-udp-packet   ( addr  [ buffer udp-packet-addr packet-len ] | 0 )
     check-data-packet    ( addr  [ buffer data-addr data-len ] | 0 )
     ?dup 0=
  while
     1 #retries +!
     #retries @  max-retries > if ." receive failed" die then
  repeat               ( addr buffer data-addr data-len )
\ need to return buffer to pool
  >r 2 pick ( addr buffer data-addr addr )
  r@ cmove  ( addr buffer )
  return-buffer  ( addr )
  r@ +           ( addr' )
  r> 512 =       ( addr' more? )
;
: tftpwrite ( addr size file-name -- )
;
: tftpread ( addr file-name -- size )
  echo-init
  4000 timeout !
  setup-read-request   ( addr )
  dup                 ( addr addr )
  begin
     get-data-packet  ( addr addr' more? )
  while
     setup-ack-packet
  repeat              ( addr addr' )
 \ Send the final acknowledge
  setup-ack-packet
  send-current-packet
  swap -
;
