\ load source code from rom.  Each rom contains single bytes of a
\ word, but it is desireable to only have to burn one prom at a time
\ so the code is copied one byte at a time from addresses that differ by
\ two. By default, the code is loaded from rom 0, which is physically
\ located just above the "0/0" prom that contains the kernel.
\ Rom 1 may be loaded by typing "rom1 mload".  Rom 1 is to the left of
\ rom 0, and rom2 is above rom0.

hex
f0.8001 lconstant rom0addr
f0.8000 lconstant rom1addr
f0.9001 lconstant rom2addr
f0.9000 lconstant rom3addr

lvariable mload-addr

: rom0    rom0addr mload-addr l! ;
: rom1    rom1addr mload-addr l! ;
: rom2    rom2addr mload-addr l! ;
: rom3    rom3addr mload-addr l! ;
rom0

variable old-expect
variable old-?interactive
variable verbose?
: verbose true verbose? ! ;
: quiet false verbose? ! ;
quiet

: l+! ( l addr -- )
  >r r@ l@ l+ r> l!
;
: end-mload
  old-expect @ ['] expect (is
  old-?interactive @ ?interactive !
  rom0addr mload-addr l!       ( default mload address )
;

variable start-addr
variable max-len

: mexpect ( addr len -- )
  0 span !
  max-len !
  start-addr !
  begin
     span @  max-len @  <
  while
     mload-addr l@  c@l
     dup  control j  =  ( newline )
     if   drop
          span @ max-len ! ( set up to exit )
     else dup th ff = if
          drop  end-mload
          span @ max-len ! ( set up to exit )
     else start-addr @ span @  +   c!
          1 span +!
     then then
     2. mload-addr l+!
  repeat
;
: mload
  ?interactive @  old-?interactive !
  verbose? @ ?interactive !
  ['] expect       >is @  old-expect       !
  ['] mexpect ['] expect (is
  interpret
;

decimal
