\ Interface routines to connect the scdiag program
\ to the uarts running under Forth.
\ The scdiag routine uses an image of the "sunromvec"
\ structure located at 0x1000 to do its I/O.
\ The only romvec routines currently provided are
\ getchar and putchar.

th 1000. lconstant ROMVEC
th ef.8000 lconstant scdiag

create getchar  ( return-address -- ) ( Result left in d0 )
assembler
  d0 clr
  uarta l# a0 lmove
  begin
     byte  0 # a0 ) btst
  0<> until
  2 a0 d) d0 move
  long
rts
forth

create putchar  ( char return-address -- char )
assembler
  uarta l# a0 lmove
  begin
     byte  2 # a0 ) btst
  0<> until
  d0 2 a0 d) bmove
  long
rts
forth

code jsr  ( address -- )
  sp )+ a0 lmove
  a0 ) jsr
c;

: go
  getchar ROMVEC 14. l+ l!
  putchar ROMVEC 18. l+ l!
  scdiag jsr
;
