\ Common stand-alone code.  Requires the definition of several
\ machine-dependent words, which are defined in standio.*.f
\  ioinit     : initialize the serial i/o channel for key and emit
\  RAMbase    : leaves the 32-bit address of the start of RAM
\  RAMtop     : leaves the 32-bit address of the end of RAM
\  ROMbase    : leaves the 32-bit address of the start of ROM,
\               or wherever the kernel is upon cold boot
\  hwreset    : perform any necessary initialization of hardware
\               resources before doing anything else.  This must be
\               an assembly language routine which returns with
\               a6 ) jmp

hex

: stand-cold-hook
  ioinit
 ( catch level 7 interrupts, like abort key on Motorola VME board )
\  warm-code rel th 7c. l!l
  televideo
  emacs-edit
;

create standboot
assembler
   th 4dfa , 6 ,
\   6 pc d) a6 lea    ( return address )
   hwreset bra

 RAMtop  l# sp lmove
 RAMbase l# d7 lmove ( set new base address )
 ROMbase l# a0 lmove ( address of load point )
         d7 a1 lmove ( address of new location )

   .8000 l# d0 lmove ( no. of bytes to move )
  begin 
     a0 )+  a1 )+  bmove ( move a byte )
  d0 dbra    ( loop )

 ( now scrub the rest of the bank so there won't be parity errors )
    .8000 l# d0 lmove ( no. of bytes to move )
   0 d1 moveq
   begin
    ( can't use a clr instruction because it reads before writing )
       d1 a1 )+  bmove
   d0 dbra    ( loop )

  ROMbase 8 +  l#)  sp -) rmove  \ Address of end of initial user area

\ The stack now contains:
   ( IOvector  end-address )

\  Call the existing startup code

\ Relocation is not needed for the 32-bit token version, 
\ because it has absolute adresses for all its tokens anyway,
\ so it will only run at the same address where it runs under Unix.

\t16   cold-code  #  a0 rmove
\t32   cold-code l#  a0  move

   a0 ) jsr
forth

\ reset vector
\ location 0 contains the initial stack pointer
\ location 4 contains the initial pc

: patchboot ( --- )
 \ change the cold boot entry to contain the initial sp and pc
 \ Normally, location 0 contains "cold-boot bra" and location 4
 \ contains "warm-boot bra".  In the boot prom, though, these
 \ locations will be the initial sp and the initial pc used by the
 \ hardware reset handler.

  RAMtop origin l!     ( patch location 0 - the initial sp )
  standboot n->w w->l ROMbase l+  ( relocate to ROM bank )
  origin 4 + l!        ( patch location 4 - the initial pc )
      ( this location normally contains "warm-boot bra" )
;
decimal
