hex

\ Machine-dependent code for the Astraea 68000 VME CPU board

ff.e001 lconstant siomode
ff.e003 lconstant siocsr
ff.e005 lconstant siocr
ff.e007 lconstant siodata

: ioinit
  10 siocr   c!l  ( reset mode pointer )
  13 siomode c!l  ( 8 bits no parity )
  07 siomode c!l  ( 1 stop bit )
  bb siocsr  c!l  ( 9600 baud )
  05 siocr   c!l  ( enable Tx, enable Rx )
;
code stand-key?  ( --- f )
     byte
     siocsr l#)  d0  move
     0 # d0 btst            ( RxReady ? )
     word
     0=  if  sp -) clr  else  true # sp -) move  then
c;
code stand-key  ( --- f )
  byte
  begin
     siocsr l#)  d0  move
     0 # d0 btst                ( RxReady ? )
  0<> until
  word  d0 clr byte
  siodata l#) d0 move
  word
  th 7f #  d0 andw  ( strip parity for now )
  d0 sp -) move
c;
code stand-emit ( char -- )
  word sp )+ d1 move
  byte
  begin
     siocsr l#)  d0  move
     2 # d0 btst            ( TxReady ? )
  0<> until
  byte  d1 siodata l#) move
c;

40.0000 lconstant RAMbase
40.fff0 lconstant RAMtop
ff.0000 lconstant ROMbase

ff.d019 lconstant sysfaildata
ff.d009 lconstant sysfaildir

\ The sysfail bit in the system control port of the parallel port chip
\ has to be turned off before the VME memory board will respond

create hwreset
 assembler
\ Return address is in a6
 byte
  0 # sysfaildata l#) move ( 0 to sysfail data register bit ) ( sysfail off )
 10 # sysfaildir  l#) move ( output mode on that register )
\ Return
a6 ) jmp

forth
