hex
ee.c800 lconstant uartbase  ( model 50 )

th 01    constant   ZSRR0_RX_READY  ( received character available )
th 04    constant   ZSRR0_TX_READY  ( transmit buffer empty )

: uarta uartbase 4. l+ ;
: uartb uartbase ;

: uctl!    ( n uartx )  c!l ;
: uctl@    ( uartx --- n )  c@l ;

: udata!   ( n uartx --- )  2. l+ c!l ;
: udata@   ( uartx --- @ )  2. l+ c@l ;

\ version of constant for relative addresses
: rel-con ( addr -- )  ( later:  -- addr-in-new-bank )
  create w,  does> wa@
;

\ this version omits the symbolic names of the bits to reduce the space used
\ for storing their names
\ see inituarts.f for the symbolic definitions of all these magic numbers

create uart-init-table
9 c, c0 c,    4 c, 46 c,    3 c, c0 c,    5 c, e2 c,
9 c,  2 c,    b c, 55 c,    c c,  e c,    d c,  0 c,
e c,  2 c,    3 c, c1 c,    5 c, ea c,    e c,  3 c,
0 c, 10 c,    0 c, 10 c,
here rel-con uart-init-table-end

\ Write all the assorted initialization commands to both
\ halves of the UART chip.

: inituarts
  uart-init-table-end  uart-init-table
  do
     i c@  uarta uctl!  i /c + c@ uarta uctl!
     i c@  uartb uctl!  i /c + c@ uartb uctl!
  /c 2* +loop
;
lvariable talking-to  uarta talking-to l!
hex
: ?rx talking-to l@ uctl@ ZSRR0_RX_READY and ;
: ?tx talking-to l@ uctl@ ZSRR0_TX_READY and ;
: stand-key  begin ?rx until   talking-to l@ udata@ ;
: stand-emit begin ?tx until   talking-to l@ udata! ;
: stand-key? ?rx 0<> ;
: usea
  uarta talking-to l! 
  inituarts
;
: useb
  uartb talking-to l!
  inituarts
;

: ioinit
  usea
;

ec.0000 lconstant RAMbase
ec.fff0 lconstant RAMtop
ef.0000 lconstant ROMbase

hex
0000 constant INIT-CX

create hwreset
assembler
\ Return address is in a6

\ Initialize the Memory Mapping for a stand-alone system
\ This is only needed if the Forth system is to be burned
\ into PROM.  If the Forth system is booted by the Sun PROM monitor,
\ all this has already been taken care of.
 word
 FC_MAP l#) a1 lea                      ( Get function code in a reg )
        4e7b ,  9000 , ( movc   a1,sfc  ( Set source function code )
        4e7b ,  9001 , ( movc   a1,dfc  ( Set destination function code )

 INIT-CX  # d0 move
 CX_ADDR l# a0 move
        0e50 ,  0800 , ( movsw  d0,a0@  ( Set up context register )

long        
\ set all segment entries to 0xff
    .00ff l# d0 move
   0.0005 l# a0 lmove
 100.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )
      8000. l# a0 adda
   repeat

\ Set up the first 6 Megs worth of segment entries
    .0000 l# d0 move
   0.0005 l# a0 lmove
  60.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )
     8000. l# a0 adda
     1 d0 addq
   repeat

\ Set up the top 2 Megs worth of segment entries
    .00c0 l# d0 move
  e0.0005 l# a0 lmove
 100.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )
     8000. l# a0 adda
     1 d0 addq
   repeat

\ Fix the funny INVALID_PMEG entry

    .00ff l# d0 move
  ea.8000 l# a0 lmove
       0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )

    .00d5 l# d0 move
  ff.8000 l# a0 lmove
       0e10 ,  0800 , ( movsb  d0,a0@  ( Write segment map entry )

\ report

   0.0001 l# d0 move
 LED_ADDR l# a0 move
         0e10 ,  0800 , ( movsb  d0,a0@  ( Write diagnostic register entry )

\ Clear out all the page map entries

  8000.0000 l# d0 lmove
     0.0000 l# a0 lmove
   100.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
   repeat

\ Map in 6 Megs of on-board memory

  fe00.0000 l# d0 lmove
     0.0000 l# a0 lmove
    60.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
     1 d0 addq
   repeat

\ Map in 64 K of Bus IO space

  ecc0.0fe0 l# d0 lmove
    eb.0000 l# a0 lmove
    ec.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
     1 d0 addq
   repeat

\ Map in 128 K of Video Memory - with execute permission

  fe40.0000 l# d0 lmove
    ec.0000 l# a0 lmove
    ee.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
     1 d0 addq
   repeat

\ Map in 64 K of PROM Space

  fe40.0fe0 l# d0 lmove
    ef.0000 l# a0 lmove
    f0.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
   repeat
\ Don't increment the page number because all of the PROM space
\ uses just one page.  All the PROM address lines are connected
\ to CPU address lines, and the page map bits just select the PROM chip

\ Map in 1 Meg of Bus memory space

  fe80.0000 l# d0 lmove
    f0.0000 l# a0 lmove
   100.0000 l# a1 lmove
   begin  a0 a1 cmpa  u>
   while
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )
     800. l# a0 adda
     1 d0 addq
   repeat

\ Timer

\  ee40.0fe5 l# d0 lmove
    ee.0000 l# a0 lmove
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )

\ DES
\
\  ec40.0fe2 l# d0 lmove
\    ee.1800 l# a0 lmove
\       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )

\ Ether

  ec40.0fe1 l# d0 lmove
    ee.3000 l# a0 lmove
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )

\ Keyboard/Mouse

  ec40.0fe3 l# d0 lmove
    ee.c000 l# a0 lmove
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )

\ Serial Port 0

  ec40.0fe4 l# d0 lmove
    ee.c800 l# a0 lmove
       0e90 ,  0800 , ( movsl  d0,a0@  ( Write page map entry )

\ Get out of boot state

      80. l# d0 lmove
 ENABLE_ADDR l# a0 lmove
        0e10 ,  0800 , ( movsb  d0,a0@  ( Write enable register )

\ report

   0.0008 l# d0 move
 LED_ADDR l# a0 move
         0e10 ,  0800 , ( movsb  d0,a0@  ( Write diagnostic register entry )

\ Return
a6 ) jmp

forth
