\ Long looping words.  Useful for a 16-bit Forth running on a machine
\ with a large address space.

' branch >body constant bran1

code (lloop
  long
  1 rp ) addq   bran1 bvc   ( increment counter and branch if not done )
  word /l 3 * rp d) rp lea  ( done; remove loop params from stack )
  /w ip addq                ( skip the branch offset )
c;
code (l+loop
  long
  sp )+ d0 move   d0 rp ) add   bran1 bvc
  word /l 3 * rp d) rp lea
  /w ip addq
c;
code (ldo  (s l i -- ) ( f83 )
  long
  sp )+ d0 move   sp )+ d1 move
     ( -- r: loop-end-offset l+0x8000 i-l-0x8000 )
  ip rp -) move  ( save the do offset address )
  /w ip addq     ( skip the do offset )
  long  th 8000.0000 l# d1 add
  d1 rp -) move   d1 d0 sub    d0 rp -) move
c;
code (l?do  (s l i -- ) ( f83 )
  long
  sp )+ d0 move   sp )+ d1 move  d0 d1 cmp
  bran1 beq
     ( -- r: loop-end-offset l+0x8000 i-l-0x8000 )
  ip rp -) move  ( save the do offset address )
  /w ip addq     ( skip the do offset )
  long  th 8000.0000 l# d1 add
  d1 rp -) move   d1 d0 sub    d0 rp -) move
c;
code li  (s -- n )
  long
  rp ) d0 move   /l rp d) d0 add  d0 sp -) move
c;
code lj   (s -- n )
  long
  /l 3 * rp d) d0 move
  /l 4 * rp d) d0 add
  d0 sp -) move
c;
code (lleave  (s -- )
  long
  /l 2* rp addq    ( get rid of the loop indices )
  rp )+ ip move   word ip ) ip adda long  
c;
code (l?leave  (s f -- )
  sp )+ tst
  long
  0<> if
     /l 2* rp addq    ( get rid of the loop indices )
     rp )+ ip move   word ip ) ip adda long
  then
c;

: lleave   compile (lleave                           ; immediate
: l?leave  compile (l?leave                          ; immediate
: ldo      compile (ldo    ?>mark                    ; immediate
: l?do     compile (l?do   ?>mark                    ; immediate
: lloop
    compile (lloop   2dup 2+ ?<resolve ?>resolve    ; immediate
: l+loop
    compile (l+loop  2dup 2+ ?<resolve ?>resolve    ; immediate
