decimal

\ sys@ takes an offset into the monitor ROM vector and returns
\ the 32-bit address stored in that ROM vector location.
\ For instance, the long stored at offset decimal 16 of the ROM vector is
\ the address of the echo flag, so 0  16 sys@ d!1  would turn off echoing

: sys@ ( offset --- daddr )
  s->l syscall-vec l@ l+ l@l
;
: getline ( echo --- )
  [ 28 /l * ] literal syscall ldrop
;
: linebuf ( --- daddr )
  [ 25 /l * ] literal sys@
;
: linesize ( --- cnt )
  [ 27 /l * ] literal sys@ l@l l->n
;
: getstring ( addr len --- cnt )
  1. ( echo on ) getline >r >r
  linebuf  ( mon_line_buf )
  r> n->a  ( mon_line_buf our_line_buf )
  r> linesize min s->l ( mon_.. our_.. minsize )
  cmovel
  linesize
;
: stand-expect ( addr len --- )
  2dup getstring ( addr len cnt )
  dup span !
  rot + 0 swap c! ( terminate with a null ) ( len )
  drop 
;
variable pushback-char  -1 pushback-char !
: stand-key?  ( -- f )
  pushback-char @ -1 <>
  if   true
  else
     [ 7 /l * ] literal syscall retval  -1 over =
     ( do this because the monitor returns -1 if no characters )
     if   1+ ( return 0 for false)
     else pushback-char ! true
     then
  then
;
: stand-key  ( -- char )  ( version which allows background tasks to run )
  pushback-char @ -1 <>
  if   pushback-char @  -1 pushback-char !
  else
    begin [ 7 /l * ] literal syscall retval dup -1 =  ( -1 true | char false )
    while drop pause
    repeat  ( char )
  then
;
: stand-emit  ( char -- )
  [ 6 /l * ] literal syscall drop
;
: stand-bye  ( -- )
  [ 49 /l * ] literal syscall drop
;
: stand-prompt
  ?interactive @  if .ok then
;
: yesecho ( -- ) ( turn on echoing ) 
  -1 [ 9 /l * ] literal sys@  c!l
;
: noecho ( -- ) ( turn off echoing )
  0 [ 9 /l * ] literal sys@  c!l
;
: stand-cold-hook ( -- )
  stand-cold-hook
  ['] stand-bye    ['] bye    (is
  ['] stand-expect ['] expect (is

\ stand-key, stand-key?, and stand-emit will be installed by the common
\ code in save-stand.f

\ Clobber cold boot entry with noops.
\t32  th 4e71  origin w!   th 4e71 origin 2 + w!
\ Put an absolute jump at the warm boot entry point
\t32  th 4ef9  origin 4 + w! ( l#( jmp opcode )
\t32  warm-code origin 6 + l!  ( warm-code address)
;
