\ Stand-alone boot code suitable for running Forth under the
\ Sun ROM monitor

hex
origin lconstant RAMbase
4.0000 lconstant RAMtop
RAMtop RAMbase l- lconstant RAMsize
 .4000 lconstant ROMbase
( 20.0000 lconstant ROMvec ( Sun 1 )
ef.0000 lconstant ROMvec ( Sun 2 )


create standboot
assembler
 RAMtop  l# sp lmove
 RAMbase l# d7 lmove ( set new base address )
 ROMbase l# a0 lmove ( address of load point )
         d7 a1 lmove ( address of new location )

\ Copy the dictionary image to its execution address
   long
   RAMsize l# a0 adda
   RAMsize l# a1 adda
   begin  a1 d7 cmp  u<
   while  a0 -) a1 -) lmove
   repeat

  ROMvec l#  sp -) lmove   ( push address of ROM I/O vector )
  
  ROMbase 8 +  l#)  sp -) amove

\ The stack now contains:
   ( IOvector  end-address )

\  Call the existing startup code
\t16   cold-code # a0 rmove
\ Relocation is not needed, because the 32-bit token
\ version has absolute adresses for all its tokens anyway, so it
\ will only run at the same address where it runs under Unix.
\t32   cold-code l#  a0  move
   a0 ) jsr
forth

: patchboot ( --- )
 ( change the cold boot entry to point to the new boot code )
\t16  standboot   2 -    origin 2+ w!
\t32  th 4ef9  origin w! ( l#( jmp opcode )
\t32  standboot origin - ROMbase +  origin 2+ l!
 ( the 2 - is because the branch offset is relative to location 2 )
 ( For t16, location 0 contains "bra xxxx", the xxx offset being at loc 2 )
 ( For t32, location 0 contains "standboot l#( jmp" )
;
