load exceptions.f
load callfinder.f

exception: no-file

: open-file ( file-name -- fd )
  read open ?dup
  0= if no-file raise then
;
: open-input-file ( file-name -- fd | 0 )
   no-file catch?
   if   ." File " count type ."  was not found" cr  false
   else dup open-file  ( file-name fd )
        nip
   then
;

exception: bad-number

: get-number ( -- l )        ( Raises bad-number exception if error )
  query
  bl word number?
  0= if  bad-number raise  then
;
 \ Prints a message and raises bad-number exception if error
: verbose-get-number ( -- l )
  bad-number catch?
  if   ." The number contained non-numeric characters" cr
       bad-number uncatch
       bad-number raise
  then 
  get-number
;
: check-number ( n -- n )
  dup 1 and
  if  ." The number was not even" cr
      bad-number raise
  then
;
: get-even-number ( -- )
  bad-number catch?
  if   ." Try again: "
  else ." Enter a number: "
  then
  verbose-get-number check-number
  .
;
